"""
openDAQ python bindings
"""
from __future__ import annotations
import numpy
import typing
__all__ = ['AddressInfo', 'AddressInfoBuilder', 'AddressInfoFromBuilder', 'AddressReachabilityStatus', 'AndSearchFilter', 'AnySearchFilter', 'ArgumentInfo', 'AuthenticationProvider', 'BaseObject', 'BasicFileLoggerSink', 'BlockReader', 'BlockReaderBuilder', 'BlockReaderFromExisting', 'BlockReaderStatus', 'BoolProperty', 'BoolPropertyBuilder', 'Boolean', 'Buffer', 'CallableInfo', 'Client', 'CmdLineArgsConfigProvider', 'Coercer', 'ComplexNumber', 'Component', 'ComponentStatusContainer', 'ConnectedClientInfo', 'ConnectedClientInfoWithParams', 'Connection', 'ConstantDataRule', 'Context', 'CoreEventArgs', 'CoreEventArgsPropertyAdded', 'CoreEventArgsPropertyObjectUpdateEnd', 'CoreEventArgsPropertyRemoved', 'CoreEventArgsPropertyValueChanged', 'CoreEventArgsTypeAdded', 'CoreEventArgsTypeRemoved', 'CoreType', 'CustomSearchFilter', 'DataDescriptorBuilder', 'DataDescriptorBuilderFromExisting', 'DataDescriptorChangedEventPacket', 'DataDescriptorFromBuilder', 'DataPacket', 'DataPacketWithDomain', 'DataRule', 'DataRuleBuilder', 'DataRuleBuilderFromExisting', 'DataRuleFromBuilder', 'DataRuleType', 'DeviceDomain', 'DeviceInfoConfig', 'DeviceInfoConfigWithCustomSdkVersion', 'DeviceType', 'Dict', 'DictProperty', 'DictPropertyBuilder', 'Dimension', 'DimensionBuilder', 'DimensionBuilderFromExisting', 'DimensionFromBuilder', 'DimensionRule', 'DimensionRuleBuilder', 'DimensionRuleBuilderFromExisting', 'DimensionRuleFromBuilder', 'DimensionRuleType', 'Enumeration', 'EnumerationProperty', 'EnumerationPropertyBuilder', 'EnumerationType', 'EnumerationTypeWithValues', 'EnumerationWithType', 'EnvConfigProvider', 'EvalValue', 'EvalValueArgs', 'EvalValueFunc', 'Event', 'EventArgs', 'EventHandler', 'EventPacket', 'ExcludedTagsSearchFilter', 'ExplicitDataRule', 'ExplicitDomainDataRule', 'Float', 'FloatProperty', 'FloatPropertyBuilder', 'Folder', 'FolderWithItemType', 'Function', 'FunctionBlockType', 'FunctionProperty', 'FunctionPropertyBuilder', 'IAddressInfo', 'IAddressInfoBuilder', 'IArgumentInfo', 'IAuthenticationProvider', 'IAwaitable', 'IBaseObject', 'IBlockReader', 'IBlockReaderBuilder', 'IBlockReaderStatus', 'IBoolean', 'ICallableInfo', 'IChannel', 'ICoercer', 'IComplexNumber', 'IComponent', 'IComponentPrivate', 'IComponentStatusContainer', 'IComponentStatusContainerPrivate', 'IComponentType', 'IConfigProvider', 'IConnectedClientInfo', 'IConnection', 'IConnectionStatusContainerPrivate', 'IContext', 'ICoreEventArgs', 'IDataDescriptor', 'IDataDescriptorBuilder', 'IDataPacket', 'IDataRule', 'IDataRuleBuilder', 'IDevice', 'IDeviceDomain', 'IDeviceInfo', 'IDeviceInfoConfig', 'IDeviceNetworkConfig', 'IDevicePrivate', 'IDeviceType', 'IDict', 'IDimension', 'IDimensionBuilder', 'IDimensionRule', 'IDimensionRuleBuilder', 'IDiscoveryServer', 'IEnumeration', 'IEnumerationType', 'IEvalValue', 'IEvent', 'IEventArgs', 'IEventHandler', 'IEventPacket', 'IFloat', 'IFolder', 'IFolderConfig', 'IFunction', 'IFunctionBlock', 'IFunctionBlockType', 'IGraphVisualization', 'IInputPort', 'IInputPortConfig', 'IInputPortNotifications', 'IInstance', 'IInstanceBuilder', 'IInteger', 'IIterable', 'IIterator', 'IList', 'ILogFileInfo', 'ILogFileInfoBuilder', 'ILogger', 'ILoggerComponent', 'ILoggerSink', 'ILoggerThreadPool', 'IMirroredDevice', 'IMirroredDeviceConfig', 'IMirroredSignalConfig', 'IMirroredSignalPrivate', 'IModule', 'IModuleInfo', 'IModuleManager', 'IMultiReader', 'IMultiReaderBuilder', 'IMultiReaderStatus', 'INetworkInterface', 'INumber', 'IOwnable', 'IPacket', 'IPacketDestructCallback', 'IPacketReader', 'IPermissionManager', 'IPermissionMaskBuilder', 'IPermissions', 'IPermissionsBuilder', 'IProcedure', 'IProperty', 'IPropertyBuilder', 'IPropertyObject', 'IPropertyObjectClass', 'IPropertyObjectClassBuilder', 'IPropertyObjectProtected', 'IPropertyValueEventArgs', 'IRange', 'IRatio', 'IReader', 'IReaderStatus', 'IReferenceDomainInfo', 'IReferenceDomainInfoBuilder', 'IRemovable', 'ISampleReader', 'IScaling', 'IScalingBuilder', 'IScheduler', 'ISearchFilter', 'IServer', 'IServerCapability', 'IServerType', 'ISignal', 'ISignalConfig', 'ISignalEvents', 'ISimpleType', 'IStreamReader', 'IStreamReaderBuilder', 'IStreaming', 'IStreamingType', 'IString', 'IStruct', 'IStructBuilder', 'IStructType', 'ISubscriptionEventArgs', 'ISyncComponent', 'ISyncComponentPrivate', 'ITags', 'ITagsPrivate', 'ITailReader', 'ITailReaderBuilder', 'ITailReaderStatus', 'ITask', 'ITaskGraph', 'IType', 'ITypeManager', 'IUnit', 'IUnitBuilder', 'IUpdateParameters', 'IUser', 'IValidator', 'IVersionInfo', 'ImplicitDomainGapDetectedEventPacket', 'InputPort', 'Instance', 'InstanceBuilder', 'InstanceFromBuilder', 'IntProperty', 'IntPropertyBuilder', 'Integer', 'InterfaceIdSearchFilter', 'IoFolder', 'JsonConfigProvider', 'JsonFileAuthenticationProvider', 'JsonStringAuthenticationProvider', 'LinearDataRule', 'LinearDimensionRule', 'LinearScaling', 'List', 'ListDimensionRule', 'ListProperty', 'ListPropertyBuilder', 'LocalIdSearchFilter', 'LogFileInfoBuilder', 'LogFileInfoFromBuilder', 'LogLevel', 'LogarithmicDimensionRule', 'Logger', 'LoggerComponent', 'LoggerThreadPool', 'MdnsDiscoveryServer', 'MockSignal', 'ModuleInfo', 'ModuleManager', 'ModuleManagerMultiplePaths', 'MultiReader', 'MultiReaderBuilder', 'MultiReaderFromExisting', 'MultiReaderStatus', 'NetworkInterface', 'NotSearchFilter', 'NullContext', 'ObjectProperty', 'ObjectPropertyBuilder', 'OperationModeType', 'OrSearchFilter', 'PacketReader', 'PacketReaderFromPort', 'PacketReadyNotification', 'PacketType', 'Permission', 'PermissionManager', 'PermissionMaskBuilder', 'PermissionMaskBuilderFromMask', 'PermissionsBuilder', 'Procedure', 'PropertyBuilder', 'PropertyEventType', 'PropertyObject', 'PropertyObjectClassBuilder', 'PropertyObjectClassBuilderWithManager', 'PropertyObjectClassFromBuilder', 'PropertyObjectWithClassAndManager', 'PropertyValueEventArgs', 'ProtocolType', 'Range', 'Ratio', 'RatioProperty', 'RatioPropertyBuilder', 'ReadMode', 'ReadStatus', 'ReadTimeoutType', 'ReaderStatus', 'RecursiveSearchFilter', 'ReferenceDomainInfoBuilder', 'ReferenceDomainInfoBuilderFromExisting', 'ReferenceDomainInfoFromBuilder', 'ReferenceProperty', 'ReferencePropertyBuilder', 'RequiredTagsSearchFilter', 'RotatingFileLoggerSink', 'SampleType', 'ScaledSampleType', 'Scaling', 'ScalingBuilder', 'ScalingBuilderFromExisting', 'ScalingFromBuilder', 'ScalingType', 'Scheduler', 'SelectionProperty', 'SelectionPropertyBuilder', 'ServerType', 'Signal', 'SignalWithDescriptor', 'SimpleType', 'SparseSelectionProperty', 'SparseSelectionPropertyBuilder', 'StaticAuthenticationProvider', 'StdErrLoggerSink', 'StdOutLoggerSink', 'StreamReader', 'StreamReaderBuilder', 'StreamReaderFromExisting', 'StreamingType', 'String', 'StringProperty', 'StringPropertyBuilder', 'Struct', 'StructBuilder', 'StructBuilderFromStruct', 'StructFromBuilder', 'StructProperty', 'StructPropertyBuilder', 'StructType', 'StructTypeNoDefaults', 'SubscriptionEventArgs', 'SubscriptionEventType', 'SyncComponent', 'Tags', 'TailReader', 'TailReaderBuilder', 'TailReaderFromExisting', 'TailReaderStatus', 'Task', 'TaskGraph', 'TimeBlockReader', 'TimeMultiReader', 'TimeSource', 'TimeStreamReader', 'TimeTailReader', 'TypeManager', 'Unit', 'UnitBuilder', 'UnitBuilderFromExisting', 'UpdateParameters', 'User', 'UsesOffset', 'Validator', 'VersionInfo', 'VisibleSearchFilter', 'clear_error_info', 'get_tracked_object_count', 'print_tracked_objects']
class AddressReachabilityStatus:
    """
    Members:
    
      Unknown
    
      Reachable
    
      Unreachable
    """
    Reachable: typing.ClassVar[AddressReachabilityStatus]  # value = <AddressReachabilityStatus.Reachable: 1>
    Unknown: typing.ClassVar[AddressReachabilityStatus]  # value = <AddressReachabilityStatus.Unknown: 0>
    Unreachable: typing.ClassVar[AddressReachabilityStatus]  # value = <AddressReachabilityStatus.Unreachable: 2>
    __members__: typing.ClassVar[dict[str, AddressReachabilityStatus]]  # value = {'Unknown': <AddressReachabilityStatus.Unknown: 0>, 'Reachable': <AddressReachabilityStatus.Reachable: 1>, 'Unreachable': <AddressReachabilityStatus.Unreachable: 2>}
    def __eq__(self, other: typing.Any) -> bool:
        ...
    def __getstate__(self) -> int:
        ...
    def __hash__(self) -> int:
        ...
    def __index__(self) -> int:
        ...
    def __init__(self, value: int) -> None:
        ...
    def __int__(self) -> int:
        ...
    def __ne__(self, other: typing.Any) -> bool:
        ...
    def __repr__(self) -> str:
        ...
    def __setstate__(self, state: int) -> None:
        ...
    def __str__(self) -> str:
        ...
    @property
    def name(self) -> str:
        ...
    @property
    def value(self) -> int:
        ...
class Buffer:
    def __init__(self: typing_extensions.Buffer, arg0: ..., arg1: capsule, arg2: int) -> None:
        ...
class CoreType:
    """
    Members:
    
      ctBool
    
      ctInt
    
      ctFloat
    
      ctString
    
      ctList
    
      ctDict
    
      ctRatio
    
      ctProc
    
      ctObject
    
      ctBinaryData
    
      ctFunc
    
      ctComplexNumber
    
      ctStruct
    
      ctEnumeration
    
      ctUndefined
    """
    __members__: typing.ClassVar[dict[str, CoreType]]  # value = {'ctBool': <CoreType.ctBool: 0>, 'ctInt': <CoreType.ctInt: 1>, 'ctFloat': <CoreType.ctFloat: 2>, 'ctString': <CoreType.ctString: 3>, 'ctList': <CoreType.ctList: 4>, 'ctDict': <CoreType.ctDict: 5>, 'ctRatio': <CoreType.ctRatio: 6>, 'ctProc': <CoreType.ctProc: 7>, 'ctObject': <CoreType.ctObject: 8>, 'ctBinaryData': <CoreType.ctBinaryData: 9>, 'ctFunc': <CoreType.ctFunc: 10>, 'ctComplexNumber': <CoreType.ctComplexNumber: 11>, 'ctStruct': <CoreType.ctStruct: 12>, 'ctEnumeration': <CoreType.ctEnumeration: 13>, 'ctUndefined': <CoreType.ctUndefined: 65535>}
    ctBinaryData: typing.ClassVar[CoreType]  # value = <CoreType.ctBinaryData: 9>
    ctBool: typing.ClassVar[CoreType]  # value = <CoreType.ctBool: 0>
    ctComplexNumber: typing.ClassVar[CoreType]  # value = <CoreType.ctComplexNumber: 11>
    ctDict: typing.ClassVar[CoreType]  # value = <CoreType.ctDict: 5>
    ctEnumeration: typing.ClassVar[CoreType]  # value = <CoreType.ctEnumeration: 13>
    ctFloat: typing.ClassVar[CoreType]  # value = <CoreType.ctFloat: 2>
    ctFunc: typing.ClassVar[CoreType]  # value = <CoreType.ctFunc: 10>
    ctInt: typing.ClassVar[CoreType]  # value = <CoreType.ctInt: 1>
    ctList: typing.ClassVar[CoreType]  # value = <CoreType.ctList: 4>
    ctObject: typing.ClassVar[CoreType]  # value = <CoreType.ctObject: 8>
    ctProc: typing.ClassVar[CoreType]  # value = <CoreType.ctProc: 7>
    ctRatio: typing.ClassVar[CoreType]  # value = <CoreType.ctRatio: 6>
    ctString: typing.ClassVar[CoreType]  # value = <CoreType.ctString: 3>
    ctStruct: typing.ClassVar[CoreType]  # value = <CoreType.ctStruct: 12>
    ctUndefined: typing.ClassVar[CoreType]  # value = <CoreType.ctUndefined: 65535>
    def __eq__(self, other: typing.Any) -> bool:
        ...
    def __getstate__(self) -> int:
        ...
    def __hash__(self) -> int:
        ...
    def __index__(self) -> int:
        ...
    def __init__(self, value: int) -> None:
        ...
    def __int__(self) -> int:
        ...
    def __ne__(self, other: typing.Any) -> bool:
        ...
    def __repr__(self) -> str:
        ...
    def __setstate__(self, state: int) -> None:
        ...
    def __str__(self) -> str:
        ...
    @property
    def name(self) -> str:
        ...
    @property
    def value(self) -> int:
        ...
class DataRuleType:
    """
    Members:
    
      Other
    
      Linear
    
      Constant
    
      Explicit
    """
    Constant: typing.ClassVar[DataRuleType]  # value = <DataRuleType.Constant: 2>
    Explicit: typing.ClassVar[DataRuleType]  # value = <DataRuleType.Explicit: 3>
    Linear: typing.ClassVar[DataRuleType]  # value = <DataRuleType.Linear: 1>
    Other: typing.ClassVar[DataRuleType]  # value = <DataRuleType.Other: 0>
    __members__: typing.ClassVar[dict[str, DataRuleType]]  # value = {'Other': <DataRuleType.Other: 0>, 'Linear': <DataRuleType.Linear: 1>, 'Constant': <DataRuleType.Constant: 2>, 'Explicit': <DataRuleType.Explicit: 3>}
    def __eq__(self, other: typing.Any) -> bool:
        ...
    def __getstate__(self) -> int:
        ...
    def __hash__(self) -> int:
        ...
    def __index__(self) -> int:
        ...
    def __init__(self, value: int) -> None:
        ...
    def __int__(self) -> int:
        ...
    def __ne__(self, other: typing.Any) -> bool:
        ...
    def __repr__(self) -> str:
        ...
    def __setstate__(self, state: int) -> None:
        ...
    def __str__(self) -> str:
        ...
    @property
    def name(self) -> str:
        ...
    @property
    def value(self) -> int:
        ...
class DimensionRuleType:
    """
    Members:
    
      Other
    
      Linear
    
      Logarithmic
    
      List
    """
    Linear: typing.ClassVar[DimensionRuleType]  # value = <DimensionRuleType.Linear: 1>
    List: typing.ClassVar[DimensionRuleType]  # value = <DimensionRuleType.List: 3>
    Logarithmic: typing.ClassVar[DimensionRuleType]  # value = <DimensionRuleType.Logarithmic: 2>
    Other: typing.ClassVar[DimensionRuleType]  # value = <DimensionRuleType.Other: 0>
    __members__: typing.ClassVar[dict[str, DimensionRuleType]]  # value = {'Other': <DimensionRuleType.Other: 0>, 'Linear': <DimensionRuleType.Linear: 1>, 'Logarithmic': <DimensionRuleType.Logarithmic: 2>, 'List': <DimensionRuleType.List: 3>}
    def __eq__(self, other: typing.Any) -> bool:
        ...
    def __getstate__(self) -> int:
        ...
    def __hash__(self) -> int:
        ...
    def __index__(self) -> int:
        ...
    def __init__(self, value: int) -> None:
        ...
    def __int__(self) -> int:
        ...
    def __ne__(self, other: typing.Any) -> bool:
        ...
    def __repr__(self) -> str:
        ...
    def __setstate__(self, state: int) -> None:
        ...
    def __str__(self) -> str:
        ...
    @property
    def name(self) -> str:
        ...
    @property
    def value(self) -> int:
        ...
class IAddressInfo(IPropertyObject):
    """
    """
    @staticmethod
    def can_cast_from(arg0: IBaseObject) -> bool:
        ...
    @staticmethod
    def cast_from(arg0: IBaseObject) -> IAddressInfo:
        ...
    @staticmethod
    def convert_from(arg0: IBaseObject) -> IAddressInfo:
        ...
    @property
    def address(self) -> str:
        """
        Gets the server address as a string.
        """
    @property
    def connection_string(self) -> str:
        """
        Gets the connection string corresponding to the address.
        """
    @property
    def reachability_status(self) -> AddressReachabilityStatus:
        """
        Gets the reachability status of the address.
        """
    @property
    def type(self) -> str:
        """
        Gets the type of the address.
        """
class IAddressInfoBuilder(IBaseObject):
    """
    """
    @staticmethod
    def can_cast_from(arg0: IBaseObject) -> bool:
        ...
    @staticmethod
    def cast_from(arg0: IBaseObject) -> IAddressInfoBuilder:
        ...
    @staticmethod
    def convert_from(arg0: IBaseObject) -> IAddressInfoBuilder:
        ...
    def build(self) -> IAddressInfo:
        """
        Builds the address.
        """
    @property
    def address(self) -> str:
        """
        Gets the server address as a string. / Sets the server address as a string.
        """
    @address.setter
    def address(self, arg1: IString | str | IEvalValue) -> None:
        ...
    @property
    def connection_string(self) -> str:
        """
        Gets the connection string corresponding to the address. / Sets the connection string corresponding to the address.
        """
    @connection_string.setter
    def connection_string(self, arg1: IString | str | IEvalValue) -> None:
        ...
    @property
    def reachability_status(self) -> AddressReachabilityStatus:
        """
        Gets the reachability status of the address. / Sets the reachability status of the address.
        """
    @reachability_status.setter
    def reachability_status(self, arg1: AddressReachabilityStatus) -> None:
        ...
    @property
    def type(self) -> str:
        """
        Gets the type of the address. / Sets the type of the address.
        """
    @type.setter
    def type(self, arg1: IString | str | IEvalValue) -> None:
        ...
class IArgumentInfo(IBaseObject):
    """
    Provides the name and type of a single function/procedure argument
    """
    @staticmethod
    def can_cast_from(arg0: IBaseObject) -> bool:
        ...
    @staticmethod
    def cast_from(arg0: IBaseObject) -> IArgumentInfo:
        ...
    @staticmethod
    def convert_from(arg0: IBaseObject) -> IArgumentInfo:
        ...
    @property
    def name(self) -> str:
        """
        Gets the name of the argument.
        """
    @property
    def type(self) -> CoreType:
        """
        Gets the core type of the argument.
        """
class IAuthenticationProvider(IBaseObject):
    """
    A class which is responsible for authenticating a user. The authentication is usually done by verifying the username and password. An authenticator implementation might use external services for achieving that. It might make a call to an external databse, do a lookup to a json file with defined users or it might simply check the password against a hardcoded one.
    """
    @staticmethod
    def can_cast_from(arg0: IBaseObject) -> bool:
        ...
    @staticmethod
    def cast_from(arg0: IBaseObject) -> IAuthenticationProvider:
        ...
    @staticmethod
    def convert_from(arg0: IBaseObject) -> IAuthenticationProvider:
        ...
    def authenticate(self, username: IString | str | IEvalValue, password: IString | str | IEvalValue) -> IUser:
        """
        Authenticate user using username and password. If authentication is successful, a User instance is returned. Otherwise an exception is thrown.
        """
    def authenticate_anonymous(self) -> IUser:
        """
        Authenticate as anonymous user. If anonymous authentication is not allowed, an exception is thrown.
        """
    def find_user(self, username: IString | str | IEvalValue) -> IUser:
        """
        Find a user instance by its username. If no user with maching username is not found, null is returned.
        """
    @property
    def anonymous_allowed(self) -> int:
        """
        Returns true if anonymous authentication is allowed. When anonymous authentication is enabled, user can connect to the server without providing username or password.
        """
class IAwaitable(IBaseObject):
    """
    """
    @staticmethod
    def can_cast_from(arg0: IBaseObject) -> bool:
        ...
    @staticmethod
    def cast_from(arg0: IBaseObject) -> IAwaitable:
        ...
    @staticmethod
    def convert_from(arg0: IBaseObject) -> IAwaitable:
        ...
    def cancel(self) -> int:
        """
        Cancels the outstanding work if it has not already started.
        """
    def has_completed(self) -> int:
        """
        Checks if the execution has already finished.
        """
    def wait(self) -> None:
        ...
    @property
    def result(self) -> typing.Any:
        """
        Waits until the awaitable has a valid result and retrieves it or re-throws the exception that occurred during the execution.
        """
class IBaseObject:
    """
    Extends `IUnknown` by providing additional methods for borrowing interfaces, hashing, and equality comparison. All openDAQ objects implement `IBaseObject` interface or its descendants. Hashing and equality comparison provides the ability to use the object as an element in dictionaries and lists. Classes that implement any interface derived from `IBaseObject` should be derived from `ImplementationOf` class, which provides the default implementation of `IBaseObject` interface methods.
    """
    @staticmethod
    def can_cast_from(arg0: IBaseObject) -> bool:
        ...
    @staticmethod
    def cast_from(arg0: IBaseObject) -> IBaseObject:
        ...
    def __eq__(self, arg0: typing.Any) -> bool:
        ...
    def __float__(self) -> float:
        ...
    def __hash__(self) -> int:
        ...
    def __init__(self, arg0: IBaseObject) -> None:
        ...
    def __int__(self) -> int:
        ...
    def __str__(self) -> str:
        ...
    @property
    def core_type(self) -> CoreType:
        ...
class IBlockReader(ISampleReader):
    """
    A signal data reader that abstracts away reading of signal packets by keeping an internal read-position and automatically advances it on subsequent reads. The difference to a StreamReader is that instead of reading on per sample basis it always returns only a full block of samples. This means that even if more samples are available they will not be read until there is enough of them to fill at least one block.
    """
    @staticmethod
    def can_cast_from(arg0: IBaseObject) -> bool:
        ...
    @staticmethod
    def cast_from(arg0: IBaseObject) -> IBlockReader:
        ...
    @staticmethod
    def convert_from(arg0: IBaseObject) -> IBlockReader:
        ...
    def read(self, count: int, timeout_ms: int = 0, return_status: bool = False) -> numpy.ndarray | tuple[numpy.ndarray, IBlockReaderStatus]:
        """
        Copies at maximum the next `count` blocks of unread samples to the values buffer.The amount actually read is returned through the `count` parameter
        """
    def read_with_domain(self, count: int, timeout_ms: int = 0, return_status: bool = False) -> tuple[numpy.ndarray, numpy.ndarray] | tuple[numpy.ndarray, numpy.ndarray, IBlockReaderStatus]:
        """
        Copies at maximum the next `count` blocks of unread samples and clock-stamps to the `dataBlocks` and `domainBlocks` buffers.The amount actually read is returned through the `count` parameter.
        """
    @property
    def block_size(self) -> int:
        """
        The amount of samples the reader considers as one block.
        """
class IBlockReaderBuilder(IBaseObject):
    """
    Builder component of Block reader objects. Contains setter methods to configure the Block reader parameters and a `build` method that builds the Unit object.
    """
    @staticmethod
    def can_cast_from(arg0: IBaseObject) -> bool:
        ...
    @staticmethod
    def cast_from(arg0: IBaseObject) -> IBlockReaderBuilder:
        ...
    @staticmethod
    def convert_from(arg0: IBaseObject) -> IBlockReaderBuilder:
        ...
    def build(self) -> IBlockReader:
        """
        Builds and returns a Block reader object using the currently set values of the Builder.
        """
    @property
    def block_size(self) -> int:
        """
        Gets the block size / Sets the block size
        """
    @block_size.setter
    def block_size(self, arg1: int) -> None:
        ...
    @property
    def domain_read_type(self) -> SampleType:
        """
        Gets the domain signal read type / Sets the domain signal read type
        """
    @domain_read_type.setter
    def domain_read_type(self, arg1: SampleType) -> None:
        ...
    @property
    def input_port(self) -> IInputPort:
        """
        Gets the input port / Sets the input port to block reader
        """
    @input_port.setter
    def input_port(self, arg1: IInputPort) -> None:
        ...
    @property
    def old_block_reader(self) -> IBlockReader:
        """
        Gets the old Block reader instance to copy from / Sets old block reader instance to copy from
        """
    @old_block_reader.setter
    def old_block_reader(self, arg1: IBlockReader) -> None:
        ...
    @property
    def overlap(self) -> int:
        """
        Gets the overlap / Sets the overlap
        """
    @overlap.setter
    def overlap(self, arg1: int) -> None:
        ...
    @property
    def read_mode(self) -> ReadMode:
        """
        Gets the read mode (Unscaled, Scaled, RawValue) / Sets the read mode (Unscaled, Scaled, RawValue)
        """
    @read_mode.setter
    def read_mode(self, arg1: ReadMode) -> None:
        ...
    @property
    def signal(self) -> ISignal:
        """
        Gets the signal / Sets the signal to block reader
        """
    @signal.setter
    def signal(self, arg1: ISignal) -> None:
        ...
    @property
    def skip_events(self) -> int:
        """
        Gets the skip events / Sets the skip events
        """
    @skip_events.setter
    def skip_events(self, arg1: bool) -> None:
        ...
    @property
    def value_read_type(self) -> SampleType:
        """
        Gets the value signal read type / Sets the value signal read type
        """
    @value_read_type.setter
    def value_read_type(self, arg1: SampleType) -> None:
        ...
class IBlockReaderStatus(IReaderStatus):
    """
    IBlockReaderStatus inherits from IReaderStatus to expand information returned read function
    """
    @staticmethod
    def can_cast_from(arg0: IBaseObject) -> bool:
        ...
    @staticmethod
    def cast_from(arg0: IBaseObject) -> IBlockReaderStatus:
        ...
    @staticmethod
    def convert_from(arg0: IBaseObject) -> IBlockReaderStatus:
        ...
    @property
    def read_samples(self) -> int:
        """
        Returns the number of samples that were read. Sometimes, during the process of reading, an event packet may occur that stops the reading of remaining samples. Developers can use this function to determine how many samples were actually read.
        """
class IBoolean(IBaseObject):
    """
    Represents boolean variable as `IBoolean` interface. Use this interface to wrap boolean variable when you need to add the variable to lists, dictionaries and other containers which accept `IBaseObject` interface.
    """
    @staticmethod
    def can_cast_from(arg0: IBaseObject) -> bool:
        ...
    @staticmethod
    def cast_from(arg0: IBaseObject) -> IBoolean:
        ...
    @staticmethod
    def convert_from(arg0: IBaseObject) -> IBoolean:
        ...
    def __bool__(self) -> bool:
        ...
    @property
    def value(self) -> bool:
        """
        Gets a boolean value stored in the object.
        """
class ICallableInfo(IBaseObject):
    """
    Provides information about the argument count and types, as well as the return type of Function/Procedure-type properties.
    """
    @staticmethod
    def can_cast_from(arg0: IBaseObject) -> bool:
        ...
    @staticmethod
    def cast_from(arg0: IBaseObject) -> ICallableInfo:
        ...
    @staticmethod
    def convert_from(arg0: IBaseObject) -> ICallableInfo:
        ...
    @property
    def arguments(self) -> IList:
        """
        Gets the list of arguments the callable function/procedure expects.
        """
    @property
    def const(self) -> int:
        """
        A flag indicating if function is marked as const. A const function promises not to modify the state of the device or any other objects under the openDAQ instance.
        """
    @property
    def return_type(self) -> CoreType:
        """
        Gets the return type of the callable function.
        """
class IChannel(IFunctionBlock):
    """
    Channels represent physical sensors of openDAQ devices. Internally they are standard function blocks with an additional option to provide a list of tags.
    """
    @staticmethod
    def can_cast_from(arg0: IBaseObject) -> bool:
        ...
    @staticmethod
    def cast_from(arg0: IBaseObject) -> IChannel:
        ...
    @staticmethod
    def convert_from(arg0: IBaseObject) -> IChannel:
        ...
class ICoercer(IBaseObject):
    """
    Used by openDAQ properties to coerce a value to match the restrictions imposed by the Property.
    """
    @staticmethod
    def can_cast_from(arg0: IBaseObject) -> bool:
        ...
    @staticmethod
    def cast_from(arg0: IBaseObject) -> ICoercer:
        ...
    @staticmethod
    def convert_from(arg0: IBaseObject) -> ICoercer:
        ...
    def coerce(self, prop_obj: typing.Any, value: typing.Any) -> typing.Any:
        """
        Coerces `value` to match the coercion restrictions and outputs the result.
        """
    def coerce_no_lock(self, prop_obj: typing.Any, value: typing.Any) -> typing.Any:
        ...
    @property
    def eval(self) -> str:
        """
        Gets the string expression used when creating the coercer.
        """
class IComplexNumber(IBaseObject):
    """
    Represents a complex number as `IComplexNumber` interface. Use this interface to wrap complex number when you need to add the number to lists, dictionaries and other containers which accept `IBaseObject` and derived interfaces. Complex numbers have two components: real and imaginary. Both of them are of Float type.
    """
    @staticmethod
    def can_cast_from(arg0: IBaseObject) -> bool:
        ...
    @staticmethod
    def cast_from(arg0: IBaseObject) -> IComplexNumber:
        ...
    @staticmethod
    def convert_from(arg0: IBaseObject) -> IComplexNumber:
        ...
    def __complex__(self) -> complex:
        ...
    def equals_value(self, value: ...) -> bool:
        """
        Compares stored complex value to the complex number parameter.
        """
    @property
    def imaginary(self) -> float:
        """
        Gets the imaginary part of the complex number value.
        """
    @property
    def real(self) -> float:
        """
        Gets the real part of the complex number value.
        """
    @property
    def value(self) -> complex:
        """
        Gets a complex value stored in the object.
        """
class IComponent(IPropertyObject):
    """
    Acts as a base interface for components, such as device, function block, channel and signal.
    """
    @staticmethod
    def can_cast_from(arg0: IBaseObject) -> bool:
        ...
    @staticmethod
    def cast_from(arg0: IBaseObject) -> IComponent:
        ...
    @staticmethod
    def convert_from(arg0: IBaseObject) -> IComponent:
        ...
    def find_component(self, id: IString | str | IEvalValue) -> IComponent:
        """
        Finds the component (signal/device/function block) with the specified (global) id.
        """
    @property
    def active(self) -> int:
        """
        Returns true if the component is active; false otherwise. / Sets the component to be either active or inactive. Also recursively sets the `active` field of all child components if component is a folder.
        """
    @active.setter
    def active(self, arg1: bool) -> None:
        ...
    @property
    def context(self) -> IContext:
        """
        Gets the context object.
        """
    @property
    def description(self) -> str:
        """
        Gets the description of the component. / Sets the description of the component.
        """
    @description.setter
    def description(self, arg1: IString | str | IEvalValue) -> None:
        ...
    @property
    def global_id(self) -> str:
        """
        Gets the global ID of the component.
        """
    @property
    def local_id(self) -> str:
        """
        Gets the local ID of the component.
        """
    @property
    def locked_attributes(self) -> IList:
        """
        Gets a list of the component's locked attributes. The locked attributes cannot be modified via their respective setters.
        """
    @property
    def name(self) -> str:
        """
        Gets the name of the component. / Sets the name of the component.
        """
    @name.setter
    def name(self, arg1: IString | str | IEvalValue) -> None:
        ...
    @property
    def on_component_core_event(self) -> IEvent:
        """
        Gets the Core Event object that triggers whenever a change to this component happens within the openDAQ core structure.
        """
    @property
    def parent(self) -> IComponent:
        """
        Gets the parent of the component.
        """
    @property
    def status_container(self) -> IComponentStatusContainer:
        """
        Gets the container of Component statuses.
        """
    @property
    def tags(self) -> ITags:
        """
        Gets the tags of the component.
        """
    @property
    def visible(self) -> int:
        """
        Gets `visible` metadata state of the component / Sets `visible` attribute state of the component
        """
    @visible.setter
    def visible(self, arg1: bool) -> None:
        ...
class IComponentPrivate(IBaseObject):
    """
    Provides access to private methods of the component.
    """
    @staticmethod
    def can_cast_from(arg0: IBaseObject) -> bool:
        ...
    @staticmethod
    def cast_from(arg0: IBaseObject) -> IComponentPrivate:
        ...
    @staticmethod
    def convert_from(arg0: IBaseObject) -> IComponentPrivate:
        ...
    def lock_all_attributes(self) -> None:
        """
        Locks all attributes of the component.
        """
    def lock_attributes(self, attributes: IList | list | IEvalValue) -> None:
        """
        Locks the attributes contained in the provided list.
        """
    def trigger_component_core_event(self, args: ICoreEventArgs) -> None:
        """
        Triggers the component-specific core event with the provided arguments.
        """
    def unlock_all_attributes(self) -> None:
        """
        Unlocks all attributes of the component.
        """
    def unlock_attributes(self, attributes: IList | list | IEvalValue) -> None:
        """
        Unlocks the attributes contained in the provided list.
        """
    def update_operation_mode(self, mode_type: OperationModeType) -> None:
        """
        Notifies component about the change of the operation mode.
        """
class IComponentStatusContainer(IBaseObject):
    """
    A container of Component Statuses and their corresponding values.
    """
    @staticmethod
    def can_cast_from(arg0: IBaseObject) -> bool:
        ...
    @staticmethod
    def cast_from(arg0: IBaseObject) -> IComponentStatusContainer:
        ...
    @staticmethod
    def convert_from(arg0: IBaseObject) -> IComponentStatusContainer:
        ...
    def get_status(self, name: IString | str | IEvalValue) -> IEnumeration:
        """
        Gets the current value of Component status with a given name.
        """
    def get_status_message(self, name: IString | str | IEvalValue) -> str:
        """
        Gets the status message of Component status with a given name.
        """
    @property
    def statuses(self) -> IDict:
        """
        Gets the current values of all Component statuses.
        """
class IComponentStatusContainerPrivate(IBaseObject):
    """
    Provides access to private methods of the Component status container.
    """
    @staticmethod
    def can_cast_from(arg0: IBaseObject) -> bool:
        ...
    @staticmethod
    def cast_from(arg0: IBaseObject) -> IComponentStatusContainerPrivate:
        ...
    @staticmethod
    def convert_from(arg0: IBaseObject) -> IComponentStatusContainerPrivate:
        ...
    def add_status(self, name: IString | str | IEvalValue, initial_value: IEnumeration) -> None:
        """
        Adds the new status with given name and initial value.
        """
    def add_status_with_message(self, name: IString | str | IEvalValue, initial_value: IEnumeration, message: IString | str | IEvalValue) -> None:
        """
        Adds the new status with given name, initial value, and message.
        """
    def set_status(self, name: IString | str | IEvalValue, value: IEnumeration) -> None:
        """
        Sets the value for the existing component status.
        """
    def set_status_with_message(self, name: IString | str | IEvalValue, value: IEnumeration, message: IString | str | IEvalValue) -> None:
        """
        Sets the value for the existing component status with a message.
        """
class IComponentType(IBaseObject):
    """
    Provides information about the component types.
    """
    @staticmethod
    def can_cast_from(arg0: IBaseObject) -> bool:
        ...
    @staticmethod
    def cast_from(arg0: IBaseObject) -> IComponentType:
        ...
    @staticmethod
    def convert_from(arg0: IBaseObject) -> IComponentType:
        ...
    def create_default_config(self) -> IPropertyObject:
        """
        The function clones and returns default configuration. On each call, we need to create new object, because we want that each instance of the component has its own configuration object.
        """
    @property
    def description(self) -> str:
        """
        Gets the description of a component type.
        """
    @property
    def id(self) -> str:
        """
        Gets the unique component type id.
        """
    @property
    def module_info(self) -> IModuleInfo:
        """
        Retrieves the module information.
        """
    @property
    def name(self) -> str:
        """
        Gets the user-friendly name of a component type.
        """
class IConfigProvider(IBaseObject):
    """
    Config provider is an interface that was made for populating an options dictionary of an instance builder from external sources like a config file, environment variables, or command line arguments. The process of population of the dictionary have to be alligned with rules: - all keys are set in lowercase. Values are set without case changes. - if a provider is trying to override an existing value, it has to have the same type. For example provider can not replace integer value with string or object with list - if a provider is overriding a list, it replaces old list items with a new one.
    """
    @staticmethod
    def can_cast_from(arg0: IBaseObject) -> bool:
        ...
    @staticmethod
    def cast_from(arg0: IBaseObject) -> IConfigProvider:
        ...
    @staticmethod
    def convert_from(arg0: IBaseObject) -> IConfigProvider:
        ...
    def populate_options(self, options: IDict | dict) -> None:
        """
        Populate the existing options dictionary with variables from config provider
        """
class IConnectedClientInfo(IPropertyObject):
    """
    """
    @staticmethod
    def can_cast_from(arg0: IBaseObject) -> bool:
        ...
    @staticmethod
    def cast_from(arg0: IBaseObject) -> IConnectedClientInfo:
        ...
    @staticmethod
    def convert_from(arg0: IBaseObject) -> IConnectedClientInfo:
        ...
    @property
    def address(self) -> str:
        """
        Gets the client address string.
        """
    @property
    def client_type_name(self) -> str:
        """
        Gets the type of connected configuration connection client.
        """
    @property
    def host_name(self) -> str:
        """
        Gets the client host name.
        """
    @property
    def protocol_name(self) -> str:
        """
        Gets the name of the protocol used by the client.
        """
    @property
    def protocol_type(self) -> ProtocolType:
        """
        Gets the type of protocol used by the client.
        """
class IConnection(IBaseObject):
    """
    Represents a connection between an Input port and Signal. Acts as a queue for packets sent by the signal, which can be read by the input port and the input port's owner.
    """
    @staticmethod
    def can_cast_from(arg0: IBaseObject) -> bool:
        ...
    @staticmethod
    def cast_from(arg0: IBaseObject) -> IConnection:
        ...
    @staticmethod
    def convert_from(arg0: IBaseObject) -> IConnection:
        ...
    def dequeue(self) -> IPacket:
        """
        Removes the packet at the front of the queue and returns it.
        """
    def dequeue_all(self) -> IList:
        """
        Removes all packets from the queue.
        """
    def enqueue(self, packet: IPacket) -> None:
        """
        Places a packet at the back of the queue.
        """
    def enqueue_multiple(self, packets: IList | list | IEvalValue) -> None:
        """
        Places multiple packets at the back of the queue.
        """
    def enqueue_on_this_thread(self, packet: IPacket) -> None:
        """
        Places a packet at the back of the queue.
        """
    def has_event_packet(self) -> int:
        """
        Queries if the connection has an event packet.
        """
    def has_gap_packet(self) -> int:
        """
        Queries if the connection has a gap packet.
        """
    def peek(self) -> IPacket:
        """
        Returns the packet at the front of the queue without removing it.
        """
    @property
    def available_samples(self) -> int:
        """
        Gets the number of samples available in the queued packets. The returned value ignores any Sample-Descriptor changes.
        """
    @property
    def input_port(self) -> IInputPort:
        """
        Gets the Input port to which packets are being sent.
        """
    @property
    def packet_count(self) -> int:
        """
        Gets the number of queued packets.
        """
    @property
    def remote(self) -> int:
        """
        Returns true if the type of connection is remote.
        """
    @property
    def samples_until_next_descriptor(self) -> int:
        """
        Gets the number of same-type samples available in the queued packets. The returned value is up-to the next Sample-Descriptor-Changed packet if any.
        """
    @property
    def samples_until_next_event_packet(self) -> int:
        """
        Gets the number of samples available in the queued packets until the next event packet. The returned value is up-to the next Event packet if any.
        """
    @property
    def samples_until_next_gap_packet(self) -> int:
        """
        Gets the number of samples available in the queued packets until the next gap packet. The returned value is up-to the next Gap packet if any.
        """
    @property
    def signal(self) -> ISignal:
        """
        Gets the Signal that is sending packets through the Connection.
        """
class IConnectionStatusContainerPrivate(IBaseObject):
    """
    Provides access to private methods for managing the Device's connection statuses.
    """
    @staticmethod
    def can_cast_from(arg0: IBaseObject) -> bool:
        ...
    @staticmethod
    def cast_from(arg0: IBaseObject) -> IConnectionStatusContainerPrivate:
        ...
    @staticmethod
    def convert_from(arg0: IBaseObject) -> IConnectionStatusContainerPrivate:
        ...
    def add_configuration_connection_status(self, connection_string: IString | str | IEvalValue, initial_value: IEnumeration) -> None:
        """
        Adds a new configuration connection status with the specified connection string and initial value.
        """
    def add_streaming_connection_status(self, connection_string: IString | str | IEvalValue, initial_value: IEnumeration, streaming_object: IStreaming) -> None:
        """
        Adds a new streaming connection status with the specified connection string, initial value, and streaming object.
        """
    def remove_streaming_connection_status(self, connection_string: IString | str | IEvalValue) -> None:
        """
        Removes a streaming connection status associated with the specified connection string.
        """
    def update_connection_status(self, connection_string: IString | str | IEvalValue, value: IEnumeration, streaming_object: IStreaming) -> None:
        """
        Updates the value of an existing connection status.
        """
    def update_connection_status_with_message(self, connection_string: IString | str | IEvalValue, value: IEnumeration, streaming_object: IStreaming, message: IString | str | IEvalValue) -> None:
        """
        Updates the value of an existing connection status with a message.
        """
class IContext(IBaseObject):
    """
    The Context serves as a container for the Scheduler and Logger. It originates at the instance, and is passed to the root device, which forwards it to components such as function blocks and signals.
    """
    @staticmethod
    def can_cast_from(arg0: IBaseObject) -> bool:
        ...
    @staticmethod
    def cast_from(arg0: IBaseObject) -> IContext:
        ...
    @staticmethod
    def convert_from(arg0: IBaseObject) -> IContext:
        ...
    def get_module_options(self, module_id: IString | str | IEvalValue) -> IDict:
        """
        Retrieves the options associated with the specified module ID.
        """
    @property
    def authentication_provider(self) -> IAuthenticationProvider:
        """
        Gets the Authentication provider.
        """
    @property
    def discovery_servers(self) -> IDict:
        """
        Gets the dictionary of available discovery servers.
        """
    @property
    def logger(self) -> ILogger:
        """
        Gets the logger.
        """
    @property
    def module_manager(self) -> typing.Any:
        """
        Gets the Module Manager as a Base Object.
        """
    @property
    def on_core_event(self) -> IEvent:
        """
        Gets the Core Event object that triggers whenever a change happens within the openDAQ core structure.
        """
    @property
    def options(self) -> IDict:
        """
        Gets the dictionary of options
        """
    @property
    def scheduler(self) -> IScheduler:
        """
        Gets the scheduler.
        """
    @property
    def type_manager(self) -> ITypeManager:
        """
        Gets the Type Manager.
        """
class ICoreEventArgs(IEventArgs):
    """
    Arguments object that defines a Core event type, and provides a set of parameters specific to a given event type.
    """
    @staticmethod
    def can_cast_from(arg0: IBaseObject) -> bool:
        ...
    @staticmethod
    def cast_from(arg0: IBaseObject) -> ICoreEventArgs:
        ...
    @staticmethod
    def convert_from(arg0: IBaseObject) -> ICoreEventArgs:
        ...
    @property
    def parameters(self) -> IDict:
        """
        Gets the parameters of the core event.
        """
class IDataDescriptor(IBaseObject):
    """
    Describes the data sent by a signal, defining how they are to be interpreted by anyone receiving the signal's packets.
    """
    @staticmethod
    def can_cast_from(arg0: IBaseObject) -> bool:
        ...
    @staticmethod
    def cast_from(arg0: IBaseObject) -> IDataDescriptor:
        ...
    @staticmethod
    def convert_from(arg0: IBaseObject) -> IDataDescriptor:
        ...
    @property
    def dimensions(self) -> IList:
        """
        Gets the list of the descriptor's dimension's.
        """
    @property
    def metadata(self) -> IDict:
        """
        Gets any extra metadata defined by the data descriptor.
        """
    @property
    def name(self) -> str:
        """
        Gets a descriptive name of the signal value.
        """
    @property
    def origin(self) -> str:
        """
        Gets the absolute origin of a signal value component.
        """
    @property
    def post_scaling(self) -> IScaling:
        ...
    @property
    def raw_sample_size(self) -> int:
        """
        Gets the actual sample size in buffer of one sample in bytes.
        """
    @property
    def reference_domain_info(self) -> IReferenceDomainInfo:
        """
        Gets the Reference Domain Info.
        """
    @property
    def rule(self) -> IDataRule:
        """
        Gets the value Data rule.
        """
    @property
    def sample_size(self) -> int:
        """
        Gets the size of one sample in bytes.
        """
    @property
    def sample_type(self) -> SampleType:
        """
        Gets the descriptor's sample type.
        """
    @property
    def struct_fields(self) -> IList:
        """
        Gets the fields of the struct, forming a recursive value descriptor definition.
        """
    @property
    def tick_resolution(self) -> IRatio:
        """
        Gets the Resolution which scales the explicit or implicit value to the physical unit defined in `unit`. It is defined as domain (usually time) between two consecutive ticks.
        """
    @property
    def unit(self) -> IUnit:
        """
        Gets the unit of the data in a signal's packets.
        """
    @property
    def value_range(self) -> IRange:
        """
        Gets the value range of the data in a signal's packets defining the lowest and highest expected values.
        """
class IDataDescriptorBuilder(IBaseObject):
    """
    Builder component of Data descriptor objects. Contains setter methods that allow for Data descriptor parameter configuration, and a `build` method that builds the Data descriptor.
    """
    @staticmethod
    def can_cast_from(arg0: IBaseObject) -> bool:
        ...
    @staticmethod
    def cast_from(arg0: IBaseObject) -> IDataDescriptorBuilder:
        ...
    @staticmethod
    def convert_from(arg0: IBaseObject) -> IDataDescriptorBuilder:
        ...
    def build(self) -> IDataDescriptor:
        """
        Builds and returns a Data descriptor object using the currently set values of the Builder.
        """
    @property
    def dimensions(self) -> IList:
        """
        Gets the list of the descriptor's dimension's. / Sets the list of the descriptor's dimension's.
        """
    @dimensions.setter
    def dimensions(self, arg1: IList | list | IEvalValue) -> None:
        ...
    @property
    def metadata(self) -> IDict:
        """
        Gets any extra metadata defined by the data descriptor. / Sets any extra metadata defined by the data descriptor.
        """
    @metadata.setter
    def metadata(self, arg1: IDict | dict) -> None:
        ...
    @property
    def name(self) -> str:
        """
        Gets a descriptive name for the signal's value. / Sets a descriptive name for the signal's value.
        """
    @name.setter
    def name(self, arg1: IString | str | IEvalValue) -> None:
        ...
    @property
    def origin(self) -> str:
        """
        Gets the absolute origin of a signal value component. / Sets the absolute origin of a signal value component.
        """
    @origin.setter
    def origin(self, arg1: IString | str | IEvalValue) -> None:
        ...
    @property
    def post_scaling(self) -> IScaling:
        """
        Gets the scaling rule that needs to be applied to explicit/implicit data by readers. / Sets the scaling rule that needs to be applied to explicit/implicit data by readers.
        """
    @post_scaling.setter
    def post_scaling(self, arg1: IScaling) -> None:
        ...
    @property
    def reference_domain_info(self) -> IReferenceDomainInfo:
        """
        Gets the Reference Domain Info. / Sets the Reference Domain Info.
        """
    @reference_domain_info.setter
    def reference_domain_info(self, arg1: IReferenceDomainInfo) -> None:
        ...
    @property
    def rule(self) -> IDataRule:
        """
        Gets the value Data rule. / Sets the value Data rule.
        """
    @rule.setter
    def rule(self, arg1: IDataRule) -> None:
        ...
    @property
    def sample_type(self) -> SampleType:
        """
        Gets the descriptor's sample type. / Sets the descriptor's sample type.
        """
    @sample_type.setter
    def sample_type(self, arg1: SampleType) -> None:
        ...
    @property
    def struct_fields(self) -> IList:
        """
        Gets the fields of the struct, forming a recursive value descriptor definition. / Sets the fields of the struct, forming a recursive value descriptor definition.
        """
    @struct_fields.setter
    def struct_fields(self, arg1: IList | list | IEvalValue) -> None:
        ...
    @property
    def tick_resolution(self) -> IRatio:
        """
        Gets the Resolution which scales the an explicit or implicit value to the physical unit defined in `unit`. / Sets the Resolution which scales the an explicit or implicit value to the physical unit defined in `unit`.
        """
    @tick_resolution.setter
    def tick_resolution(self, arg1: IRatio | tuple[int, int]) -> None:
        ...
    @property
    def unit(self) -> IUnit:
        """
        Gets the unit of the data in a signal's packets. / Sets the unit of the data in a signal's packets.
        """
    @unit.setter
    def unit(self, arg1: IUnit) -> None:
        ...
    @property
    def value_range(self) -> IRange:
        """
        Gets the value range of the data in a signal's packets defining the lowest and highest expected values. / Sets the value range of the data in a signal's packets defining the lowest and highest expected values.
        """
    @value_range.setter
    def value_range(self, arg1: IRange) -> None:
        ...
class IDataPacket(IPacket):
    """
    Packet that contains data sent by a signal. The data can be either explicit, or implicit.
    """
    @staticmethod
    def can_cast_from(arg0: IBaseObject) -> bool:
        ...
    @staticmethod
    def cast_from(arg0: IBaseObject) -> IDataPacket:
        ...
    @staticmethod
    def convert_from(arg0: IBaseObject) -> IDataPacket:
        ...
    def get_last_value(self, type_manager: ITypeManager = None) -> typing.Any:
        """
        Gets the data packet last value.
        """
    def get_value_by_index(self, index: int, type_manager: ITypeManager = None) -> typing.Any:
        """
        Gets the data packet last value.
        """
    @property
    def data(self) -> typing_extensions.Buffer:
        """
        Gets the calculated/scaled data address of the packet.
        """
    @property
    def data_descriptor(self) -> IDataDescriptor:
        """
        Gets the signal descriptor of the signal that sent the packet at the time of sending.
        """
    @property
    def data_size(self) -> int:
        """
        Gets size of data buffer in bytes.
        """
    @property
    def domain_packet(self) -> IDataPacket:
        """
        Gets the associated domain Data packet.
        """
    @property
    def last_value(self) -> typing.Any:
        """
        Gets the data packet last value.
        """
    @property
    def offset(self) -> INumber:
        """
        Gets current packet offset. This offset is later applied to the data rule used by a signal to calculate actual data value. This value is usually a time or other domain value. Packet offset is particularly useful when one wants to transfer a gap in otherwise equidistant samples. If we have a linear data rule, defined by equation f(x) = k*x + n, then the data value will be calculated by the equation g(x) = offset + f(x).
        """
    @property
    def packet_id(self) -> int:
        """
        Gets the unique packet id.
        """
    @property
    def raw_data(self) -> typing_extensions.Buffer:
        """
        Gets a pointer to the raw packet data. `nullptr` if the signal's data rule is implicit.
        """
    @property
    def raw_data_size(self) -> int:
        """
        Gets size of raw data buffer in bytes.
        """
    @property
    def sample_count(self) -> int:
        """
        Gets the number of samples in the packet.
        """
class IDataRule(IBaseObject):
    """
    Rule that defines how a signal value is calculated from an implicit initialization value when the rule type is not `Explicit`.
    """
    @staticmethod
    def can_cast_from(arg0: IBaseObject) -> bool:
        ...
    @staticmethod
    def cast_from(arg0: IBaseObject) -> IDataRule:
        ...
    @staticmethod
    def convert_from(arg0: IBaseObject) -> IDataRule:
        ...
    @property
    def parameters(self) -> IDict:
        """
        Gets a dictionary of string-object key-value pairs representing the parameters used to evaluate the rule.
        """
    @property
    def type(self) -> DataRuleType:
        """
        Gets the type of the data rule.
        """
class IDataRuleBuilder(IBaseObject):
    """
    Configuration component of Data rule objects. Contains setter methods that allow for Data rule parameter configuration, and a `build` method that builds the Data rule.
    """
    @staticmethod
    def can_cast_from(arg0: IBaseObject) -> bool:
        ...
    @staticmethod
    def cast_from(arg0: IBaseObject) -> IDataRuleBuilder:
        ...
    @staticmethod
    def convert_from(arg0: IBaseObject) -> IDataRuleBuilder:
        ...
    def add_parameter(self, name: IString | str | IEvalValue, parameter: typing.Any) -> None:
        """
        Adds a string-object pair parameter to the Dictionary of Data rule parameters.
        """
    def build(self) -> IDataRule:
        """
        Builds and returns a Data rule object using the currently set values of the Builder.
        """
    def remove_parameter(self, name: IString | str | IEvalValue) -> None:
        """
        Removes the parameter with the given name from the Dictionary of Data rule parameters.
        """
    @property
    def parameters(self) -> IDict:
        """
        Gets a dictionary of string-object key-value pairs representing the parameters used to evaluate the rule. / Sets a dictionary of string-object key-value pairs representing the parameters used to evaluate the rule.
        """
    @parameters.setter
    def parameters(self, arg1: IDict | dict) -> None:
        ...
    @property
    def type(self) -> DataRuleType:
        """
        Gets the type of the data rule. / Sets the type of the data rule.
        """
    @type.setter
    def type(self, arg1: DataRuleType) -> None:
        ...
class IDevice(IFolder):
    """
    Represents an openDAQ device. The device contains a list of signals and physical channels. Some devices support adding function blocks, or connecting to devices. The list of available function blocks/devices can be obtained via the `getAvailable` functions, and added via the `add` functions.
    """
    @staticmethod
    def can_cast_from(arg0: IBaseObject) -> bool:
        ...
    @staticmethod
    def cast_from(arg0: IBaseObject) -> IDevice:
        ...
    @staticmethod
    def convert_from(arg0: IBaseObject) -> IDevice:
        ...
    def add_device(self, connection_string: IString | str | IEvalValue, config: IPropertyObject = None) -> IDevice:
        """
        Connects to a device at the given connection string and returns it.
        """
    def add_function_block(self, type_id: IString | str | IEvalValue, config: IPropertyObject = None) -> IFunctionBlock:
        """
        Creates and adds a function block to the device with the provided unique ID and returns it.
        """
    def add_server(self, type_id: IString | str | IEvalValue, config: IPropertyObject) -> IServer:
        """
        Creates and adds to the device a server with the provided unique type ID and returns it.
        """
    def add_streaming(self, connection_string: IString | str | IEvalValue, config: IPropertyObject = None) -> IStreaming:
        """
        Connects to a streaming at the given connection string, adds it as a streaming source of device and returns created streaming object.
        """
    def create_default_add_device_config(self) -> IPropertyObject:
        """
        Creates config object that can be used when adding a device. Contains Device and Streaming default configuration for all available Device/Streaming types. Also contains general add-device configuration settings.
        """
    def get_channels(self, search_filter: ISearchFilter = None) -> IList:
        """
        Gets a flat list of the device's physical channels.
        """
    def get_channels_recursive(self, search_filter: ISearchFilter = None) -> IList:
        """
        Gets a flat list of the device's physical channels. Also finds all visible channels of visible child devices
        """
    def get_devices(self, search_filter: ISearchFilter = None) -> IList:
        """
        Gets a list of child devices that the device is connected to.
        """
    def get_function_blocks(self, search_filter: ISearchFilter = None) -> IList:
        """
        Gets the list of added function blocks.
        """
    def get_log(self, id: IString | str | IEvalValue, size: int = -1, offset: int = 0) -> str:
        """
        Retrieves a chunk of the log file with the provided ID.
        """
    def get_signals(self, search_filter: ISearchFilter = None) -> IList:
        """
        Gets a list of the device's signals.
        """
    def get_signals_recursive(self, search_filter: ISearchFilter = None) -> IList:
        """
        Gets a list of the signals that belong to the device.
        """
    def load_configuration(self, configuration: IString | str | IEvalValue, config: IUpdateParameters = None) -> None:
        """
        Loads the configuration of the device from string.
        """
    def lock(self) -> None:
        """
        Lock a device with a session user. Once locked, no properties of the device can be changed via the protocol layer. Only the same user who locked the device can unlock it. If no user was specified when the device was locked, any user will be able to unlock it.
        """
    def remove_device(self, device: IDevice) -> None:
        """
        Disconnects from the device provided as argument and removes it from the internal list of devices.
        """
    def remove_function_block(self, function_block: IFunctionBlock) -> None:
        """
        Removes the function block provided as argument, disconnecting its signals and input ports.
        """
    def remove_server(self, server: IServer) -> None:
        """
        Removes the server provided as argument.
        """
    def save_configuration(self) -> str:
        """
        Saves the configuration of the device to string.
        """
    def unlock(self) -> None:
        """
        Unlock a device with a session user. A device can only be unlocked by the same user who locked it. If no user was specified when the device was locked, any user will be able to unlock it.
        """
    @property
    def available_device_types(self) -> IDict:
        """
        Get a dictionary of available device types as <IString, IDeviceType> pairs
        """
    @property
    def available_devices(self) -> IList:
        """
        Gets a list of available devices, containing their Device Info.
        """
    @property
    def available_function_block_types(self) -> IDict:
        """
        Gets all function block types that are supported by the device, containing their description.
        """
    @property
    def available_operation_modes(self) -> IList:
        """
        Gets a list of available operation modes for the device.
        """
    @property
    def channels(self) -> IList:
        """
        Gets a flat list of the device's physical channels.
        """
    @property
    def channels_recursive(self) -> IList:
        """
        Gets a flat list of the device's physical channels. Also finds all visible channels of visible child devices
        """
    @property
    def connection_status_container(self) -> IComponentStatusContainer:
        """
        Gets the container holding the statuses of device configuration and streaming connections.
        """
    @property
    def custom_components(self) -> IList:
        """
        Gets a list of all components/folders in a device that are not titled 'IO', 'Sig', 'Dev', 'Synchronization' or 'FB'
        """
    @property
    def devices(self) -> IList:
        """
        Gets a list of child devices that the device is connected to.
        """
    @property
    def domain(self) -> IDeviceDomain:
        """
        Gets the device's domain data. It allows for querying the device for its domain (time) values.
        """
    @property
    def function_blocks(self) -> IList:
        """
        Gets the list of added function blocks.
        """
    @property
    def info(self) -> IDeviceInfo:
        """
        Gets the device info. It contains data about the device such as the device's serial number, location, and connection string.
        """
    @property
    def inputs_outputs_folder(self) -> IFolder:
        """
        Gets a folder containing channels.
        """
    @property
    def locked(self) -> int:
        """
        Returns true if device is locked. Once locked, no properties of the device can be changed via the protocol layer.
        """
    @property
    def log_file_infos(self) -> IList:
        """
        Gets a list of available log files.
        """
    @property
    def operation_mode(self) -> str:
        """
        Gets the operation mode of the device. / Sets the operation mode of the device subtree excluding the sub-devices.
        """
    @operation_mode.setter
    def operation_mode(self, arg1: IString | str | IEvalValue) -> None:
        ...
    @property
    def servers(self) -> IList:
        """
        Get list of added servers.
        """
    @property
    def signals(self) -> IList:
        """
        Gets a list of the device's signals.
        """
    @property
    def signals_recursive(self) -> IList:
        """
        Gets a list of the signals that belong to the device.
        """
    @property
    def sync_component(self) -> ISyncComponent:
        """
        Gets the sync component of the device.
        """
    @property
    def ticks_since_origin(self) -> int:
        """
        Gets the number of ticks passed since the device's absolute origin.
        """
class IDeviceDomain(IBaseObject):
    """
    Contains information about the domain of the device.
    """
    @staticmethod
    def can_cast_from(arg0: IBaseObject) -> bool:
        ...
    @staticmethod
    def cast_from(arg0: IBaseObject) -> IDeviceDomain:
        ...
    @staticmethod
    def convert_from(arg0: IBaseObject) -> IDeviceDomain:
        ...
    @property
    def origin(self) -> str:
        """
        Gets the device's absolute origin. Most often this is a time epoch in the ISO 8601 format.
        """
    @property
    def reference_domain_info(self) -> IReferenceDomainInfo:
        """
        Gets the Reference Domain Info.
        """
    @property
    def tick_resolution(self) -> IRatio:
        """
        Gets domain (usually time) between two consecutive ticks. Resolution is provided in a domain unit.
        """
    @property
    def unit(self) -> IUnit:
        """
        Gets the domain unit (eg. seconds, hours, degrees...)
        """
class IDeviceInfo(IPropertyObject):
    """
    Contains standard information about an openDAQ device and device type. The Device Info object is a Property Object, allowing for custom String, Int, Bool, or Float-type properties to be added.
    """
    @staticmethod
    def can_cast_from(arg0: IBaseObject) -> bool:
        ...
    @staticmethod
    def cast_from(arg0: IBaseObject) -> IDeviceInfo:
        ...
    @staticmethod
    def convert_from(arg0: IBaseObject) -> IDeviceInfo:
        ...
    def get_network_interface(self, interface_name: IString | str | IEvalValue) -> INetworkInterface:
        """
        Gets the network interface with a given name.
        """
    def get_server_capability(self, protocol_id: IString | str | IEvalValue) -> IServerCapability:
        """
        Gets the server capability with a given ID.
        """
    def has_server_capability(self, protocol_id: IString | str | IEvalValue) -> int:
        """
        Checks whether the server capability with a given ID is available.
        """
    @property
    def asset_id(self) -> str:
        """
        Gets the asset ID of the device. Represents a user writable alphanumeric character sequence uniquely identifying a component.
        """
    @property
    def configuration_connection_info(self) -> IServerCapability:
        """
        Retrieves the configuration connection information of the server to which the client is connected.
        """
    @property
    def connected_clients_info(self) -> IList:
        """
        Gets the list of connected client information objects.
        """
    @property
    def connection_string(self) -> str:
        """
        Gets the string representation of a connection address used to connect to the device.
        """
    @property
    def custom_info_property_names(self) -> IList:
        """
        Gets the list of property names that are not in the default set of Device info properties. Default properties are all info properties that have a corresponding getter method.
        """
    @property
    def device_class(self) -> str:
        """
        Gets the purpose of the device. For example "TestMeasurementDevice".
        """
    @property
    def device_manual(self) -> str:
        """
        Gets the address of the user manual. It may be a pathname in the file system or a URL (Web address)
        """
    @property
    def device_revision(self) -> str:
        """
        Gets the revision level of the device.
        """
    @property
    def device_type(self) -> IDeviceType:
        """
        Gets a device type as an object providing type id, name, short description and default device configuration. By using default config object as a starting point, users can easily modify the preset properties to tailor the configuration of the client device accordingly.
        """
    @property
    def hardware_revision(self) -> str:
        """
        Gets the revision level of the hardware.
        """
    @property
    def location(self) -> str:
        """
        Gets the location of the device.
        """
    @property
    def mac_address(self) -> str:
        """
        Gets the Mac address of the device.
        """
    @property
    def manufacturer(self) -> str:
        """
        Gets the company that manufactured the device
        """
    @property
    def manufacturer_uri(self) -> str:
        """
        Gets the unique identifier of the company that manufactured the device This identifier should be a fully qualified domain name; however, it may be a GUID or similar construct that ensures global uniqueness.
        """
    @property
    def model(self) -> str:
        """
        Gets the model of the device
        """
    @property
    def name(self) -> str:
        """
        Gets the name of the device
        """
    @property
    def network_interfaces(self) -> IDict:
        """
        Gets the dictionary of network interfaces stored in device info.
        """
    @property
    def parent_mac_address(self) -> str:
        """
        Gets the Mac address of the device's parent.
        """
    @property
    def platform(self) -> str:
        """
        Gets the platform of the device. The platform specifies whether real hardware is used or if the device is simulated.
        """
    @property
    def position(self) -> int:
        """
        Gets the position of the device. The position specifies the position within a given system. For example in which slot or slice the device is in.
        """
    @property
    def product_code(self) -> str:
        """
        Gets the unique combination of numbers and letters used to identify the device.
        """
    @property
    def product_instance_uri(self) -> str:
        """
        Gets the globally unique resource identifier provided by the manufacturer. The recommended syntax of the ProductInstanceUri is: <ManufacturerUri>/<any string> where <any string> is unique among all instances using the same ManufacturerUri.
        """
    @property
    def revision_counter(self) -> int:
        """
        Gets the incremental counter indicating the number of times the configuration data has been modified.
        """
    @property
    def sdk_version(self) -> str:
        """
        Gets the version of the SDK used to build said device. Can be empty if the device does not use the SDK as its firmware/is implemented at a protocol-level.
        """
    @property
    def serial_number(self) -> str:
        """
        Gets the unique production number provided by the manufacturer
        """
    @property
    def server_capabilities(self) -> IList:
        """
        Gets the list of server capabilities stored in device info.
        """
    @property
    def software_revision(self) -> str:
        """
        Gets the revision level of the software component.
        """
    @property
    def system_type(self) -> str:
        """
        Gets the system type. The system type can, for example, be LayeredSystem, StandaloneSystem, or RackSystem.
        """
    @property
    def system_uuid(self) -> str:
        """
        Gets the system UUID that represents a unique ID of a system. All devices in a system share this UUID.
        """
    @property
    def user_name(self) -> str:
        """
        Gets the name of the current user of the device.
        """
class IDeviceInfoConfig(IDeviceInfo):
    """
    Configuration component of Device info objects. Contains setter methods that are available until the object is frozen.
    """
    @staticmethod
    def can_cast_from(arg0: IBaseObject) -> bool:
        ...
    @staticmethod
    def cast_from(arg0: IBaseObject) -> IDeviceInfoConfig:
        ...
    @staticmethod
    def convert_from(arg0: IBaseObject) -> IDeviceInfoConfig:
        ...
class IDeviceNetworkConfig(IBaseObject):
    """
    Interface for managing device network configuration information and settings.
    """
    @staticmethod
    def can_cast_from(arg0: IBaseObject) -> bool:
        ...
    @staticmethod
    def cast_from(arg0: IBaseObject) -> IDeviceNetworkConfig:
        ...
    @staticmethod
    def convert_from(arg0: IBaseObject) -> IDeviceNetworkConfig:
        ...
    def retrieve_network_configuration(self, iface_name: IString | str | IEvalValue) -> IPropertyObject:
        """
        Retrieves the currently active configuration of a specified network interface.
        """
    def submit_network_configuration(self, iface_name: IString | str | IEvalValue, config: IPropertyObject) -> None:
        """
        Submits a new configuration parameters to a specified network interface.
        """
    @property
    def network_configuration_enabled(self) -> int:
        """
        Checks if the device supports network configuration management.
        """
    @property
    def network_interface_names(self) -> IList:
        """
        Gets the names of all configurable network interfaces on the device.
        """
class IDevicePrivate(IBaseObject):
    """
    """
    device_config: IPropertyObject
    @staticmethod
    def can_cast_from(arg0: IBaseObject) -> bool:
        ...
    @staticmethod
    def cast_from(arg0: IBaseObject) -> IDevicePrivate:
        ...
    @staticmethod
    def convert_from(arg0: IBaseObject) -> IDevicePrivate:
        ...
    def force_unlock(self) -> None:
        ...
    def lock(self, user: IUser) -> None:
        ...
    def unlock(self, user: IUser) -> None:
        ...
    @property
    def locked_internal(self) -> int:
        ...
class IDeviceType(IComponentType):
    """
    Provides information on what device type can be created by a given module. Can be used to obtain the default configuration used when either adding/creating a new device.
    """
    @staticmethod
    def can_cast_from(arg0: IBaseObject) -> bool:
        ...
    @staticmethod
    def cast_from(arg0: IBaseObject) -> IDeviceType:
        ...
    @staticmethod
    def convert_from(arg0: IBaseObject) -> IDeviceType:
        ...
    @property
    def connection_string_prefix(self) -> str:
        ...
class IDict(IBaseObject):
    """
    Represents a heterogeneous dictionary of objects.
    """
    @staticmethod
    def can_cast_from(arg0: IBaseObject) -> bool:
        ...
    @staticmethod
    def cast_from(arg0: IBaseObject) -> IDict:
        ...
    @staticmethod
    def convert_from(arg0: IBaseObject) -> IDict:
        ...
    def __delitem__(self, arg0: typing.Any) -> None:
        ...
    def __getitem__(self, arg0: typing.Any) -> typing.Any:
        ...
    def __iter__(self) -> typing.Any:
        ...
    def __len__(self) -> int:
        ...
    def __setitem__(self, arg0: typing.Any, arg1: typing.Any) -> None:
        ...
    def clear(self) -> None:
        ...
    def items(self) -> list:
        ...
    def keys(self) -> IIterable:
        ...
    def pop(self, arg0: typing.Any) -> IBaseObject:
        ...
    def values(self) -> IIterable:
        ...
class IDimension(IBaseObject):
    """
    Describes a dimension of the signal's data. Eg. a column/row in a matrix.
    """
    @staticmethod
    def can_cast_from(arg0: IBaseObject) -> bool:
        ...
    @staticmethod
    def cast_from(arg0: IBaseObject) -> IDimension:
        ...
    @staticmethod
    def convert_from(arg0: IBaseObject) -> IDimension:
        ...
    @property
    def labels(self) -> IList:
        """
        Gets a list of labels that defines the dimension.
        """
    @property
    def name(self) -> str:
        """
        Gets the name of the dimension.
        """
    @property
    def rule(self) -> IDimensionRule:
        """
        Gets the rule that defines the labels and size of the dimension.
        """
    @property
    def size(self) -> int:
        """
        Gets the size of the dimension.
        """
    @property
    def unit(self) -> IUnit:
        """
        Gets the unit of the dimension's labels.
        """
class IDimensionBuilder(IBaseObject):
    """
    Configuration component of Dimension objects. Contains setter methods that allow for Dimension parameter configuration, and a `build` method that builds the Dimension.
    """
    @staticmethod
    def can_cast_from(arg0: IBaseObject) -> bool:
        ...
    @staticmethod
    def cast_from(arg0: IBaseObject) -> IDimensionBuilder:
        ...
    @staticmethod
    def convert_from(arg0: IBaseObject) -> IDimensionBuilder:
        ...
    def build(self) -> IDimension:
        """
        Builds and returns a Dimension object using the currently set values of the Builder.
        """
    @property
    def name(self) -> str:
        """
        Gets the name of the dimension. / Sets the name of the dimension.
        """
    @name.setter
    def name(self, arg1: IString | str | IEvalValue) -> None:
        ...
    @property
    def rule(self) -> IDimensionRule:
        """
        Gets the rule that defines the labels and size of the dimension. / Sets the rule that defines the labels and size of the dimension.
        """
    @rule.setter
    def rule(self, arg1: IDimensionRule) -> None:
        ...
    @property
    def unit(self) -> IUnit:
        """
        Gets the unit of the dimension's labels. / Sets the unit of the dimension's labels.
        """
    @unit.setter
    def unit(self, arg1: IUnit) -> None:
        ...
class IDimensionRule(IBaseObject):
    """
    Rule that defines the labels (alternatively called bins, ticks) of a dimension.
    """
    @staticmethod
    def can_cast_from(arg0: IBaseObject) -> bool:
        ...
    @staticmethod
    def cast_from(arg0: IBaseObject) -> IDimensionRule:
        ...
    @staticmethod
    def convert_from(arg0: IBaseObject) -> IDimensionRule:
        ...
    @property
    def parameters(self) -> IDict:
        """
        Gets a dictionary of string-object key-value pairs representing the parameters used to evaluate the rule.
        """
    @property
    def type(self) -> DimensionRuleType:
        """
        Gets the type of the dimension rule.
        """
class IDimensionRuleBuilder(IBaseObject):
    """
    Configuration component of Dimension rule objects. Contains setter methods that allow for Dimension rule parameter configuration, and a `build` method that builds the Dimension rule.
    """
    @staticmethod
    def can_cast_from(arg0: IBaseObject) -> bool:
        ...
    @staticmethod
    def cast_from(arg0: IBaseObject) -> IDimensionRuleBuilder:
        ...
    @staticmethod
    def convert_from(arg0: IBaseObject) -> IDimensionRuleBuilder:
        ...
    def add_parameter(self, name: IString | str | IEvalValue, parameter: typing.Any) -> None:
        """
        Adds a string-object pair parameter to the Dictionary of Dimension rule parameters.
        """
    def build(self) -> IDimensionRule:
        """
        Builds and returns a Dimension rule object using the currently set values of the Builder.
        """
    def remove_parameter(self, name: IString | str | IEvalValue) -> None:
        """
        Removes the parameter with the given name from the Dictionary of Dimension rule parameters.
        """
    @property
    def parameters(self) -> IDict:
        """
        Gets a dictionary of string-object key-value pairs representing the parameters used to evaluate the rule. / Sets a dictionary of string-object key-value pairs representing the parameters used to evaluate the rule.
        """
    @parameters.setter
    def parameters(self, arg1: IDict | dict) -> None:
        ...
    @property
    def type(self) -> DimensionRuleType:
        """
        Gets the type of the dimension rule. / Sets the type of the dimension rule. Rule parameters must be configured to match the requirements of the rule type.
        """
    @type.setter
    def type(self, arg1: DimensionRuleType) -> None:
        ...
class IDiscoveryServer(IBaseObject):
    """
    """
    @staticmethod
    def can_cast_from(arg0: IBaseObject) -> bool:
        ...
    @staticmethod
    def cast_from(arg0: IBaseObject) -> IDiscoveryServer:
        ...
    @staticmethod
    def convert_from(arg0: IBaseObject) -> IDiscoveryServer:
        ...
    def register_service(self, id: IString | str | IEvalValue, config: IPropertyObject, device_info: IDeviceInfo) -> None:
        ...
    def unregister_service(self, id: IString | str | IEvalValue) -> None:
        ...
class IEnumeration(IBaseObject):
    """
    Enumerations are immutable objects that encapsulate a value within a predefined set of named integral constants. These constants are predefined in an Enumeration type with the same name as the Enumeration.
    """
    @staticmethod
    def can_cast_from(arg0: IBaseObject) -> bool:
        ...
    @staticmethod
    def cast_from(arg0: IBaseObject) -> IEnumeration:
        ...
    @staticmethod
    def convert_from(arg0: IBaseObject) -> IEnumeration:
        ...
    def __str__(self) -> typing.Any:
        ...
    @property
    def enumeration_type(self) -> IEnumerationType:
        """
        Gets the Enumeration's type.
        """
    @property
    def name(self) -> str:
        """
        Gets the Enumeration value as String containing the name of the enumerator constant.
        """
    @property
    def value(self) -> int:
        """
        Gets the Enumeration value as Integer enumerator constant.
        """
class IEnumerationType(IType):
    """
    Enumeration types define the enumerator names and values of Enumerations with a name matching that of the Enumeration type.
    """
    @staticmethod
    def can_cast_from(arg0: IBaseObject) -> bool:
        ...
    @staticmethod
    def cast_from(arg0: IBaseObject) -> IEnumerationType:
        ...
    @staticmethod
    def convert_from(arg0: IBaseObject) -> IEnumerationType:
        ...
    def __call__(self, arg0: int) -> IEnumeration:
        ...
    def __getattr__(self, arg0: str) -> IEnumeration:
        ...
    def __getitem__(self, arg0: str) -> IEnumeration:
        ...
    def get_enumerator_int_value(self, name: str) -> int:
        """
        Gets the value of enumerator with the specified name.
        """
    @property
    def as_dictionary(self) -> IDict:
        """
        Gets the enumerator names and values as a Dictionary.
        """
    @property
    def count(self) -> int:
        """
        Gets the number of enumerators within the Enumeration Type.
        """
    @property
    def enumerator_names(self) -> IList:
        """
        Gets the list of enumerator names.
        """
class IEvalValue(IBaseObject):
    """
    Dynamic expression evaluator
    """
    @staticmethod
    def can_cast_from(arg0: IBaseObject) -> bool:
        ...
    @staticmethod
    def cast_from(arg0: IBaseObject) -> IEvalValue:
        ...
    @staticmethod
    def convert_from(arg0: IBaseObject) -> IEvalValue:
        ...
    def clone_with_owner(self, owner: IPropertyObject) -> IEvalValue:
        """
        Clones the object and attaches an owner.
        """
    def get_parse_error_code(self) -> None:
        """
        Returns the parse error code.
        """
    @property
    def eval(self) -> str:
        """
        Gets the expression.
        """
    @property
    def property_references(self) -> IList:
        """
        Returns the names of all properties referenced by the eval value.
        """
    @property
    def result(self) -> typing.Any:
        """
        Gets the result of the expression.
        """
    @property
    def result_no_lock(self) -> typing.Any:
        ...
class IEvent(IBaseObject):
    """
    """
    @staticmethod
    def can_cast_from(arg0: IBaseObject) -> bool:
        ...
    @staticmethod
    def cast_from(arg0: IBaseObject) -> IEvent:
        ...
    @staticmethod
    def convert_from(arg0: IBaseObject) -> IEvent:
        ...
    def __add__(self, event_handler: IEventHandler) -> None:
        ...
    def __and__(self, event_handler: IEventHandler) -> None:
        ...
    def __or__(self, event_handler: IEventHandler) -> None:
        ...
    def __sub__(self, event_handler: IEventHandler) -> None:
        ...
    def add_handler(self, event_handler: IEventHandler) -> None:
        ...
    def clear(self) -> None:
        ...
    def mute(self) -> None:
        ...
    def mute_listener(self, event_handler: IEventHandler) -> None:
        ...
    def remove_handler(self, event_handler: IEventHandler) -> None:
        ...
    def unmute(self) -> None:
        ...
    def unmute_listener(self, event_handler: IEventHandler) -> None:
        ...
    @property
    def subscriber_count(self) -> int:
        ...
    @property
    def subscribers(self) -> IList:
        ...
class IEventArgs(IBaseObject):
    """
    """
    @staticmethod
    def can_cast_from(arg0: IBaseObject) -> bool:
        ...
    @staticmethod
    def cast_from(arg0: IBaseObject) -> IEventArgs:
        ...
    @staticmethod
    def convert_from(arg0: IBaseObject) -> IEventArgs:
        ...
    @property
    def event_id(self) -> int:
        ...
    @property
    def event_name(self) -> str:
        ...
class IEventHandler(IBaseObject):
    """
    """
    @staticmethod
    def can_cast_from(arg0: IBaseObject) -> bool:
        ...
    @staticmethod
    def cast_from(arg0: IBaseObject) -> IEventHandler:
        ...
    @staticmethod
    def convert_from(arg0: IBaseObject) -> IEventHandler:
        ...
class IEventPacket(IPacket):
    """
    As with Data packets, Event packets travel along the signal paths. They are used to notify recipients of any relevant changes to the signal sending the packet.
    """
    @staticmethod
    def can_cast_from(arg0: IBaseObject) -> bool:
        ...
    @staticmethod
    def cast_from(arg0: IBaseObject) -> IEventPacket:
        ...
    @staticmethod
    def convert_from(arg0: IBaseObject) -> IEventPacket:
        ...
    @property
    def event_id(self) -> str:
        """
        Gets the ID of the event as a string. In example "DATA_DESCRIPTOR_CHANGED".
        """
    @property
    def parameters(self) -> IDict:
        """
        Dictionary containing parameters as <String, BaseObject> pairs relevant to the event signalized by the Event packet.
        """
class IFloat(IBaseObject):
    """
    Represents float number as `IFloat` interface. Use this interface to wrap float variable when you need to add the number to lists, dictionaries and other containers which accept `IBaseObject` and derived interfaces. Float type is defined as double-precision IEEE 754 value.
    """
    @staticmethod
    def can_cast_from(arg0: IBaseObject) -> bool:
        ...
    @staticmethod
    def cast_from(arg0: IBaseObject) -> IFloat:
        ...
    @staticmethod
    def convert_from(arg0: IBaseObject) -> IFloat:
        ...
    @property
    def value(self) -> float:
        """
        Gets a float value stored in the object.
        """
class IFolder(IComponent):
    """
    Acts as a container for other components
    """
    @staticmethod
    def can_cast_from(arg0: IBaseObject) -> bool:
        ...
    @staticmethod
    def cast_from(arg0: IBaseObject) -> IFolder:
        ...
    @staticmethod
    def convert_from(arg0: IBaseObject) -> IFolder:
        ...
    def get_item(self, local_id: IString | str | IEvalValue) -> IComponent:
        """
        Gets the item component with the specified localId.
        """
    def get_items(self, search_filter: ISearchFilter = None) -> IList:
        """
        Gets the list of the items in the folder.
        """
    def has_item(self, local_id: IString | str | IEvalValue) -> int:
        """
        Returns True if the folder has an item with local ID.
        """
    @property
    def empty(self) -> int:
        """
        Returns True if the folder is empty.
        """
    @property
    def items(self) -> IList:
        """
        Gets the list of the items in the folder.
        """
class IFolderConfig(IFolder):
    """
    Allows write access to folder.
    """
    @staticmethod
    def can_cast_from(arg0: IBaseObject) -> bool:
        ...
    @staticmethod
    def cast_from(arg0: IBaseObject) -> IFolderConfig:
        ...
    @staticmethod
    def convert_from(arg0: IBaseObject) -> IFolderConfig:
        ...
    def add_item(self, item: IComponent) -> None:
        """
        Adds a component to the folder.
        """
    def clear(self) -> None:
        """
        Removes all items from the folder.
        """
    def remove_item(self, item: IComponent) -> None:
        """
        Removes the item from the folder.
        """
    def remove_item_with_local_id(self, local_id: IString | str | IEvalValue) -> None:
        """
        Removes the item from the folder using local id of the component.
        """
class IFunction(IBaseObject):
    """
    Holds a callback function with return value.
    """
    @staticmethod
    def can_cast_from(arg0: IBaseObject) -> bool:
        ...
    @staticmethod
    def cast_from(arg0: IBaseObject) -> IFunction:
        ...
    @staticmethod
    def convert_from(arg0: IBaseObject) -> IFunction:
        ...
    def __call__(self, *args) -> typing.Any:
        ...
class IFunctionBlock(IFolder):
    """
    Function blocks perform calculations on inputs/generate data, outputting new data in its output signals as packets.
    """
    @staticmethod
    def can_cast_from(arg0: IBaseObject) -> bool:
        ...
    @staticmethod
    def cast_from(arg0: IBaseObject) -> IFunctionBlock:
        ...
    @staticmethod
    def convert_from(arg0: IBaseObject) -> IFunctionBlock:
        ...
    def add_function_block(self, type_id: IString | str | IEvalValue, config: IPropertyObject = None) -> IFunctionBlock:
        """
        Creates and adds a function block as the nested of current function block with the provided unique ID and returns it.
        """
    def get_function_blocks(self, search_filter: ISearchFilter = None) -> IList:
        """
        Gets a list of sub-function blocks.
        """
    def get_input_ports(self, search_filter: ISearchFilter = None) -> IList:
        """
        Gets a list of the function block's input ports.
        """
    def get_signals(self, search_filter: ISearchFilter = None) -> IList:
        """
        Gets the list of the function block's output signals.
        """
    def get_signals_recursive(self, search_filter: ISearchFilter = None) -> IList:
        """
        Gets the list of the function block's visible output signals including signals from visible child function blocks.
        """
    def remove_function_block(self, function_block: IFunctionBlock) -> None:
        """
        Removes the function block provided as argument, disconnecting its signals and input ports.
        """
    @property
    def available_function_block_types(self) -> IDict:
        """
        Gets all nested function block types that are supported, containing their description.
        """
    @property
    def function_block_type(self) -> IFunctionBlockType:
        """
        Gets an information structure contain metadata of the function block type.
        """
    @property
    def function_blocks(self) -> IList:
        """
        Gets a list of sub-function blocks.
        """
    @property
    def input_ports(self) -> IList:
        """
        Gets a list of the function block's input ports.
        """
    @property
    def signals(self) -> IList:
        """
        Gets the list of the function block's output signals.
        """
    @property
    def signals_recursive(self) -> IList:
        """
        Gets the list of the function block's visible output signals including signals from visible child function blocks.
        """
    @property
    def status_signal(self) -> ISignal:
        """
        Gets the function block's status signal.
        """
class IFunctionBlockType(IComponentType):
    """
    Provides information about the function block.
    """
    @staticmethod
    def can_cast_from(arg0: IBaseObject) -> bool:
        ...
    @staticmethod
    def cast_from(arg0: IBaseObject) -> IFunctionBlockType:
        ...
    @staticmethod
    def convert_from(arg0: IBaseObject) -> IFunctionBlockType:
        ...
class IGraphVisualization(IBaseObject):
    """
    Represents a way to get a string representation of a graph usually in some diagram description language like DOT, mermaid or D2.
    """
    @staticmethod
    def can_cast_from(arg0: IBaseObject) -> bool:
        ...
    @staticmethod
    def cast_from(arg0: IBaseObject) -> IGraphVisualization:
        ...
    @staticmethod
    def convert_from(arg0: IBaseObject) -> IGraphVisualization:
        ...
    def dump(self) -> str:
        """
        Returns the graph representation as a string.
        """
class IInputPort(IComponent):
    """
    Signals accepted by input ports can be connected, forming a connection between the input port and signal, through which Packets can be sent.
    """
    @staticmethod
    def can_cast_from(arg0: IBaseObject) -> bool:
        ...
    @staticmethod
    def cast_from(arg0: IBaseObject) -> IInputPort:
        ...
    @staticmethod
    def convert_from(arg0: IBaseObject) -> IInputPort:
        ...
    def accepts_signal(self, signal: ISignal) -> int:
        """
        Returns true if the signal can be connected to the input port; false otherwise.
        """
    def connect(self, signal: ISignal) -> None:
        """
        Connects the signal to the input port, forming a Connection.
        """
    def disconnect(self) -> None:
        """
        Disconnects the signal from the input port.
        """
    @property
    def connection(self) -> IConnection:
        """
        Gets the Connection object formed between the Signal and Input port.
        """
    @property
    def requires_signal(self) -> int:
        """
        Returns true if the input port requires a signal to be connected; false otherwise.
        """
    @property
    def signal(self) -> ISignal:
        """
        Gets the signal connected to the input port.
        """
class IInputPortConfig(IInputPort):
    """
    The configuration component of input ports. Provides access to Input port owners to internal components of the input port.
    """
    @staticmethod
    def can_cast_from(arg0: IBaseObject) -> bool:
        ...
    @staticmethod
    def cast_from(arg0: IBaseObject) -> IInputPortConfig:
        ...
    @staticmethod
    def convert_from(arg0: IBaseObject) -> IInputPortConfig:
        ...
    def notify_packet_enqueued(self, queue_was_empty: bool) -> None:
        """
        Gets called when a packet was enqueued in a connection.
        """
    def notify_packet_enqueued_on_this_thread(self) -> None:
        """
        Gets called when a packet was enqueued in a connection.
        """
    @property
    def custom_data(self) -> typing.Any:
        """
        Get a custom data attached to the object. / Set a custom data attached to the object.
        """
    @custom_data.setter
    def custom_data(self, arg1: typing.Any) -> None:
        ...
    @property
    def gap_checking_enabled(self) -> int:
        """
        Returns the state of gap checking requested by the input port.
        """
class IInputPortNotifications(IBaseObject):
    """
    Notifications object passed to the input port on construction by its owner (listener).
    """
    @staticmethod
    def can_cast_from(arg0: IBaseObject) -> bool:
        ...
    @staticmethod
    def cast_from(arg0: IBaseObject) -> IInputPortNotifications:
        ...
    @staticmethod
    def convert_from(arg0: IBaseObject) -> IInputPortNotifications:
        ...
    def accepts_signal(self, port: IInputPort, signal: ISignal) -> int:
        """
        Called when the Input port method `acceptsSignal` is called. Should return true if the signal is accepted; false otherwise.
        """
    def connected(self, port: IInputPort) -> None:
        """
        Called when a signal is connected to the input port.
        """
    def disconnected(self, port: IInputPort) -> None:
        """
        Called when a signal is disconnected from the input port.
        """
    def packet_received(self, port: IInputPort) -> None:
        """
        Notifies the listener of the newly received packet on the specified input-port.
        """
class IInstance(IDevice):
    """
    The top-level openDAQ object. It acts as container for the openDAQ context and the base module manager.
    """
    @staticmethod
    def can_cast_from(arg0: IBaseObject) -> bool:
        ...
    @staticmethod
    def cast_from(arg0: IBaseObject) -> IInstance:
        ...
    @staticmethod
    def convert_from(arg0: IBaseObject) -> IInstance:
        ...
    def add_standard_servers(self) -> IList:
        """
        Creates and adds streaming and "OpenDAQOPCUA" servers with default configurations.
        """
    def set_root_device(self, connection_string: IString | str | IEvalValue, config: IPropertyObject = None) -> None:
        """
        Adds a device with the connection string as root device.
        """
    @property
    def available_server_types(self) -> IDict:
        """
        Get a dictionary of available server types as <IString, IServerType> pairs
        """
    @property
    def module_manager(self) -> IModuleManager:
        """
        Gets the Module manager.
        """
    @property
    def root_device(self) -> IDevice:
        """
        Gets the current root device.
        """
class IInstanceBuilder(IBaseObject):
    """
    Builder component of Instance objects. Contains setter methods to configure the Instance parameters, such as Context (Logger, Scheduler, ModuleManager) and RootDevice. Contains a  `build` method that builds the Instance object.
    """
    @staticmethod
    def can_cast_from(arg0: IBaseObject) -> bool:
        ...
    @staticmethod
    def cast_from(arg0: IBaseObject) -> IInstanceBuilder:
        ...
    @staticmethod
    def convert_from(arg0: IBaseObject) -> IInstanceBuilder:
        ...
    def add_config_provider(self, config_provider: IConfigProvider) -> None:
        """
        Populates internal options dictionary with values from set config provider
        """
    def add_discovery_server(self, server_name: IString | str | IEvalValue) -> None:
        """
        Adds a discovery server to the context
        """
    def add_logger_sink(self, sink: ILoggerSink) -> None:
        """
        Adds the logger sink of the default Instance logger. If Logger has been set, configuring of the Logger sink has no effect in building Instance.
        """
    def add_module_path(self, path: IString | str | IEvalValue) -> None:
        """
        Add the path for the default ModuleManager of the Instance. If Module manager has been set, configuring of Module path has no effect in building Instance.
        """
    def build(self) -> IInstance:
        """
        Builds and returns an Instance object using the currently set values of the Builder.
        """
    def enable_standard_providers(self, flag: bool) -> None:
        """
        Allows enabling or disabling standard configuration providers, including JsonConfigProvider, based on the specified flag.
        """
    def set_component_log_level(self, component: IString | str | IEvalValue, log_level: LogLevel) -> None:
        """
        Sets The Logger level for a specific component of the Instance. Log messages related to that component will be processed according to the specified log level.
        """
    def set_root_device(self, connection_string: IString | str | IEvalValue, config: IPropertyObject = None) -> None:
        """
        Sets the connection string for a device that replaces the default openDAQ root device. When the instance is created, a connection to the device with the given connection string will be established, and the device will be placed at the root of the component tree structure.
        """
    def set_sink_log_level(self, sink: ILoggerSink, log_level: LogLevel) -> None:
        """
        Sets the sink logger level of the default Instance logger. If Logger has been set, configuring of the Logger sink has no effect in building Instance.
        """
    @property
    def authentication_provider(self) -> IAuthenticationProvider:
        """
        Gets the AuthenticationProvider of Instance / Sets the AuthenticationProvider for the Instance.
        """
    @authentication_provider.setter
    def authentication_provider(self, arg1: IAuthenticationProvider) -> None:
        ...
    @property
    def components_log_level(self) -> IDict:
        """
        Gets the dictionary of component names and log level which will be added to logger components
        """
    @property
    def context(self) -> IContext:
        """
        Returns a context object of the instance. / Sets the Context object of the instance. This overwrites other context related settings such as logger, scheduler and module manager settings.
        """
    @context.setter
    def context(self, arg1: IContext) -> None:
        ...
    @property
    def default_root_device_info(self) -> IDeviceInfo:
        """
        Gets the default device info of Instance / Sets the default device info of Instance. If device info has been set, method getInfo of Instance will return set device info if Root Device has not been set
        """
    @default_root_device_info.setter
    def default_root_device_info(self, arg1: IDeviceInfo) -> None:
        ...
    @property
    def default_root_device_local_id(self) -> str:
        """
        Gets the default root device local id / Sets the local id for default device. Has no effect if `Root device` has been congigured.
        """
    @default_root_device_local_id.setter
    def default_root_device_local_id(self, arg1: IString | str | IEvalValue) -> None:
        ...
    @property
    def discovery_servers(self) -> IList:
        """
        Gets the dictionary of discovery servers
        """
    @property
    def global_log_level(self) -> LogLevel:
        """
        Gets the default Logger global level of Instance / Sets the Logger global log level for the Instance. All log messages with a severity level equal to or higher than the specified level will be processed.
        """
    @global_log_level.setter
    def global_log_level(self, arg1: LogLevel) -> None:
        ...
    @property
    def logger(self) -> ILogger:
        """
        Gets the Logger of the Instance. Returns nullptr if custom logger has not been set / Sets the custom Logger for the Instance. This logger will be used for logging messages related to the Instance and its components. When configured, the `Logger sink` will be ignored, as it is in use only with the default Instance logger.
        """
    @logger.setter
    def logger(self, arg1: ILogger) -> None:
        ...
    @property
    def logger_sinks(self) -> IList:
        """
        Gets the list of logger sinks for the default Instance logger.
        """
    @property
    def module_manager(self) -> IModuleManager:
        """
        Gets the custom ModuleManager of Instance / Sets The custom ModuleManager for the Instance.
        """
    @module_manager.setter
    def module_manager(self, arg1: IModuleManager) -> None:
        ...
    @property
    def module_path(self) -> str:
        """
        Gets the path for the default ModuleManager of Instance. / Sets the path for the default ModuleManager of the Instance. If Module manager has been set, configuring of Module path has no effect in building Instance.
        """
    @module_path.setter
    def module_path(self, arg1: IString | str | IEvalValue) -> None:
        ...
    @property
    def module_paths_list(self) -> IList:
        """
        Get the list of paths for the default ModuleManager of the Instance. If Module manager has been set, configuring of Module path has no effect in building Instance.
        """
    @property
    def options(self) -> IDict:
        """
        Gets the dictionary of instance options
        """
    @property
    def root_device(self) -> str:
        """
        Gets the connection string for the default root device of Instance.
        """
    @property
    def root_device_config(self) -> IPropertyObject:
        """
        Gets the configuration property object for the default root device of Instance.
        """
    @property
    def scheduler(self) -> IScheduler:
        """
        Gets the custom scheduler of Instance / Sets the custom scheduler of Instance
        """
    @scheduler.setter
    def scheduler(self, arg1: IScheduler) -> None:
        ...
    @property
    def scheduler_worker_num(self) -> int:
        """
        Gets the amount of worker threads in the scheduler of Instance. / Sets the number of worker threads in the scheduler of the Instance. If Scheduler has been set, configuring of Scheduler worker num has no effect in building Instance.
        """
    @scheduler_worker_num.setter
    def scheduler_worker_num(self, arg1: int) -> None:
        ...
class IInteger(IBaseObject):
    """
    Represents int number as `IInteger` interface. Use this interface to wrap integer variable when you need to add the number to lists, dictionaries and other containers which accept `IBaseObject` and derived interfaces.
    """
    @staticmethod
    def can_cast_from(arg0: IBaseObject) -> bool:
        ...
    @staticmethod
    def cast_from(arg0: IBaseObject) -> IInteger:
        ...
    @staticmethod
    def convert_from(arg0: IBaseObject) -> IInteger:
        ...
    @property
    def value(self) -> int:
        """
        Gets an int value stored in the object.
        """
class IIterable(IBaseObject):
    """
    An iterable object can construct iterators and use them to iterate through items.
    """
    @staticmethod
    def can_cast_from(arg0: IBaseObject) -> bool:
        ...
    @staticmethod
    def cast_from(arg0: IBaseObject) -> IIterable:
        ...
    @staticmethod
    def convert_from(arg0: IBaseObject) -> IIterable:
        ...
    def __iter__(self) -> IIterator:
        """
        Creates and returns the object's start iterator.
        """
class IIterator(IBaseObject):
    """
    Interface to iterate through items of a container object.
    """
    @staticmethod
    def can_cast_from(arg0: IBaseObject) -> bool:
        ...
    @staticmethod
    def cast_from(arg0: IBaseObject) -> IIterator:
        ...
    @staticmethod
    def convert_from(arg0: IBaseObject) -> IIterator:
        ...
    def __next__(self) -> typing.Any:
        ...
class IList(IBaseObject):
    """
    Represents a heterogeneous collection of objects that can be individually accessed by index.
    """
    @staticmethod
    def can_cast_from(arg0: IBaseObject) -> bool:
        ...
    @staticmethod
    def cast_from(arg0: IBaseObject) -> IList:
        ...
    @staticmethod
    def convert_from(arg0: IBaseObject) -> IList:
        ...
    def __delitem__(self, arg0: int) -> None:
        ...
    @typing.overload
    def __getitem__(self, arg0: int) -> typing.Any:
        ...
    @typing.overload
    def __getitem__(self, arg0: slice) -> IList:
        ...
    def __iter__(self) -> typing.Any:
        ...
    def __len__(self) -> int:
        ...
    def __repr__(self) -> str:
        ...
    def __setitem__(self, arg0: int, arg1: typing.Any) -> None:
        ...
    def __str__(self) -> str:
        ...
    def append(self, arg0: typing.Any) -> None:
        ...
    def clear(self) -> None:
        """
        Removes all elements from the list.
        """
    def pop_back(self) -> typing.Any:
        ...
    def pop_front(self) -> typing.Any:
        ...
    def push_back(self, arg0: typing.Any) -> None:
        ...
    def push_front(self, arg0: typing.Any) -> None:
        ...
class ILogFileInfo(IBaseObject):
    """
    """
    @staticmethod
    def can_cast_from(arg0: IBaseObject) -> bool:
        ...
    @staticmethod
    def cast_from(arg0: IBaseObject) -> ILogFileInfo:
        ...
    @staticmethod
    def convert_from(arg0: IBaseObject) -> ILogFileInfo:
        ...
    @property
    def description(self) -> str:
        """
        Gets the description of the log file.
        """
    @property
    def encoding(self) -> str:
        """
        Gets the encoding of the log file.
        """
    @property
    def id(self) -> str:
        """
        Gets the id of the log file in format `getLocalPath() + "/" + getName()`.
        """
    @property
    def last_modified(self) -> str:
        """
        Gets the date of the last modification of the log file in ISO 8601 format.
        """
    @property
    def local_path(self) -> str:
        """
        Gets the local path of the log file. The local path can be not assigned as it is optional.
        """
    @property
    def name(self) -> str:
        """
        Gets the name of the log file.
        """
    @property
    def size(self) -> int:
        """
        Gets the size of the log file in bytes.
        """
class ILogFileInfoBuilder(IBaseObject):
    """
    """
    @staticmethod
    def can_cast_from(arg0: IBaseObject) -> bool:
        ...
    @staticmethod
    def cast_from(arg0: IBaseObject) -> ILogFileInfoBuilder:
        ...
    @staticmethod
    def convert_from(arg0: IBaseObject) -> ILogFileInfoBuilder:
        ...
    def build(self) -> ILogFileInfo:
        """
        Builds the log file info.
        """
    @property
    def description(self) -> str:
        """
        Gets the description of the log file. / Sets the description of the log file.
        """
    @description.setter
    def description(self, arg1: IString | str | IEvalValue) -> None:
        ...
    @property
    def encoding(self) -> str:
        """
        Gets the encoding of the log file. / Sets the encoding of the log file.
        """
    @encoding.setter
    def encoding(self, arg1: IString | str | IEvalValue) -> None:
        ...
    @property
    def id(self) -> str:
        """
        Gets the id of the log file. If the local path is not assigned, the id is equal to the `localPath + "/" + name`. / Sets the id of the log file. Oth
        """
    @id.setter
    def id(self, arg1: IString | str | IEvalValue) -> None:
        ...
    @property
    def last_modified(self) -> str:
        """
        Gets the date of the last modification of the log file in ISO 8601 format. / Sets the date of the last modification of the log file in ISO 8601 format.
        """
    @last_modified.setter
    def last_modified(self, arg1: IString | str | IEvalValue) -> None:
        ...
    @property
    def local_path(self) -> str:
        """
        Gets the local path of the log file. The local path can be not assigned as it is optional. / Sets the local path of the log file. The local path can be not assigned as it is optional.
        """
    @local_path.setter
    def local_path(self, arg1: IString | str | IEvalValue) -> None:
        ...
    @property
    def name(self) -> str:
        """
        Gets the name of the log file. / Sets the name of the log file.
        """
    @name.setter
    def name(self, arg1: IString | str | IEvalValue) -> None:
        ...
    @property
    def size(self) -> int:
        """
        Gets the size of the log file in bytes. / Sets the size of the log file in bytes.
        """
    @size.setter
    def size(self, arg1: int) -> None:
        ...
class ILogger(IBaseObject):
    """
    Represents a collection of @ref ILoggerComponent "Logger Components" with multiple
    """
    @staticmethod
    def can_cast_from(arg0: IBaseObject) -> bool:
        ...
    @staticmethod
    def cast_from(arg0: IBaseObject) -> ILogger:
        ...
    @staticmethod
    def convert_from(arg0: IBaseObject) -> ILogger:
        ...
    def add_component(self, name: IString | str | IEvalValue) -> ILoggerComponent:
        """
        Creates a component with a given name and adds it to the Logger object.
        """
    def flush(self) -> None:
        """
        Triggers writing out the messages stored in temporary buffers for added components and sinks associated with the Logger object.
        """
    def flush_on_level(self, level: LogLevel) -> None:
        """
        Sets the minimum severity level of messages to be automatically flushed by components of Logger object.
        """
    def get_component(self, name: IString | str | IEvalValue) -> ILoggerComponent:
        """
        Gets an added component by name.
        """
    def get_or_add_component(self, name: IString | str | IEvalValue) -> ILoggerComponent:
        """
        Gets an added component by name or creates a new one with a given name and adds it to the Logger object.
        """
    def remove_component(self, name: IString | str | IEvalValue) -> None:
        """
        Removes the component with a given name from the Logger object.
        """
    @property
    def components(self) -> IList:
        """
        Gets a list of added components.
        """
    @property
    def level(self) -> LogLevel:
        """
        Gets the default log severity level. / Sets the default log severity level.
        """
    @level.setter
    def level(self, arg1: LogLevel) -> None:
        ...
class ILoggerComponent(IBaseObject):
    """
    Logs messages produced by a specific part of openDAC SDK. The messages are written into the @ref ILoggerSink "Logger Sinks" associated with the Logger Component object.
    """
    @staticmethod
    def can_cast_from(arg0: IBaseObject) -> bool:
        ...
    @staticmethod
    def cast_from(arg0: IBaseObject) -> ILoggerComponent:
        ...
    @staticmethod
    def convert_from(arg0: IBaseObject) -> ILoggerComponent:
        ...
    def flush(self) -> None:
        """
        Triggers writing out the messages stored in temporary buffers.
        """
    def flush_on_level(self, level: LogLevel) -> None:
        """
        Sets the minimum severity level of messages to be automatically written to the associated sinks bypassing the temporary buffers.
        """
    def log_message(self, location: ..., msg: str, level: LogLevel) -> None:
        """
        Logs a message with the provided source location and severity level.
        """
    def should_log(self, level: LogLevel) -> int:
        """
        Checks whether the messages with given log severity level will be logged or not.
        """
    @property
    def level(self) -> LogLevel:
        """
        Gets the minimal severity level of messages to be logged by the component. / Sets the minimal severity level of messages to be logged by the component.
        """
    @level.setter
    def level(self, arg1: LogLevel) -> None:
        ...
    @property
    def name(self) -> str:
        """
        Gets the name of the component.
        """
class ILoggerSink(IBaseObject):
    """
    Represents the object that actually writes the log messages to the target. Each Logger Sink is responsible for only single target: file, console etc.
    """
    @staticmethod
    def can_cast_from(arg0: IBaseObject) -> bool:
        ...
    @staticmethod
    def cast_from(arg0: IBaseObject) -> ILoggerSink:
        ...
    @staticmethod
    def convert_from(arg0: IBaseObject) -> ILoggerSink:
        ...
    def flush(self) -> None:
        """
        Triggers writing out the messages from temporary buffers to the target.
        """
    def should_log(self, level: LogLevel) -> int:
        """
        Checks whether the messages with given log severity level will be written to the target or not.
        """
    @property
    def level(self) -> LogLevel:
        """
        Gets the minimal severity level of messages to be written to the target. / Sets the minimal severity level of messages to be written to the target.
        """
    @level.setter
    def level(self, arg1: LogLevel) -> None:
        ...
class ILoggerThreadPool(IBaseObject):
    """
    Container for messages queue and backing threads used for asynchronous logging.
    """
    @staticmethod
    def can_cast_from(arg0: IBaseObject) -> bool:
        ...
    @staticmethod
    def cast_from(arg0: IBaseObject) -> ILoggerThreadPool:
        ...
    @staticmethod
    def convert_from(arg0: IBaseObject) -> ILoggerThreadPool:
        ...
class IMirroredDevice(IDevice):
    """
    Represents an openDAQ mirrored client device. Allows accessing streaming data sources associated with the device.
    """
    @staticmethod
    def can_cast_from(arg0: IBaseObject) -> bool:
        ...
    @staticmethod
    def cast_from(arg0: IBaseObject) -> IMirroredDevice:
        ...
    @staticmethod
    def convert_from(arg0: IBaseObject) -> IMirroredDevice:
        ...
    @property
    def streaming_sources(self) -> IList:
        """
        Gets a list of streaming objects representing all streaming sources of the device.
        """
class IMirroredDeviceConfig(IMirroredDevice):
    """
    Represents configuration interface for mirrored device. Allows attaching and removing streaming data sources associated with the device.
    """
    @staticmethod
    def can_cast_from(arg0: IBaseObject) -> bool:
        ...
    @staticmethod
    def cast_from(arg0: IBaseObject) -> IMirroredDeviceConfig:
        ...
    @staticmethod
    def convert_from(arg0: IBaseObject) -> IMirroredDeviceConfig:
        ...
    def add_streaming_source(self, streaming_source: IStreaming) -> None:
        """
        Adds streaming source for device.
        """
    def remove_streaming_source(self, streaming_connection_string: IString | str | IEvalValue) -> None:
        """
        Removes streaming source for device e.g. when the streaming source is no longer available.
        """
class IMirroredSignalConfig(ISignalConfig):
    """
    Represents configuration interface for mirrored signals. Allows selecting streaming data sources per signal.
    """
    @staticmethod
    def can_cast_from(arg0: IBaseObject) -> bool:
        ...
    @staticmethod
    def cast_from(arg0: IBaseObject) -> IMirroredSignalConfig:
        ...
    @staticmethod
    def convert_from(arg0: IBaseObject) -> IMirroredSignalConfig:
        ...
    def deactivate_streaming(self) -> None:
        """
        Stops the streaming and clears the active streaming source of the signal.
        """
    @property
    def active_streaming_source(self) -> str:
        """
        Gets a connection strings of the active streaming source of the signal. / Sets the active streaming source of the signal.
        """
    @active_streaming_source.setter
    def active_streaming_source(self, arg1: IString | str | IEvalValue) -> None:
        ...
    @property
    def on_subscribe_complete(self) -> IEvent:
        """
        Gets the Event that is triggered whenever the acknowledgment for signal subscription completion is received from the streaming server.
        """
    @property
    def on_unsubscribe_complete(self) -> IEvent:
        """
        Gets the Event that is triggered whenever the acknowledgment for signal unsubscription completion is received from the streaming server.
        """
    @property
    def remote_id(self) -> str:
        """
        Gets the global ID of the signal as it appears on the remote device.
        """
    @property
    def streaming_sources(self) -> IList:
        """
        Gets a list of connection strings of all available streaming sources of the signal.
        """
class IMirroredSignalPrivate(IBaseObject):
    """
    Internal functions used by openDAQ core. This interface should never be used in client SDK or module code.
    """
    mirrored_data_descriptor: IDataDescriptor
    mirrored_domain_signal: IMirroredSignalConfig
    @staticmethod
    def can_cast_from(arg0: IBaseObject) -> bool:
        ...
    @staticmethod
    def cast_from(arg0: IBaseObject) -> IMirroredSignalPrivate:
        ...
    @staticmethod
    def convert_from(arg0: IBaseObject) -> IMirroredSignalPrivate:
        ...
    def add_streaming_source(self, streaming: IStreaming) -> None:
        """
        Adds streaming source for signal.
        """
    def remove_streaming_source(self, streaming_connection_string: IString | str | IEvalValue) -> None:
        """
        Removes streaming source for signal.
        """
    def subscribe_completed(self, streaming_connection_string: IString | str | IEvalValue) -> None:
        """
        Handles the completion of subscription acknowledged by the specified streaming source.
        """
    def trigger_event(self, event_packet: IEventPacket) -> int:
        """
        Handles event packet e.g. packet with changes of the signals descriptors or signal properties
        """
    def unsubscribe_completed(self, streaming_connection_string: IString | str | IEvalValue) -> None:
        """
        Handles the completion of unsubscription acknowledged by the specified streaming source.
        """
    def unsubscribe_completed_no_lock(self, streaming_connection_string: IString | str | IEvalValue) -> None:
        """
        Acts the same as unsubscribeCompleted() but does not enter a critical section.
        """
class IModule(IBaseObject):
    """
    A module is an object that provides device and function block factories. The object is usually implemented in an external dynamic link / shared library. IModuleManager is responsible for loading all modules.
    """
    @staticmethod
    def can_cast_from(arg0: IBaseObject) -> bool:
        ...
    @staticmethod
    def cast_from(arg0: IBaseObject) -> IModule:
        ...
    @staticmethod
    def convert_from(arg0: IBaseObject) -> IModule:
        ...
    def complete_server_capability(self, source: IServerCapability, target: ...) -> int:
        ...
    def create_device(self, connection_string: IString | str | IEvalValue, parent: IComponent, config: IPropertyObject = None) -> IDevice:
        """
        Creates a device object that can communicate with the device described in the specified connection string. The device object is not automatically added as a sub-device of the caller, but only returned by reference.
        """
    def create_function_block(self, id: IString | str | IEvalValue, parent: IComponent, local_id: IString | str | IEvalValue, config: IPropertyObject = None) -> IFunctionBlock:
        """
        Creates and returns a function block with the specified id. The function block is not automatically added to the FB list of the caller.
        """
    def create_server(self, server_type_id: IString | str | IEvalValue, root_device: IDevice, config: IPropertyObject = None) -> IServer:
        """
        Creates and returns a server with the specified server type.
        """
    def create_streaming(self, connection_string: IString | str | IEvalValue, config: IPropertyObject = None) -> IStreaming:
        """
        Creates and returns a streaming object using the specified connection string and config object.
        """
    @property
    def available_device_types(self) -> IDict:
        """
        Returns a dictionary of known and available device types this module can create.
        """
    @property
    def available_devices(self) -> IList:
        """
        Returns a list of known devices info. The implementation can start discovery in background and only return the results in this function.
        """
    @property
    def available_function_block_types(self) -> IDict:
        """
        Returns a dictionary of known and available function block types this module can create.
        """
    @property
    def available_server_types(self) -> IDict:
        """
        Returns a dictionary of known and available servers types that this module can create.
        """
    @property
    def available_streaming_types(self) -> IDict:
        """
        Returns a dictionary of known and available streaming types that this module (client) can create.
        """
    @property
    def module_info(self) -> IModuleInfo:
        """
        Retrieves the module information.
        """
class IModuleInfo(IBaseObject):
    """
    Give module information composing of: - version info (major, minor, patch) - name - id.
    """
    @staticmethod
    def can_cast_from(arg0: IBaseObject) -> bool:
        ...
    @staticmethod
    def cast_from(arg0: IBaseObject) -> IModuleInfo:
        ...
    @staticmethod
    def convert_from(arg0: IBaseObject) -> IModuleInfo:
        ...
    @property
    def id(self) -> str:
        """
        Gets the module id.
        """
    @property
    def name(self) -> str:
        """
        Gets the module name.
        """
    @property
    def version_info(self) -> IVersionInfo:
        """
        Retrieves the module version information.
        """
class IModuleManager(IBaseObject):
    """
    Loads all available modules in a implementation-defined manner. User can also side-load custom modules via `addModule` call.
    """
    @staticmethod
    def can_cast_from(arg0: IBaseObject) -> bool:
        ...
    @staticmethod
    def cast_from(arg0: IBaseObject) -> IModuleManager:
        ...
    @staticmethod
    def convert_from(arg0: IBaseObject) -> IModuleManager:
        ...
    def add_module(self, module: IModule) -> None:
        """
        Side-load a custom module in run-time from memory that was not found by default.
        """
    def load_modules(self, context: IContext) -> None:
        """
        Loads all modules from the directory path specified during manager construction. The Context is passed to all loaded modules for internal use.
        """
    @property
    def modules(self) -> IList:
        """
        Retrieves all modules known to the manager. Whether they were found or side-loaded.
        """
class IMultiReader(ISampleReader):
    """
    Reads multiple Signals at once.
    """
    @staticmethod
    def can_cast_from(arg0: IBaseObject) -> bool:
        ...
    @staticmethod
    def cast_from(arg0: IBaseObject) -> IMultiReader:
        ...
    @staticmethod
    def convert_from(arg0: IBaseObject) -> IMultiReader:
        ...
    def read(self, count: int, timeout_ms: int = 0, return_status: bool = False) -> numpy.ndarray | tuple[numpy.ndarray, IMultiReaderStatus]:
        """
        Copies at maximum the next `count` unread samples to the values buffer. The amount actually read is returned through the `count` parameter.
        """
    def read_with_domain(self, count: int, timeout_ms: int = 0, return_status: bool = False) -> tuple[numpy.ndarray, numpy.ndarray] | tuple[numpy.ndarray, numpy.ndarray, IMultiReaderStatus]:
        """
        Copies at maximum the next `count` unread samples and clock-stamps to the `samples` and `domain` buffers. The amount actually read is returned through the `count` parameter.
        """
    def skip_samples(self, count: int, return_status: bool = False) -> int | tuple[int, IReaderStatus]:
        """
        Skips the specified amount of samples.
        """
    @property
    def active(self) -> int:
        """
        Gets / Sets active or inactive MultiReader state. In inactive state MultiReader will receive only event packets.
        """
    @active.setter
    def active(self, arg1: bool) -> None:
        ...
    @property
    def common_sample_rate(self) -> int:
        """
        Gets the common sample rate in case input signal have different rates. The value of common sample rate is such that sample rate of any individual signal can be represented as commonSampleRate / Div, where Div is an integer. Unless the required common sample rate is specified in the MultiReader constructor, common sample rate is lowest common multiple of individual signal's sample rates. The number of samples to be read is specified in common sample rate.
        """
    @property
    def is_synchronized(self) -> int:
        """
        Gets the synchronization status of the reader
        """
    @property
    def origin(self) -> str:
        """
        Gets the origin the reader aligned all the signals to. This is usually the earliest (lowest value) from all the signals.
        """
    @property
    def tick_resolution(self) -> IRatio:
        """
        Gets the resolution the reader aligned all the signals to. This is the highest resolution (lowest value) of all the signals to not loose the precision.
        """
class IMultiReaderBuilder(IBaseObject):
    """
    Builder component of Multi reader objects. Contains setter methods to configure the Multi reader parameters and a `build` method that builds the Unit object.
    """
    @staticmethod
    def can_cast_from(arg0: IBaseObject) -> bool:
        ...
    @staticmethod
    def cast_from(arg0: IBaseObject) -> IMultiReaderBuilder:
        ...
    @staticmethod
    def convert_from(arg0: IBaseObject) -> IMultiReaderBuilder:
        ...
    def add_input_port(self, port: IInputPort) -> None:
        """
        Adds the input port to list in multi reader
        """
    def add_signal(self, signal: ISignal) -> None:
        """
        Adds the signal to list in multi reader
        """
    def build(self) -> IMultiReader:
        """
        Builds and returns a Multi reader object using the currently set values of the Builder.
        """
    @property
    def domain_read_type(self) -> SampleType:
        """
        Gets the domain signal read type / Sets the domain signal read type
        """
    @domain_read_type.setter
    def domain_read_type(self, arg1: SampleType) -> None:
        ...
    @property
    def min_read_count(self) -> int:
        """
        Gets the minimal number of samples to read. / Sets the minimal number of samples to read.
        """
    @min_read_count.setter
    def min_read_count(self, arg1: int) -> None:
        ...
    @property
    def read_mode(self) -> ReadMode:
        """
        Gets the read mode (Unscaled, Scaled, RawValue) / Sets the read mode (Unscaled, Scaled, RawValue)
        """
    @read_mode.setter
    def read_mode(self, arg1: ReadMode) -> None:
        ...
    @property
    def read_timeout_type(self) -> ReadTimeoutType:
        """
        Gets the read timeout mode / Sets the read timeout mode
        """
    @read_timeout_type.setter
    def read_timeout_type(self, arg1: ReadTimeoutType) -> None:
        ...
    @property
    def required_common_sample_rate(self) -> int:
        """
        Gets the required common sample rate / Sets the required common sample rate
        """
    @required_common_sample_rate.setter
    def required_common_sample_rate(self, arg1: int) -> None:
        ...
    @property
    def source_components(self) -> IList:
        """
        Gets the list of input ports
        """
    @property
    def start_on_full_unit_of_domain(self) -> int:
        """
        Gets the start on full unit of domain / Sets the start on full unit of domain
        """
    @start_on_full_unit_of_domain.setter
    def start_on_full_unit_of_domain(self, arg1: bool) -> None:
        ...
    @property
    def tick_offset_tolerance(self) -> IRatio:
        """
        Get maximum distance between signals in fractions of domain unit / Set maximum distance between signals in fractions of domain unit
        """
    @tick_offset_tolerance.setter
    def tick_offset_tolerance(self, arg1: IRatio | tuple[int, int]) -> None:
        ...
    @property
    def value_read_type(self) -> SampleType:
        """
        Gets the value signal read type / Sets the value signal read type
        """
    @value_read_type.setter
    def value_read_type(self, arg1: SampleType) -> None:
        ...
class IMultiReaderStatus(IReaderStatus):
    """
    IMultiReaderStatus inherits from IReaderStatus to expand information returned read function
    """
    @staticmethod
    def can_cast_from(arg0: IBaseObject) -> bool:
        ...
    @staticmethod
    def cast_from(arg0: IBaseObject) -> IMultiReaderStatus:
        ...
    @staticmethod
    def convert_from(arg0: IBaseObject) -> IMultiReaderStatus:
        ...
    @property
    def event_packets(self) -> IDict:
        """
        Retrieves the dictionary of event packets from the reading process, ordered by signals.
        """
    @property
    def main_descriptor(self) -> IEventPacket:
        """
        Retrieves the descriptor of main signal. The main signal is the first signal in the list of signals.
        """
class INetworkInterface(IBaseObject):
    """
    Provides an interface to manipulate the configuration of a device's (server's) network interface. Offers methods to update the IP configuration and retrieve the currently active one, if the corresponding feature supported by the device. Additionally, includes a helper method to create a prebuilt property object with valid default configuration.
    """
    @staticmethod
    def can_cast_from(arg0: IBaseObject) -> bool:
        ...
    @staticmethod
    def cast_from(arg0: IBaseObject) -> INetworkInterface:
        ...
    @staticmethod
    def convert_from(arg0: IBaseObject) -> INetworkInterface:
        ...
    def create_default_configuration(self) -> IPropertyObject:
        """
        Creates a property object containing default configuration values for a network interface.
        """
    def request_current_configuration(self) -> IPropertyObject:
        """
        Requests the currently active configuration for the network interface.
        """
    def submit_configuration(self, config: IPropertyObject) -> None:
        """
        Submits a new configuration for the network interface.
        """
class INumber(IBaseObject):
    """
    Represents either a float or an int number.
    """
    @staticmethod
    def can_cast_from(arg0: IBaseObject) -> bool:
        ...
    @staticmethod
    def cast_from(arg0: IBaseObject) -> INumber:
        ...
    @staticmethod
    def convert_from(arg0: IBaseObject) -> INumber:
        ...
    def __float__(self) -> float:
        ...
    def __int__(self) -> int:
        ...
    @property
    def float_value(self) -> float:
        """
        Gets a value stored in the object as a floating point value.
        """
    @property
    def int_value(self) -> int:
        """
        Gets a value stored in the object as an integer value.
        """
class IOwnable(IBaseObject):
    """
    An ownable object can have IPropertyObject as the owner.
    """
    @staticmethod
    def can_cast_from(arg0: IBaseObject) -> bool:
        ...
    @staticmethod
    def cast_from(arg0: IBaseObject) -> IOwnable:
        ...
    @staticmethod
    def convert_from(arg0: IBaseObject) -> IOwnable:
        ...
class IPacket(IBaseObject):
    """
    Base packet type. Data, Value, and Event packets are all also packets. Provides the packet's unique ID that is unique to a given device, as well as the packet type.
    """
    @staticmethod
    def can_cast_from(arg0: IBaseObject) -> bool:
        ...
    @staticmethod
    def cast_from(arg0: IBaseObject) -> IPacket:
        ...
    @staticmethod
    def convert_from(arg0: IBaseObject) -> IPacket:
        ...
    def subscribe_for_destruct_notification(self, packet_destruct_callback: IPacketDestructCallback) -> None:
        """
        Subscribes for notification when the packet is destroyed.
        """
    @property
    def ref_count(self) -> int:
        """
        Gets the reference count of the packet.
        """
    @property
    def type(self) -> PacketType:
        """
        Gets the packet's type.
        """
class IPacketDestructCallback(IBaseObject):
    """
    Used to subscribe to packet destruction
    """
    @staticmethod
    def can_cast_from(arg0: IBaseObject) -> bool:
        ...
    @staticmethod
    def cast_from(arg0: IBaseObject) -> IPacketDestructCallback:
        ...
    @staticmethod
    def convert_from(arg0: IBaseObject) -> IPacketDestructCallback:
        ...
    def on_packet_destroyed(self) -> None:
        """
        Called when packet is destroyed.
        """
class IPacketReader(IReader):
    """
    A signal reader reads packets from a signal data stream.
    """
    @staticmethod
    def can_cast_from(arg0: IBaseObject) -> bool:
        ...
    @staticmethod
    def cast_from(arg0: IBaseObject) -> IPacketReader:
        ...
    @staticmethod
    def convert_from(arg0: IBaseObject) -> IPacketReader:
        ...
    def read(self) -> IPacket:
        """
        Retrieves the next available packet in the data-stream.
        """
    def read_all(self) -> IList:
        """
        Retrieves all the currently available packets in the data-stream.
        """
class IPermissionManager(IBaseObject):
    """
    A class which is responsible for managing permissions on an object level. Given a user's group, it is possible to restrict or allow read, write and execute permissions for each object. It is also possible to specify if permissions are inherited from parent object
    """
    @staticmethod
    def can_cast_from(arg0: IBaseObject) -> bool:
        ...
    @staticmethod
    def cast_from(arg0: IBaseObject) -> IPermissionManager:
        ...
    @staticmethod
    def convert_from(arg0: IBaseObject) -> IPermissionManager:
        ...
    def is_authorized(self, user: IUser, permission: Permission) -> int:
        """
        Check if user has a given permission on an object of the permission manager.
        """
class IPermissionMaskBuilder(IBaseObject):
    """
    A class which is responsible for creating a permission mask. This is a collection of Permission values which are allowed or denied for a given group id. Permission mask is defined as a 64-bit integer, where each bit corespond to a specific permission defined by Permission enum.
    """
    @staticmethod
    def can_cast_from(arg0: IBaseObject) -> bool:
        ...
    @staticmethod
    def cast_from(arg0: IBaseObject) -> IPermissionMaskBuilder:
        ...
    @staticmethod
    def convert_from(arg0: IBaseObject) -> IPermissionMaskBuilder:
        ...
    def build(self) -> int:
        """
        Build permission mask and return it as 64-bit integer.
        """
    def clear(self) -> None:
        """
        Removes all permissions from bit mask.
        """
    def execute(self) -> None:
        """
        Add execute permission to the bit mask.
        """
    def read(self) -> None:
        """
        Add read permission to the bit mask.
        """
    def write(self) -> None:
        """
        Add write permission to the bit mask.
        """
class IPermissions(IBaseObject):
    """
    A class which describes a permission configuration for openDAQ object.A configuration object can be constructed using the permission builder class.
    """
    @staticmethod
    def can_cast_from(arg0: IBaseObject) -> bool:
        ...
    @staticmethod
    def cast_from(arg0: IBaseObject) -> IPermissions:
        ...
    @staticmethod
    def convert_from(arg0: IBaseObject) -> IPermissions:
        ...
    @property
    def allowed(self) -> IDict:
        """
        Returns a dictionary of allowed permissions for each group.
        """
    @property
    def denied(self) -> IDict:
        """
        Returns a dictionary of denied permissions for each group.
        """
    @property
    def inherited(self) -> int:
        """
        Returns true if an object should inherit permissions from its parent object.
        """
class IPermissionsBuilder(IBaseObject):
    """
    A class which is responsible for assigning permissions to a property object. Permisison builder can specify allowed and denied permissions for each group. It can also inherit or overwrite premissions from parent objects.
    """
    @staticmethod
    def can_cast_from(arg0: IBaseObject) -> bool:
        ...
    @staticmethod
    def cast_from(arg0: IBaseObject) -> IPermissionsBuilder:
        ...
    @staticmethod
    def convert_from(arg0: IBaseObject) -> IPermissionsBuilder:
        ...
    def allow(self, group_id: IString | str | IEvalValue, permissions: IPermissionMaskBuilder) -> None:
        """
        Allow a specified set of permissions for a given group. If the inherit flag is enabled, this method will allow both the specified permissions and any permissions already allowed for the group on the parent component. Denied permissions will always overrule allowed permissions.
        """
    def assign(self, group_id: IString | str | IEvalValue, permissions: IPermissionMaskBuilder) -> None:
        """
        Strictly assign a specified set of permissions for a given group. This method allows only the specified permissions and will not inherit any permissions from the parent object for the group, even if the inherit flag is enabled.
        """
    def build(self) -> IPermissions:
        """
        Builds the permission config object.
        """
    def deny(self, group_id: IString | str | IEvalValue, permissions: IPermissionMaskBuilder) -> None:
        """
        Deny a specified set of permissions for a given group. If the inherit flag is enabled, this method will deny both the specified permissions and any permissions already denied for the group on the parent component. Denied permissions will always overrule allowed permissions.
        """
    def extend(self, config: IPermissions) -> None:
        """
        Add permissions of another permission config object and overwrite existing ones. Inherit flag will not be overwritten.
        """
    def inherit(self, inherit: bool) -> None:
        """
        Configure component to inherit or ignore permissions from the parent object.
        """
class IProcedure(IBaseObject):
    """
    Holds a callback function without return value.
    """
    @staticmethod
    def can_cast_from(arg0: IBaseObject) -> bool:
        ...
    @staticmethod
    def cast_from(arg0: IBaseObject) -> IProcedure:
        ...
    @staticmethod
    def convert_from(arg0: IBaseObject) -> IProcedure:
        ...
    def __call__(self, *args) -> None:
        ...
class IProperty(IBaseObject):
    """
    Defines a set of metadata that describes the values held by a Property object stored under the key equal to the property's name.
    """
    @staticmethod
    def can_cast_from(arg0: IBaseObject) -> bool:
        ...
    @staticmethod
    def cast_from(arg0: IBaseObject) -> IProperty:
        ...
    @staticmethod
    def convert_from(arg0: IBaseObject) -> IProperty:
        ...
    @property
    def callable_info(self) -> ICallableInfo:
        """
        Gets the Callable information objects of the Property that specifies the argument and return types of the callable object stored as the Property value.
        """
    @property
    def coercer(self) -> ICoercer:
        """
        Gets the coercer of the Property.
        """
    @property
    def default_value(self) -> typing.Any:
        """
        Gets the Default value of the Property. The Default value must always be configured for a Property to be in a valid state. Exceptions are Function/Procedure and Reference properties.
        """
    @property
    def description(self) -> str:
        """
        Gets the short string Description of the Property.
        """
    @property
    def is_referenced(self) -> int:
        """
        Used to determine whether the Property is referenced by another property.
        """
    @property
    def item_type(self) -> CoreType:
        """
        Gets the Item type of the Property. Configured only if the Value type is `ctDict` or `ctList`. If so, the item types of the list/dictionary must match the Property's Item type.
        """
    @property
    def key_type(self) -> CoreType:
        """
        Gets the Key type of the Property. Configured only if the Value type is `ctDict`. If so, the key type of the dictionary Property values must match the Property's Key type.
        """
    @property
    def max_value(self) -> INumber:
        """
        Gets the Maximum value of the Property. Available only if the Value type is `ctInt` or `ctFloat`.
        """
    @property
    def min_value(self) -> INumber:
        """
        Gets the Minimum value of the Property. Available only if the Value type is `ctInt` or `ctFloat`.
        """
    @property
    def name(self) -> str:
        """
        Gets the Name of the Property. The names of Properties in a Property object must be unique. The name is used as the key to the corresponding Property value when getting/setting the value.
        """
    @property
    def on_property_value_read(self) -> IEvent:
        """
        Gets the event object that is triggered when the corresponding Property value is read.
        """
    @property
    def on_property_value_write(self) -> IEvent:
        """
        Gets the event object that is triggered when a value is written to the corresponding Property value.
        """
    @property
    def read_only(self) -> int:
        """
        Used to determine whether the Property is a read-only property or not.
        """
    @property
    def referenced_property(self) -> IProperty:
        """
        Gets the referenced property. If set, all getters except for the `Name`, `Referenced property`, and `Is referenced` getters will return the value of the `Referenced property`.
        """
    @property
    def selection_values(self) -> typing.Any:
        """
        Gets the list or dictionary of selection values. If the list/dictionary is not empty, the property is a Selection property, and must have the Value type `ctInt`.
        """
    @property
    def struct_type(self) -> IStructType:
        """
        Gets the Struct type object of the Property, if the Property is a Struct property.
        """
    @property
    def suggested_values(self) -> IList:
        """
        Gets the list of Suggested values. Contains values that are the optimal settings for the corresponding Property value. These values, however, are not enforced when setting a new Property value.
        """
    @property
    def unit(self) -> IUnit:
        """
        Gets the Unit of the Property.
        """
    @property
    def validator(self) -> IValidator:
        """
        Gets the validator of the Property.
        """
    @property
    def value(self) -> typing.Any:
        """
        Gets the value of the Property. Available only if the Property is bound to a Property object. / Sets the value of the Property. Available only if the Property is bound to a Property object.
        """
    @value.setter
    def value(self, arg1: typing.Any) -> None:
        ...
    @property
    def value_type(self) -> CoreType:
        """
        Gets the Value type of the Property. Values written to the corresponding Property value must be of the same type.
        """
    @property
    def visible(self) -> int:
        """
        Used to determine whether the property is visible or not.
        """
class IPropertyBuilder(IBaseObject):
    """
    The builder interface of Properties. Allows for construction of Properties through the `build` method.
    """
    @staticmethod
    def can_cast_from(arg0: IBaseObject) -> bool:
        ...
    @staticmethod
    def cast_from(arg0: IBaseObject) -> IPropertyBuilder:
        ...
    @staticmethod
    def convert_from(arg0: IBaseObject) -> IPropertyBuilder:
        ...
    def build(self) -> IProperty:
        """
        Builds and returns a Property using the currently set values of the Builder.
        """
    @property
    def callable_info(self) -> ICallableInfo:
        """
        Gets the Callable information objects of the Property that specifies the argument and return types of the callable object stored as the Property value. / Sets the Callable information objects of the Property that specifies the argument and return types of the callable object stored as the Property value.
        """
    @callable_info.setter
    def callable_info(self, arg1: typing.Any) -> None:
        ...
    @property
    def coercer(self) -> ICoercer:
        """
        Gets the coercer of the Property. / Sets the coercer of the Property.
        """
    @coercer.setter
    def coercer(self, arg1: typing.Any) -> None:
        ...
    @property
    def default_value(self) -> typing.Any:
        """
        Gets the Default value of the Property. / Sets the Default value of the Property. The Default value must always be configured for a Property to be in a valid state. Exceptions are Function/Procedure and Reference properties. The function will freeze default value if it is freezable.
        """
    @default_value.setter
    def default_value(self, arg1: typing.Any) -> None:
        ...
    @property
    def description(self) -> str:
        """
        Gets the short string Description of the Property. / Sets the short string Description of the Property.
        """
    @description.setter
    def description(self, arg1: IString | str | IEvalValue) -> None:
        ...
    @property
    def max_value(self) -> INumber:
        """
        Gets the Maximum value of the Property. Available only if the Value type is `ctInt` or `ctFloat`. / Sets the Maximum value of the Property. Available only if the Value type is `ctInt` or `ctFloat`.
        """
    @max_value.setter
    def max_value(self, arg1: INumber | float | int | IEvalValue) -> None:
        ...
    @property
    def min_value(self) -> INumber:
        """
        Gets the Minimum value of the Property. Available only if the Value type is `ctInt` or `ctFloat`. / Sets the Minimum value of the Property. Available only if the Value type is `ctInt` or `ctFloat`.
        """
    @min_value.setter
    def min_value(self, arg1: INumber | float | int | IEvalValue) -> None:
        ...
    @property
    def name(self) -> str:
        """
        Gets the Name of the Property. / Sets the Name of the Property. The names of Properties in a Property object must be unique. The name is used as the key to the corresponding Property value when getting/setting the value.
        """
    @name.setter
    def name(self, arg1: IString | str | IEvalValue) -> None:
        ...
    @property
    def on_property_value_read(self) -> IEvent:
        """
        Gets a custom on-read event. Used mostly when cloning properties. / Sets a custom on-read event. Used mostly when cloning properties.
        """
    @property
    def on_property_value_write(self) -> IEvent:
        """
        Gets a custom on-write event. Used mostly when cloning properties. / Sets a custom on-write event. Used mostly when cloning properties.
        """
    @property
    def read_only(self) -> IBoolean:
        """
        Used to determine whether the Property is a read-only property or not. / Used to determine whether the Property is a read-only property or not.
        """
    @read_only.setter
    def read_only(self, arg1: IBoolean | bool | IEvalValue) -> None:
        ...
    @property
    def referenced_property(self) -> IEvalValue:
        """
        Gets the referenced property. / Sets the referenced property. If set, all getters except for the `Name`, `Referenced property`, and `Is referenced` getters will return the value of the `Referenced property`.
        """
    @referenced_property.setter
    def referenced_property(self, arg1: IEvalValue) -> None:
        ...
    @property
    def selection_values(self) -> typing.Any:
        """
        Gets the list or dictionary of selection values. / Sets the list or dictionary of selection values. If the list/dictionary is not empty, the property is a Selection property, and must have the Value type `ctInt`.
        """
    @selection_values.setter
    def selection_values(self, arg1: typing.Any) -> None:
        ...
    @property
    def suggested_values(self) -> IList:
        """
        Gets the list of Suggested values. Contains values that are the optimal gettings for the corresponding Property value. These values, however, are not enforced when getting a new Property value. / Sets the list of Suggested values. Contains values that are the optimal settings for the corresponding Property value. These values, however, are not enforced when setting a new Property value.
        """
    @suggested_values.setter
    def suggested_values(self, arg1: IList | list | IEvalValue) -> None:
        ...
    @property
    def unit(self) -> IUnit:
        """
        Gets the Unit of the Property. / Sets the Unit of the Property.
        """
    @unit.setter
    def unit(self, arg1: typing.Any) -> None:
        ...
    @property
    def validator(self) -> IValidator:
        """
        Gets the validator of the Property. / Sets the validator of the Property.
        """
    @validator.setter
    def validator(self, arg1: typing.Any) -> None:
        ...
    @property
    def value_type(self) -> CoreType:
        """
        Gets the Value type of the Property. / Sets the Value type of the Property. Values written to the corresponding Property value must be of the same type.
        """
    @value_type.setter
    def value_type(self, arg1: CoreType) -> None:
        ...
    @property
    def visible(self) -> IBoolean:
        """
        Used to determine whether the property is visible or not. / Used to determine whether the property is visible or not.
        """
    @visible.setter
    def visible(self, arg1: IBoolean | bool | IEvalValue) -> None:
        ...
class IPropertyObject(IBaseObject):
    """
    A container of Properties and their corresponding Property values.
    """
    @staticmethod
    def can_cast_from(arg0: IBaseObject) -> bool:
        ...
    @staticmethod
    def cast_from(arg0: IBaseObject) -> IPropertyObject:
        ...
    @staticmethod
    def convert_from(arg0: IBaseObject) -> IPropertyObject:
        ...
    def add_property(self, property: IProperty) -> None:
        """
        Adds the property to the Property object.
        """
    def begin_update(self) -> None:
        """
        Begins batch configuration of the object.
        """
    def clear_property_value(self, property_name: IString | str | IEvalValue) -> None:
        """
        Clears the Property value from the Property object
        """
    def end_update(self) -> None:
        """
        Ends batch configuration of the object.
        """
    def get_on_property_value_read(self, property_name: IString | str | IEvalValue) -> IEvent:
        """
        Gets the Event that is triggered whenever a Property value of a Property named `propertyName` is read.
        """
    def get_on_property_value_write(self, property_name: IString | str | IEvalValue) -> IEvent:
        """
        Gets the Event that is triggered whenever a Property value is written to the Property named `propertyName`.
        """
    def get_property(self, property_name: IString | str | IEvalValue) -> IProperty:
        """
        Gets the Property with the given `propertyName`.
        """
    def get_property_selection_value(self, property_name: IString | str | IEvalValue) -> typing.Any:
        """
        Gets the selected value of the Property, if the Property is a Selection property.
        """
    def get_property_value(self, property_name: IString | str | IEvalValue) -> typing.Any:
        """
        Gets the value of the Property with the given name.
        """
    def has_property(self, property_name: IString | str | IEvalValue) -> int:
        """
        Checks if the Property object contains a property named `propertyName`.
        """
    def remove_property(self, property_name: IString | str | IEvalValue) -> None:
        """
        Removes the Property named `propertyName` from the Property object.
        """
    def set_property_value(self, property_name: IString | str | IEvalValue, value: typing.Any) -> None:
        """
        Sets the value of the Property with the given name.
        """
    @property
    def all_properties(self) -> IList:
        """
        Returns a list of all properties contained in the Property object.
        """
    @property
    def class_name(self) -> str:
        """
        Gets the name of the class the Property object was constructed with.
        """
    @property
    def on_any_property_value_read(self) -> IEvent:
        """
        Gets the Event that is triggered whenever any Property value is read.The event is triggered after the specific Property event.
        """
    @property
    def on_any_property_value_write(self) -> IEvent:
        """
        Gets the Event that is triggered whenever any Property value is written. The event is triggered after the specific Property event.
        """
    @property
    def on_end_update(self) -> IEvent:
        """
        Gets the Event that is triggered whenever the batch configuration is applied.
        """
    @property
    def permission_manager(self) -> IPermissionManager:
        """
        Gets the permission manager of property object.
        """
    @property
    def updating(self) -> int:
        """
        Returns the state of batch configuration.
        """
    @property
    def visible_properties(self) -> IList:
        """
        Returns a list of visible properties contained in the Property object.
        """
class IPropertyObjectClass(IType):
    """
    Container of properties that can be used as a base class when instantiating a Property object.
    """
    @staticmethod
    def can_cast_from(arg0: IBaseObject) -> bool:
        ...
    @staticmethod
    def cast_from(arg0: IBaseObject) -> IPropertyObjectClass:
        ...
    @staticmethod
    def convert_from(arg0: IBaseObject) -> IPropertyObjectClass:
        ...
    def get_properties(self, include_inherited: bool) -> IList:
        """
        Gets the list of properties added to the class.
        """
    def get_property(self, property_name: IString | str | IEvalValue) -> IProperty:
        """
        Gets the class's property with the given name.
        """
    def has_property(self, property_name: IString | str | IEvalValue) -> int:
        """
        Checks if the property is registered.
        """
    @property
    def parent_name(self) -> str:
        """
        Gets the name of the parent of the property class.
        """
class IPropertyObjectClassBuilder(IBaseObject):
    """
    The builder interface of Property object classes. Allows for their modification and building of Property object classes.
    """
    @staticmethod
    def can_cast_from(arg0: IBaseObject) -> bool:
        ...
    @staticmethod
    def cast_from(arg0: IBaseObject) -> IPropertyObjectClassBuilder:
        ...
    @staticmethod
    def convert_from(arg0: IBaseObject) -> IPropertyObjectClassBuilder:
        ...
    def add_property(self, property: IProperty) -> None:
        """
        Adds a property to the class.
        """
    def build(self) -> IPropertyObjectClass:
        """
        Builds and returns a Property object class using the currently set values of the Builder.
        """
    def remove_property(self, property_name: IString | str | IEvalValue) -> None:
        """
        Removes a property with the given name from the class.
        """
    @property
    def manager(self) -> ITypeManager:
        """
        Gets a type manager
        """
    @property
    def name(self) -> str:
        """
        Gets the name of the property class. / Sets the name of the property class.
        """
    @name.setter
    def name(self, arg1: IString | str | IEvalValue) -> None:
        ...
    @property
    def parent_name(self) -> str:
        """
        Gets the name of the parent of the property class. / Gets the name of the parent of the property class.
        """
    @parent_name.setter
    def parent_name(self, arg1: IString | str | IEvalValue) -> None:
        ...
    @property
    def properties(self) -> IDict:
        """
        Gets the dictionary of properties
        """
    @property
    def property_order(self) -> IList:
        """
        Gets a custom order of properties as defined in the list of property names. / Sets a custom order of properties as defined in the list of property names.
        """
    @property_order.setter
    def property_order(self, arg1: IList | list | IEvalValue) -> None:
        ...
class IPropertyObjectProtected(IBaseObject):
    """
    Provides protected access that allows changing read-only property values of a Property object.
    """
    @staticmethod
    def can_cast_from(arg0: IBaseObject) -> bool:
        ...
    @staticmethod
    def cast_from(arg0: IBaseObject) -> IPropertyObjectProtected:
        ...
    @staticmethod
    def convert_from(arg0: IBaseObject) -> IPropertyObjectProtected:
        ...
    def clear_protected_property_value(self, property_name: IString | str | IEvalValue) -> None:
        """
        Clears a property value. Does not fail if the property is read-only.
        """
    def set_protected_property_value(self, property_name: IString | str | IEvalValue, value: typing.Any) -> None:
        """
        Sets a property value. Does not fail if the property is read-only.
        """
class IPropertyValueEventArgs(IEventArgs):
    """
    """
    value: typing.Any
    @staticmethod
    def can_cast_from(arg0: IBaseObject) -> bool:
        ...
    @staticmethod
    def cast_from(arg0: IBaseObject) -> IPropertyValueEventArgs:
        ...
    @staticmethod
    def convert_from(arg0: IBaseObject) -> IPropertyValueEventArgs:
        ...
    @property
    def is_updating(self) -> int:
        ...
    @property
    def old_value(self) -> typing.Any:
        ...
    @property
    def property(self) -> IProperty:
        ...
    @property
    def property_event_type(self) -> PropertyEventType:
        ...
class IRange(IBaseObject):
    """
    Describes a range of values between the `lowValue` and `highValue` boundaries.
    """
    @staticmethod
    def can_cast_from(arg0: IBaseObject) -> bool:
        ...
    @staticmethod
    def cast_from(arg0: IBaseObject) -> IRange:
        ...
    @staticmethod
    def convert_from(arg0: IBaseObject) -> IRange:
        ...
    @property
    def high_value(self) -> INumber:
        """
        Gets the upper boundary value of the range.
        """
    @property
    def low_value(self) -> INumber:
        """
        Gets the lower boundary value of the range.
        """
class IRatio(IBaseObject):
    """
    Represents rational number as `IRatio` interface. Use this interface to wrap rational number when you need to add the number to lists, dictionaries and other containers which accept `IBaseObject` and derived interfaces. Rational numbers are defined as numerator / denominator.
    """
    @staticmethod
    def can_cast_from(arg0: IBaseObject) -> bool:
        ...
    @staticmethod
    def cast_from(arg0: IBaseObject) -> IRatio:
        ...
    @staticmethod
    def convert_from(arg0: IBaseObject) -> IRatio:
        ...
    def simplify(self) -> typing.Any:
        """
        Simplifies rational number if possible and returns the simplified ratio as a new object.
        """
    @property
    def denominator(self) -> int:
        """
        Gets denominator part.
        """
    @property
    def numerator(self) -> int:
        """
        Gets numerator part.
        """
class IReader(IBaseObject):
    """
    A basic signal reader that simplifies accessing the signals's data stream.
    """
    @staticmethod
    def can_cast_from(arg0: IBaseObject) -> bool:
        ...
    @staticmethod
    def cast_from(arg0: IBaseObject) -> IReader:
        ...
    @staticmethod
    def convert_from(arg0: IBaseObject) -> IReader:
        ...
    @property
    def available_count(self) -> int:
        """
        Gets the number of segments available to read
        """
    @property
    def empty(self) -> int:
        """
        Checks if there is data to read.
        """
class IReaderStatus(IBaseObject):
    """
    Represents the status of the reading process returned by the reader::read function.
    """
    @staticmethod
    def can_cast_from(arg0: IBaseObject) -> bool:
        ...
    @staticmethod
    def cast_from(arg0: IBaseObject) -> IReaderStatus:
        ...
    @staticmethod
    def convert_from(arg0: IBaseObject) -> IReaderStatus:
        ...
    @property
    def event_packet(self) -> IEventPacket:
        """
        Retrieves the event packet from the reading process.
        """
    @property
    def offset(self) -> INumber:
        """
        Retrieves the offset of the the read values
        """
    @property
    def read_status(self) -> ReadStatus:
        """
        Retrieves the current reading status, indicating whether the reading process is in an "Ok" state, has encountered an Event, has failed, or is in an Unknown state.
        """
    @property
    def valid(self) -> int:
        """
        Checks the validity of the reader.
        """
class IReferenceDomainInfo(IBaseObject):
    """
    If set, gives additional information about the reference domain.
    """
    @staticmethod
    def can_cast_from(arg0: IBaseObject) -> bool:
        ...
    @staticmethod
    def cast_from(arg0: IBaseObject) -> IReferenceDomainInfo:
        ...
    @staticmethod
    def convert_from(arg0: IBaseObject) -> IReferenceDomainInfo:
        ...
    @property
    def reference_domain_id(self) -> str:
        """
        Gets the Reference Domain ID.
        """
    @property
    def reference_domain_offset(self) -> IInteger:
        """
        Gets the Reference Domain Offset.
        """
    @property
    def reference_time_source(self) -> TimeSource:
        """
        Gets the value that indicates the Reference Time Source.
        """
    @property
    def uses_offset(self) -> UsesOffset:
        """
        Gets the value that indicates if offset is used.
        """
class IReferenceDomainInfoBuilder(IBaseObject):
    """
    Builder component of Reference Domain Info objects. Contains setter methods that allow for Reference Domain Info parameter configuration, and a `build` method that builds the Reference Domain Info.
    """
    @staticmethod
    def can_cast_from(arg0: IBaseObject) -> bool:
        ...
    @staticmethod
    def cast_from(arg0: IBaseObject) -> IReferenceDomainInfoBuilder:
        ...
    @staticmethod
    def convert_from(arg0: IBaseObject) -> IReferenceDomainInfoBuilder:
        ...
    def build(self) -> IReferenceDomainInfo:
        """
        Builds and returns a Reference Domain Info object using the currently set values of the Builder.
        """
    @property
    def reference_domain_id(self) -> str:
        """
        Gets the Reference Domain ID. / Sets the Reference Domain ID.
        """
    @reference_domain_id.setter
    def reference_domain_id(self, arg1: IString | str | IEvalValue) -> None:
        ...
    @property
    def reference_domain_offset(self) -> IInteger:
        """
        Gets the Reference Domain Offset. / Sets the Reference Domain Offset.
        """
    @reference_domain_offset.setter
    def reference_domain_offset(self, arg1: IInteger | int | IEvalValue) -> None:
        ...
    @property
    def reference_time_source(self) -> TimeSource:
        """
        Gets the value that indicates the Reference Time Source. / Sets the value that indicates the Reference Time Source.
        """
    @reference_time_source.setter
    def reference_time_source(self, arg1: TimeSource) -> None:
        ...
    @property
    def uses_offset(self) -> UsesOffset:
        """
        Gets the value that indicates if offset is used. / Sets the value that indicates if offset is used.
        """
    @uses_offset.setter
    def uses_offset(self, arg1: UsesOffset) -> None:
        ...
class IRemovable(IBaseObject):
    """
    Allows the component to be notified when it is removed.
    """
    @staticmethod
    def can_cast_from(arg0: IBaseObject) -> bool:
        ...
    @staticmethod
    def cast_from(arg0: IBaseObject) -> IRemovable:
        ...
    @staticmethod
    def convert_from(arg0: IBaseObject) -> IRemovable:
        ...
    def remove(self) -> None:
        """
        Notifies the component that it is being removed.
        """
    @property
    def removed(self) -> int:
        """
        Returns True if component was removed.
        """
class ISampleReader(IReader):
    """
    A basic signal reader that simplifies reading the signals's samples.
    """
    @staticmethod
    def can_cast_from(arg0: IBaseObject) -> bool:
        ...
    @staticmethod
    def cast_from(arg0: IBaseObject) -> ISampleReader:
        ...
    @staticmethod
    def convert_from(arg0: IBaseObject) -> ISampleReader:
        ...
    @property
    def domain_read_type(self) -> SampleType:
        """
        Gets the sample-type the signal domain samples will be converted to when read or @c SampleType::Invalid if read-type has not been determined yet.
        """
    @property
    def read_mode(self) -> ReadMode:
        """
        Gets the reader's read mode which determines if the reader will also scale the read data or not.
        """
    @property
    def value_read_type(self) -> SampleType:
        """
        Gets the sample-type the signal value samples will be converted to when read or @c SampleType::Invalid if read-type has not been determined yet.
        """
class IScaling(IBaseObject):
    """
    Signal descriptor field that defines a scaling transformation, which should be applied to data carried by the signal's packets when read.
    """
    @staticmethod
    def can_cast_from(arg0: IBaseObject) -> bool:
        ...
    @staticmethod
    def cast_from(arg0: IBaseObject) -> IScaling:
        ...
    @staticmethod
    def convert_from(arg0: IBaseObject) -> IScaling:
        ...
    @property
    def input_sample_type(self) -> SampleType:
        """
        Gets the scaling's input data type.
        """
    @property
    def output_sample_type(self) -> ScaledSampleType:
        """
        Gets the scaling's output data type.
        """
    @property
    def parameters(self) -> IDict:
        """
        Gets the dictionary of parameters that are used to calculate the scaling in conjunction with the input data.
        """
    @property
    def type(self) -> ScalingType:
        """
        Gets the type of the scaling that determines how the scaling parameters should be interpreted and how the scaling should be calculated.
        """
class IScalingBuilder(IBaseObject):
    """
    Configuration component of Scaling objects. Contains setter methods that allow for Scaling parameter configuration, and a `build` method that builds the Scaling object.
    """
    @staticmethod
    def can_cast_from(arg0: IBaseObject) -> bool:
        ...
    @staticmethod
    def cast_from(arg0: IBaseObject) -> IScalingBuilder:
        ...
    @staticmethod
    def convert_from(arg0: IBaseObject) -> IScalingBuilder:
        ...
    def add_parameter(self, name: IString | str | IEvalValue, parameter: typing.Any) -> None:
        """
        Adds a string-object pair parameter to the Dictionary of Scaling parameters.
        """
    def build(self) -> IScaling:
        """
        Builds and returns a Scaling object using the currently set values of the Builder.
        """
    def remove_parameter(self, name: IString | str | IEvalValue) -> None:
        """
        Removes the parameter with the given name from the Dictionary of Scaling parameters.
        """
    @property
    def input_data_type(self) -> SampleType:
        """
        Gets the scaling's input data type. / Sets the scaling's input data type.
        """
    @input_data_type.setter
    def input_data_type(self, arg1: SampleType) -> None:
        ...
    @property
    def output_data_type(self) -> ScaledSampleType:
        """
        Gets the scaling's output data type. / Sets the scaling's output data type.
        """
    @output_data_type.setter
    def output_data_type(self, arg1: ScaledSampleType) -> None:
        ...
    @property
    def parameters(self) -> IDict:
        """
        Gets the list of parameters that are used to calculate the scaling in conjunction with the input data. / Gets the list of parameters that are used to calculate the scaling in conjunction with the input data.
        """
    @parameters.setter
    def parameters(self, arg1: IDict | dict) -> None:
        ...
    @property
    def scaling_type(self) -> ScalingType:
        """
        Gets the type of the scaling that determines how the scaling parameters should be interpreted and how the scaling should be calculated. / Sets the type of the scaling that determines how the scaling parameters should be interpreted and how the scaling should be calculated.
        """
    @scaling_type.setter
    def scaling_type(self, arg1: ScalingType) -> None:
        ...
class IScheduler(IBaseObject):
    """
    A thread-pool scheduler that supports scheduling one-off functions as well as dependency graphs.
    """
    @staticmethod
    def can_cast_from(arg0: IBaseObject) -> bool:
        ...
    @staticmethod
    def cast_from(arg0: IBaseObject) -> IScheduler:
        ...
    @staticmethod
    def convert_from(arg0: IBaseObject) -> IScheduler:
        ...
    def schedule_function(self, function: IFunction) -> IAwaitable:
        """
        Schedules the specified @p work function to run on the thread-pool. The call does not block but immediately returns an @p awaitable that represents the asynchronous execution. It can be waited upon and queried for status and result.
        """
    def schedule_graph(self, graph: ITaskGraph) -> IAwaitable:
        """
        Schedules the specified dependency @p graph to run on the thread-pool. The call does not block but immediately returns an @p awaitable that represents the asynchronous execution. It can be waited upon and queried for status and result. <b>Any exceptions that occur during the graph execution are silently ignored.</b>
        """
    def schedule_work(self, work: ...) -> None:
        """
        Schedules the specified work callback to run on the thread-pool. The call does not block.
        """
    def stop(self) -> None:
        """
        Cancels all outstanding work and waits for the remaining to complete. After this point the scheduler does not allow any new work or graphs for scheduling.
        """
    def wait_all(self) -> None:
        """
        Waits fo all current scheduled work and tasks to complete.
        """
    @property
    def multi_threaded(self) -> int:
        """
        Returns whether more than one worker thread is used.
        """
class ISearchFilter(IBaseObject):
    """
    Search filter that can be passed as an optional parameter to openDAQ tree traversal functions to filter out unwanted results. Allows for recursive searches.
    """
    @staticmethod
    def can_cast_from(arg0: IBaseObject) -> bool:
        ...
    @staticmethod
    def cast_from(arg0: IBaseObject) -> ISearchFilter:
        ...
    @staticmethod
    def convert_from(arg0: IBaseObject) -> ISearchFilter:
        ...
    def accepts_component(self, component: IComponent) -> int:
        """
        Defines whether or not the component should be included in the search results
        """
    def visit_children(self, component: IComponent) -> int:
        """
        Defines whether or not the children of said component should be traversed during a recursive search.
        """
class IServer(IFolder):
    """
    Represents a server. The server provides access to the openDAQ device. Depend of the implementation, it can support configuring the device, reading configuration, and data streaming.
    """
    @staticmethod
    def can_cast_from(arg0: IBaseObject) -> bool:
        ...
    @staticmethod
    def cast_from(arg0: IBaseObject) -> IServer:
        ...
    @staticmethod
    def convert_from(arg0: IBaseObject) -> IServer:
        ...
    def enable_discovery(self) -> None:
        """
        Enables the server to be discovered by the clients.
        """
    def get_signals(self, search_filter: ISearchFilter = None) -> IList:
        """
        Gets a list of the server's signals.
        """
    def stop(self) -> None:
        """
        Stops the server. This is called when we remove the server from the Instance or Instance is closing.
        """
    @property
    def id(self) -> str:
        """
        Gets the server id.
        """
    @property
    def signals(self) -> IList:
        """
        Gets a list of the server's signals.
        """
class IServerCapability(IPropertyObject):
    """
    Represents standard information about a server's capability to support various protocols. The Server Capability object functions as a Property Object, facilitating the inclusion of custom properties of String, Int, Bool, or Float types. This interface serves to store essential details regarding the supported protocol by a device. It adheres to a standardized set of properties, including methods to retrieve information such as the connection string, protocol name, protocol type, connection type, and core events enabled.
    """
    @staticmethod
    def can_cast_from(arg0: IBaseObject) -> bool:
        ...
    @staticmethod
    def cast_from(arg0: IBaseObject) -> IServerCapability:
        ...
    @staticmethod
    def convert_from(arg0: IBaseObject) -> IServerCapability:
        ...
    @property
    def address_info(self) -> IList:
        """
        Gets the list of address information objects.
        """
    @property
    def addresses(self) -> IList:
        """
        Gets the device's list of addresses with the current protocol.
        """
    @property
    def connection_string(self) -> str:
        """
        Gets the connection string of the device with the current protocol.
        """
    @property
    def connection_strings(self) -> IList:
        """
        Gets the connection string of the device with the current protocol.
        """
    @property
    def connection_type(self) -> str:
        """
        Gets the type of connection supported by the device.
        """
    @property
    def core_events_enabled(self) -> int:
        """
        Gets the client update method supported by the device.
        """
    @property
    def port(self) -> IInteger:
        """
        Gets the port of the device with the current protocol.
        """
    @property
    def prefix(self) -> str:
        """
        Gets the prefix of the connection string (eg. "daq.nd" or "daq.opcua")
        """
    @property
    def protocol_id(self) -> str:
        """
        Gets the id of the protocol supported by the device. Should not contain spaces or special characters except for '_' and '-'.
        """
    @property
    def protocol_name(self) -> str:
        """
        Gets the name of the protocol supported by the device.
        """
    @property
    def protocol_type(self) -> ProtocolType:
        """
        Gets the type of protocol supported by the device.
        """
    @property
    def protocol_version(self) -> str:
        """
        Gets the protocol version supported by the device's protocol.
        """
class IServerType(IComponentType):
    """
    Provides information about the server.
    """
    @staticmethod
    def can_cast_from(arg0: IBaseObject) -> bool:
        ...
    @staticmethod
    def cast_from(arg0: IBaseObject) -> IServerType:
        ...
    @staticmethod
    def convert_from(arg0: IBaseObject) -> IServerType:
        ...
class ISignal(IComponent):
    """
    A signal with an unique ID that sends event/data packets through connections to input ports the signal is connected to.
    """
    @staticmethod
    def can_cast_from(arg0: IBaseObject) -> bool:
        ...
    @staticmethod
    def cast_from(arg0: IBaseObject) -> ISignal:
        ...
    @staticmethod
    def convert_from(arg0: IBaseObject) -> ISignal:
        ...
    @property
    def connections(self) -> IList:
        """
        Gets the list of connections to input ports formed by the signal.
        """
    @property
    def descriptor(self) -> IDataDescriptor:
        """
        Gets the signal's data descriptor.
        """
    @property
    def domain_signal(self) -> ISignal:
        """
        Gets the signal that carries its domain data.
        """
    @property
    def last_value(self) -> typing.Any:
        """
        Gets the signal last value.
        """
    @property
    def public(self) -> int:
        """
        Returns true if the signal is public; false otherwise. / Sets the signal to be either public or private.
        """
    @public.setter
    def public(self, arg1: bool) -> None:
        ...
    @property
    def related_signals(self) -> IList:
        """
        Gets a list of related signals.
        """
    @property
    def streamed(self) -> int:
        """
        Returns true if the signal is streamed; false otherwise. / Sets the signal to be either streamed or not.
        """
    @streamed.setter
    def streamed(self, arg1: bool) -> None:
        ...
class ISignalConfig(ISignal):
    """
    The configuration component of a Signal. Allows for configuration of its properties, managing its streaming sources, and sending packets through its connections.
    """
    @staticmethod
    def can_cast_from(arg0: IBaseObject) -> bool:
        ...
    @staticmethod
    def cast_from(arg0: IBaseObject) -> ISignalConfig:
        ...
    @staticmethod
    def convert_from(arg0: IBaseObject) -> ISignalConfig:
        ...
    def add_related_signal(self, signal: ISignal) -> None:
        """
        Adds a related signal to the list of related signals.
        """
    def clear_related_signals(self) -> None:
        """
        Clears the list of related signals.
        """
    def remove_related_signal(self, signal: ISignal) -> None:
        """
        Removes a signal from the list of related signal.
        """
    def send_packet(self, packet: IPacket) -> None:
        """
        Sends a packet through all connections of the signal.
        """
    def send_packets(self, packets: IList | list | IEvalValue) -> None:
        """
        Sends multiple packets through all connections of the signal.
        """
class ISignalEvents(IBaseObject):
    """
    Internal functions of a signal containing event methods that are called on certain events. Eg. when a signal is connected to an input port, or when a signal is used as a domain signal of another.
    """
    @staticmethod
    def can_cast_from(arg0: IBaseObject) -> bool:
        ...
    @staticmethod
    def cast_from(arg0: IBaseObject) -> ISignalEvents:
        ...
    @staticmethod
    def convert_from(arg0: IBaseObject) -> ISignalEvents:
        ...
    def domain_signal_reference_removed(self, signal: ISignal) -> None:
        """
        Notifies the signal that it is no longer being used as a domain signal by the signal passed as the function argument.
        """
    def domain_signal_reference_set(self, signal: ISignal) -> None:
        """
        Notifies the signal that it is being used as a domain signal by the signal passed as the function argument.
        """
    def listener_connected(self, connection: IConnection) -> None:
        """
        Notifies the signal that it has been connected to an input port forming a new connection.
        """
    def listener_disconnected(self, connection: IConnection) -> None:
        """
        Notifies the signal that it has been disconnected from an input port with the given connection.
        """
class ISimpleType(IType):
    """
    Simple type created from a CoreType. The name of the type matches that of the CoreType used for its construction (eg. ctInt == "int"
    """
    @staticmethod
    def can_cast_from(arg0: IBaseObject) -> bool:
        ...
    @staticmethod
    def cast_from(arg0: IBaseObject) -> ISimpleType:
        ...
    @staticmethod
    def convert_from(arg0: IBaseObject) -> ISimpleType:
        ...
class IStreamReader(ISampleReader):
    """
    A signal data reader that abstracts away reading of signal packets by keeping an internal read-position and automatically advances it on subsequent reads.
    """
    @staticmethod
    def can_cast_from(arg0: IBaseObject) -> bool:
        ...
    @staticmethod
    def cast_from(arg0: IBaseObject) -> IStreamReader:
        ...
    @staticmethod
    def convert_from(arg0: IBaseObject) -> IStreamReader:
        ...
    def read(self, count: int, timeout_ms: int = 0, return_status: bool = False) -> numpy.ndarray | tuple[numpy.ndarray, IReaderStatus]:
        """
        Copies at maximum the next `count` unread samples to the values buffer. The amount actually read is returned through the `count` parameter.
        """
    def read_with_domain(self, count: int, timeout_ms: int = 0, return_status: bool = False) -> tuple[numpy.ndarray, numpy.ndarray] | tuple[numpy.ndarray, numpy.ndarray, IReaderStatus]:
        """
        Copies at maximum the next `count` unread samples and clock-stamps to the `values` and `stamps` buffers. The amount actually read is returned through the `count` parameter.
        """
    def skip_samples(self, count: int, return_status: bool = False) -> int | tuple[int, IReaderStatus]:
        """
        Skips the specified amount of samples.
        """
class IStreamReaderBuilder(IBaseObject):
    """
    Builder component of Stream reader objects. Contains setter methods to configure the Stream reader parameters and a `build` method that builds the Unit object.
    """
    @staticmethod
    def can_cast_from(arg0: IBaseObject) -> bool:
        ...
    @staticmethod
    def cast_from(arg0: IBaseObject) -> IStreamReaderBuilder:
        ...
    @staticmethod
    def convert_from(arg0: IBaseObject) -> IStreamReaderBuilder:
        ...
    def build(self) -> IStreamReader:
        """
        Builds and returns a Stream reader object using the currently set values of the Builder.
        """
    @property
    def domain_read_type(self) -> SampleType:
        """
        Gets the domain signal read type / Sets the domain signal read type
        """
    @domain_read_type.setter
    def domain_read_type(self, arg1: SampleType) -> None:
        ...
    @property
    def input_port(self) -> IInputPort:
        """
        Gets the input port / Sets the input port to stream reader
        """
    @input_port.setter
    def input_port(self, arg1: IInputPort) -> None:
        ...
    @property
    def read_mode(self) -> ReadMode:
        """
        Gets the read mode (Unscaled, Scaled, RawValue) / Sets the read mode (Unscaled, Scaled, RawValue)
        """
    @read_mode.setter
    def read_mode(self, arg1: ReadMode) -> None:
        ...
    @property
    def read_timeout_type(self) -> ReadTimeoutType:
        """
        Gets the read timeout mode / Sets the read timeout mode
        """
    @read_timeout_type.setter
    def read_timeout_type(self, arg1: ReadTimeoutType) -> None:
        ...
    @property
    def signal(self) -> ISignal:
        """
        Gets the signal / Sets the signal to stream reader
        """
    @signal.setter
    def signal(self, arg1: ISignal) -> None:
        ...
    @property
    def skip_events(self) -> int:
        """
        Gets the skip events / Sets the skip events
        """
    @skip_events.setter
    def skip_events(self, arg1: bool) -> None:
        ...
    @property
    def value_read_type(self) -> SampleType:
        """
        Gets the value signal read type / Sets the value signal read type
        """
    @value_read_type.setter
    def value_read_type(self, arg1: SampleType) -> None:
        ...
class IStreaming(IBaseObject):
    """
    Represents the client-side part of a streaming service responsible for initiating communication with the openDAQ device streaming server and processing the received data. Wraps the client-side implementation details of the particular data transfer protocol used by openDAQ to send processed/acquired data from devices running an openDAQ Server to an openDAQ Client.
    """
    @staticmethod
    def can_cast_from(arg0: IBaseObject) -> bool:
        ...
    @staticmethod
    def cast_from(arg0: IBaseObject) -> IStreaming:
        ...
    @staticmethod
    def convert_from(arg0: IBaseObject) -> IStreaming:
        ...
    def add_signals(self, signals: IList | list | IEvalValue) -> None:
        """
        Adds signals to the Streaming.
        """
    def remove_all_signals(self) -> None:
        """
        Removes all added signals from the Streaming.
        """
    def remove_signals(self, signals: IList | list | IEvalValue) -> None:
        """
        Removes signals from the Streaming.
        """
    @property
    def active(self) -> int:
        """
        Gets the active state of the Streaming. / Sets the Streaming to be either active or inactive.
        """
    @active.setter
    def active(self, arg1: bool) -> None:
        ...
    @property
    def connection_status(self) -> IEnumeration:
        """
        Retrieves the current status of the streaming connection.
        """
    @property
    def connection_string(self) -> str:
        """
        Gets the string representation of a connection address used to connect to the streaming service of the device.
        """
class IStreamingType(IComponentType):
    """
    Provides information on what streaming type can be created by a given module. Can be used to obtain the default configuration used when either adding/creating a new device, or establishing a new streaming connection.
    """
    @staticmethod
    def can_cast_from(arg0: IBaseObject) -> bool:
        ...
    @staticmethod
    def cast_from(arg0: IBaseObject) -> IStreamingType:
        ...
    @staticmethod
    def convert_from(arg0: IBaseObject) -> IStreamingType:
        ...
    @property
    def connection_string_prefix(self) -> str:
        ...
class IString(IBaseObject):
    """
    Represents string variable as `IString` interface. Use this interface to wrap string variable when you need to add the variable to lists, dictionaries and other containers which accept `IBaseObject` and derived interfaces.
    """
    @staticmethod
    def can_cast_from(arg0: IBaseObject) -> bool:
        ...
    @staticmethod
    def cast_from(arg0: IBaseObject) -> IString:
        ...
    @staticmethod
    def convert_from(arg0: IBaseObject) -> IString:
        ...
    @property
    def length(self) -> int:
        """
        Gets length of string.
        """
class IStruct(IBaseObject):
    """
    Structs are immutable objects that contain a set of key-value pairs. The key, as well as the types of each associated value for each struct are defined in advance within a Struct type that has the same name as the Struct.
    """
    @staticmethod
    def can_cast_from(arg0: IBaseObject) -> bool:
        ...
    @staticmethod
    def cast_from(arg0: IBaseObject) -> IStruct:
        ...
    @staticmethod
    def convert_from(arg0: IBaseObject) -> IStruct:
        ...
    def __delattr__(self, name: str) -> None:
        """
        Deletes the field with the given name.
        """
    def __getattr__(self, name: str) -> typing.Any:
        """
        Gets the value of a field with the given name.
        """
    def __setattr__(self, name: str, value: typing.Any) -> None:
        """
        Sets the value of a field with the given name.
        """
    def get(self, name: str) -> typing.Any:
        """
        Gets the value of a field with the given name.
        """
    def has_field(self, name: str) -> int:
        """
        Checks whether a field with the given name exists in the Struct
        """
    @property
    def as_dictionary(self) -> IDict:
        """
        Gets the field names and values of the Struct as a Dictionary.
        """
    @property
    def field_names(self) -> IList:
        """
        Gets a list of all Struct field names.
        """
    @property
    def field_values(self) -> IList:
        """
        Gets a list of all Struct field values.
        """
    @property
    def struct_type(self) -> IStructType:
        """
        Gets the Struct's type.
        """
class IStructBuilder(IBaseObject):
    """
    Builder component of Struct objects. Contains setter methods to configure the Struct parameters, and a `build` method that builds the Struct object.
    """
    @staticmethod
    def can_cast_from(arg0: IBaseObject) -> bool:
        ...
    @staticmethod
    def cast_from(arg0: IBaseObject) -> IStructBuilder:
        ...
    @staticmethod
    def convert_from(arg0: IBaseObject) -> IStructBuilder:
        ...
    def build(self) -> IStruct:
        """
        Builds and returns a Struct object using the currently set values of the Builder.
        """
    def get(self, name: str) -> typing.Any:
        """
        Gets the value of a field with the given name.
        """
    def has_field(self, name: str) -> int:
        """
        Checks whether a field with the given name exists in the Struct
        """
    def set(self, name: str, field: typing.Any) -> None:
        """
        Sets the value of a field with the given name.
        """
    @property
    def as_dictionary(self) -> IDict:
        """
        Gets the field names and values of the Struct as a Dictionary.
        """
    @property
    def field_names(self) -> IList:
        """
        Gets a list of all Struct field names.
        """
    @property
    def field_values(self) -> IList:
        """
        Gets a list of all Struct field values. / Gets a list of all Struct field values.
        """
    @field_values.setter
    def field_values(self, arg1: IList) -> None:
        ...
    @property
    def struct_type(self) -> IStructType:
        """
        Gets the Struct's type.
        """
class IStructType(IType):
    """
    Struct types define the fields (names and value types, as well as optional default values) of Structs with a name matching that of the Struct type.
    """
    @staticmethod
    def can_cast_from(arg0: IBaseObject) -> bool:
        ...
    @staticmethod
    def cast_from(arg0: IBaseObject) -> IStructType:
        ...
    @staticmethod
    def convert_from(arg0: IBaseObject) -> IStructType:
        ...
    @property
    def field_default_values(self) -> IList:
        """
        Gets the list of field default values.
        """
    @property
    def field_names(self) -> IList:
        """
        Gets the list of field names.
        """
    @property
    def field_types(self) -> IList:
        """
        Gets the list of field types.
        """
class ISubscriptionEventArgs(IEventArgs):
    """
    """
    @staticmethod
    def can_cast_from(arg0: IBaseObject) -> bool:
        ...
    @staticmethod
    def cast_from(arg0: IBaseObject) -> ISubscriptionEventArgs:
        ...
    @staticmethod
    def convert_from(arg0: IBaseObject) -> ISubscriptionEventArgs:
        ...
    @property
    def streaming_connection_string(self) -> str:
        ...
    @property
    def subscription_event_type(self) -> SubscriptionEventType:
        ...
class ISyncComponent(IComponent):
    """
    Interface representing a Synchronization Component in a Test & Measurement system. A SynchronizationComponent ensures synchronization among measurement devices in the system. It can act as a sync source and/or as a sync output, with each component having one sync input and 0 to n sync outputs.
    """
    @staticmethod
    def can_cast_from(arg0: IBaseObject) -> bool:
        ...
    @staticmethod
    def cast_from(arg0: IBaseObject) -> ISyncComponent:
        ...
    @staticmethod
    def convert_from(arg0: IBaseObject) -> ISyncComponent:
        ...
    @property
    def interfaces(self) -> IDict:
        """
        Retrieves the list of interfaces associated with this synchronization component.
        """
    @property
    def selected_source(self) -> int:
        """
        Retrieves the selected sync source interface. / Sets the selected sync source interface.
        """
    @selected_source.setter
    def selected_source(self, arg1: int) -> None:
        ...
    @property
    def sync_locked(self) -> int:
        """
        Retrieves the synchronization lock status.
        """
class ISyncComponentPrivate(IBaseObject):
    """
    Interface representing a Synchronization Component in a Test & Measurement system. A SynchronizationComponent ensures synchronization among measurement devices in the system. It can act as a sync source and/or as a sync output, with each component having one sync input and 0 to n sync outputs.
    """
    @staticmethod
    def can_cast_from(arg0: IBaseObject) -> bool:
        ...
    @staticmethod
    def cast_from(arg0: IBaseObject) -> ISyncComponentPrivate:
        ...
    @staticmethod
    def convert_from(arg0: IBaseObject) -> ISyncComponentPrivate:
        ...
    def add_interface(self, sync_interface: IPropertyObject) -> None:
        """
        Adds an interface to the synchronization component.
        """
    def remove_interface(self, sync_interface_name: IString | str | IEvalValue) -> None:
        """
        Removes an interface from the synchronization component.
        """
class ITags(IBaseObject):
    """
    List of string tags. Provides helpers to get and search the list of tags.
    """
    @staticmethod
    def can_cast_from(arg0: IBaseObject) -> bool:
        ...
    @staticmethod
    def cast_from(arg0: IBaseObject) -> ITags:
        ...
    @staticmethod
    def convert_from(arg0: IBaseObject) -> ITags:
        ...
    def contains(self, name: IString | str | IEvalValue) -> int:
        """
        Checks whether a tag is present in the list of tags.
        """
    def query(self, query: IString | str | IEvalValue) -> int:
        """
        Queries the list of tags, creating an EvalValue expression from the `query` string. Returns true if the list of tags matches the query, false otherwise.
        """
    @property
    def list(self) -> IList:
        """
        Gets the list of all tags in the list.
        """
class ITagsPrivate(IBaseObject):
    """
    Private interface to component tags. Allows for adding/removing tags.
    """
    @staticmethod
    def can_cast_from(arg0: IBaseObject) -> bool:
        ...
    @staticmethod
    def cast_from(arg0: IBaseObject) -> ITagsPrivate:
        ...
    @staticmethod
    def convert_from(arg0: IBaseObject) -> ITagsPrivate:
        ...
    def add(self, name: IString | str | IEvalValue) -> None:
        """
        Adds a new tag to the list.
        """
    def remove(self, name: IString | str | IEvalValue) -> None:
        """
        Removes a new tag from the list.
        """
    def replace(self, tags: IList | list | IEvalValue) -> None:
        """
        Replaces all tags.
        """
class ITailReader(ISampleReader):
    """
    A reader that only ever reads the last N samples, subsequent calls may result in overlapping data.
    """
    @staticmethod
    def can_cast_from(arg0: IBaseObject) -> bool:
        ...
    @staticmethod
    def cast_from(arg0: IBaseObject) -> ITailReader:
        ...
    @staticmethod
    def convert_from(arg0: IBaseObject) -> ITailReader:
        ...
    def read(self, count: int, return_status: bool = False) -> numpy.ndarray | tuple[numpy.ndarray, ITailReaderStatus]:
        """
        Copies at maximum the next `count` unread samples to the values buffer. The amount actually read is returned through the `count` parameter.
        """
    def read_with_domain(self, count: int, return_status: bool = False) -> tuple[numpy.ndarray, numpy.ndarray] | tuple[numpy.ndarray, numpy.ndarray, ITailReaderStatus]:
        """
        Copies at maximum the next `count` unread samples and clock-stamps to the `values` and `stamps` buffers. The amount actually read is returned through the `count` parameter.
        """
    @property
    def history_size(self) -> int:
        """
        The maximum amount of samples in history to keep.
        """
class ITailReaderBuilder(IBaseObject):
    """
    Builder component of Tail reader objects. Contains setter methods to configure the Tail reader parameters and a `build` method that builds the Unit object.
    """
    @staticmethod
    def can_cast_from(arg0: IBaseObject) -> bool:
        ...
    @staticmethod
    def cast_from(arg0: IBaseObject) -> ITailReaderBuilder:
        ...
    @staticmethod
    def convert_from(arg0: IBaseObject) -> ITailReaderBuilder:
        ...
    def build(self) -> ITailReader:
        """
        Builds and returns a Tail reader object using the currently set values of the Builder.
        """
    @property
    def domain_read_type(self) -> SampleType:
        """
        Gets the domain signal read type / Sets the domain signal read type
        """
    @domain_read_type.setter
    def domain_read_type(self, arg1: SampleType) -> None:
        ...
    @property
    def history_size(self) -> int:
        """
        Gets the history size / Sets the history size
        """
    @history_size.setter
    def history_size(self, arg1: int) -> None:
        ...
    @property
    def input_port(self) -> IInputPort:
        """
        Gets the input port / Sets the input port to tail reader
        """
    @input_port.setter
    def input_port(self, arg1: IInputPort) -> None:
        ...
    @property
    def read_mode(self) -> ReadMode:
        """
        Gets the read mode (Unscaled, Scaled, RawValue) / Sets the read mode (Unscaled, Scaled, RawValue)
        """
    @read_mode.setter
    def read_mode(self, arg1: ReadMode) -> None:
        ...
    @property
    def signal(self) -> ISignal:
        """
        Gets the signal / Sets the signal to tail reader
        """
    @signal.setter
    def signal(self, arg1: ISignal) -> None:
        ...
    @property
    def skip_events(self) -> int:
        """
        Gets the skip events / Sets the skip events
        """
    @skip_events.setter
    def skip_events(self, arg1: bool) -> None:
        ...
    @property
    def value_read_type(self) -> SampleType:
        """
        Gets the value signal read type / Sets the value signal read type
        """
    @value_read_type.setter
    def value_read_type(self, arg1: SampleType) -> None:
        ...
class ITailReaderStatus(IReaderStatus):
    """
    ITailReaderStatus inherits from IReaderStatus to expand information returned read function
    """
    @staticmethod
    def can_cast_from(arg0: IBaseObject) -> bool:
        ...
    @staticmethod
    def cast_from(arg0: IBaseObject) -> ITailReaderStatus:
        ...
    @staticmethod
    def convert_from(arg0: IBaseObject) -> ITailReaderStatus:
        ...
    @property
    def sufficient_history(self) -> int:
        ...
class ITask(IBaseObject):
    """
    A packaged callback with possible continuations and dependencies that can be arranged in a dependency graph (directed acyclic graph). The task is not executed directly but only when the graph is scheduled for execution and all dependencies have been satisfied.
    """
    @staticmethod
    def can_cast_from(arg0: IBaseObject) -> bool:
        ...
    @staticmethod
    def cast_from(arg0: IBaseObject) -> ITask:
        ...
    @staticmethod
    def convert_from(arg0: IBaseObject) -> ITask:
        ...
    def then(self, continuation: ITask) -> None:
        """
        Sets the continuation to only execute after this task completes. Be careful of forming cycles as tasks whose dependencies cannot be satisfied will never execute.
        """
    @property
    def name(self) -> str:
        """
        Gets the task name. / Sets the task name that is used in diagnostics.
        """
    @name.setter
    def name(self, arg1: IString | str | IEvalValue) -> None:
        ...
class ITaskGraph(ITask):
    """
    A dependency graph (directed acyclic graph) of tasks that can be scheduled for execution on a Scheduler.
    """
    @staticmethod
    def can_cast_from(arg0: IBaseObject) -> bool:
        ...
    @staticmethod
    def cast_from(arg0: IBaseObject) -> ITaskGraph:
        ...
    @staticmethod
    def convert_from(arg0: IBaseObject) -> ITaskGraph:
        ...
class IType(IBaseObject):
    """
    The base object type that is inherited by all Types (eg. Struct type, Simple type, Property object class) in openDAQ.
    """
    @staticmethod
    def can_cast_from(arg0: IBaseObject) -> bool:
        ...
    @staticmethod
    def cast_from(arg0: IBaseObject) -> IType:
        ...
    @staticmethod
    def convert_from(arg0: IBaseObject) -> IType:
        ...
    @property
    def name(self) -> str:
        """
        Gets the name of the Type
        """
class ITypeManager(IBaseObject):
    """
    Container for Type objects. The Type manager is used when creating certain types of objects (eg. Structs and Property object classes). The Types stored within the manager contain pre-defined fields, as well as constraints specifying how objects should look.
    """
    @staticmethod
    def can_cast_from(arg0: IBaseObject) -> bool:
        ...
    @staticmethod
    def cast_from(arg0: IBaseObject) -> ITypeManager:
        ...
    @staticmethod
    def convert_from(arg0: IBaseObject) -> ITypeManager:
        ...
    def add_type(self, type: IType) -> None:
        """
        Adds a type to the manager.
        """
    def get_type(self, type_name: str) -> IType | IEnumerationType:
        """
        Gets an added Type by name.
        """
    def has_type(self, type_name: str) -> int:
        """
        Checks if a type with the specified name is already added.
        """
    def remove_type(self, type_name: str) -> None:
        """
        Removes the type from the manager.
        """
    @property
    def types(self) -> IList:
        """
        Gets a list of all added Types.
        """
class IUnit(IBaseObject):
    """
    Describes a measurement unit with IDs as defined in <a href="https://unece.org/trade/cefact/UNLOCODE-Download">Codes for Units of Measurement used in International Trade</a>.
    """
    @staticmethod
    def can_cast_from(arg0: IBaseObject) -> bool:
        ...
    @staticmethod
    def cast_from(arg0: IBaseObject) -> IUnit:
        ...
    @staticmethod
    def convert_from(arg0: IBaseObject) -> IUnit:
        ...
    @property
    def id(self) -> int:
        """
        Gets the unit ID as defined in <a href="https://unece.org/trade/cefact/UNLOCODE-Download">Codes for Units of Measurement used in International Trade</a>.
        """
    @property
    def name(self) -> str:
        """
        Gets the full name of the unit, i.e. "meters per second".
        """
    @property
    def quantity(self) -> str:
        """
        Gets the quantity represented by the unit, i.e. "Velocity"
        """
    @property
    def symbol(self) -> str:
        """
        Gets the symbol of the unit, i.e. "m/s".
        """
class IUnitBuilder(IBaseObject):
    """
    Builder component of Unit objects. Contains setter methods to configure the Unit parameters, and a `build` method that builds the Unit object.
    """
    @staticmethod
    def can_cast_from(arg0: IBaseObject) -> bool:
        ...
    @staticmethod
    def cast_from(arg0: IBaseObject) -> IUnitBuilder:
        ...
    @staticmethod
    def convert_from(arg0: IBaseObject) -> IUnitBuilder:
        ...
    def build(self) -> IUnit:
        """
        Builds and returns a Unit object using the currently set values of the Builder.
        """
    @property
    def id(self) -> int:
        """
        Gets the unit ID as defined in <a href="https://unece.org/trade/cefact/UNLOCODE-Download">Codes for Units of Measurement used in International Trade</a>. / Sets the unit ID as defined in <a href="https://unece.org/trade/cefact/UNLOCODE-Download">Codes for Units of Measurement used in International Trade</a>.
        """
    @id.setter
    def id(self, arg1: int) -> None:
        ...
    @property
    def name(self) -> str:
        """
        Gets the full name of the unit, i.e. "meters per second". / Sets the full name of the unit, i.e. "meters per second".
        """
    @name.setter
    def name(self, arg1: IString | str | IEvalValue) -> None:
        ...
    @property
    def quantity(self) -> str:
        """
        Gets the quantity represented by the unit, i.e. "Velocity" / Sets the quantity represented by the unit, i.e. "Velocity"
        """
    @quantity.setter
    def quantity(self, arg1: IString | str | IEvalValue) -> None:
        ...
    @property
    def symbol(self) -> str:
        """
        Gets the symbol of the unit, i.e. "m/s". / Sets the symbol of the unit, i.e. "m/s".
        """
    @symbol.setter
    def symbol(self, arg1: IString | str | IEvalValue) -> None:
        ...
class IUpdateParameters(IPropertyObject):
    """
    IUpdateParameters interface provides a set of methods to give user flexibility to load instance configuration.
    """
    @staticmethod
    def can_cast_from(arg0: IBaseObject) -> bool:
        ...
    @staticmethod
    def cast_from(arg0: IBaseObject) -> IUpdateParameters:
        ...
    @staticmethod
    def convert_from(arg0: IBaseObject) -> IUpdateParameters:
        ...
    @property
    def re_add_devices_enabled(self) -> int:
        """
        Returns whether the re-add devices is enabled. If enabled, the devices will be re-added in update process. / Sets the re-add devices enabled flag.
        """
    @re_add_devices_enabled.setter
    def re_add_devices_enabled(self, arg1: bool) -> None:
        ...
class IUser(IBaseObject):
    """
    An immutable structure which describes an openDAQ user. It holds username, password as a hash string and a list of groups assigned to the user.
    """
    @staticmethod
    def can_cast_from(arg0: IBaseObject) -> bool:
        ...
    @staticmethod
    def cast_from(arg0: IBaseObject) -> IUser:
        ...
    @staticmethod
    def convert_from(arg0: IBaseObject) -> IUser:
        ...
    @property
    def groups(self) -> IList:
        """
        Returns a list of group IDs which the user belongs to.
        """
    @property
    def username(self) -> str:
        """
        Returns the username as a string.
        """
class IValidator(IBaseObject):
    """
    Used by openDAQ properties to validate whether a value fits the value restrictions of the Property.
    """
    @staticmethod
    def can_cast_from(arg0: IBaseObject) -> bool:
        ...
    @staticmethod
    def cast_from(arg0: IBaseObject) -> IValidator:
        ...
    @staticmethod
    def convert_from(arg0: IBaseObject) -> IValidator:
        ...
    def validate(self, prop_obj: typing.Any, value: typing.Any) -> None:
        """
        Checks whether `value` adheres to the validity conditions of the validator.
        """
    def validate_no_lock(self, prop_obj: typing.Any, value: typing.Any) -> None:
        ...
    @property
    def eval(self) -> str:
        """
        Gets the string expression used when creating the validator.
        """
class IVersionInfo(IBaseObject):
    """
    Represents a semantic version composing of: - major version representing breaking changes - minor version representing new features - patch version representing only bug fixes.
    """
    @staticmethod
    def can_cast_from(arg0: IBaseObject) -> bool:
        ...
    @staticmethod
    def cast_from(arg0: IBaseObject) -> IVersionInfo:
        ...
    @staticmethod
    def convert_from(arg0: IBaseObject) -> IVersionInfo:
        ...
    @property
    def major(self) -> int:
        """
        The major version incremented at breaking changes.
        """
    @property
    def minor(self) -> int:
        """
        The minor version incremented at new features with full backwards compatibility.
        """
    @property
    def patch(self) -> int:
        """
        The patch version incremented when only bug-fixes are added.
        """
class LogLevel:
    """
    Members:
    
      Trace
    
      Debug
    
      Info
    
      Warn
    
      Error
    
      Critical
    
      Off
    
      Default
    """
    Critical: typing.ClassVar[LogLevel]  # value = <LogLevel.Critical: 5>
    Debug: typing.ClassVar[LogLevel]  # value = <LogLevel.Debug: 1>
    Default: typing.ClassVar[LogLevel]  # value = <LogLevel.Default: 7>
    Error: typing.ClassVar[LogLevel]  # value = <LogLevel.Error: 4>
    Info: typing.ClassVar[LogLevel]  # value = <LogLevel.Info: 2>
    Off: typing.ClassVar[LogLevel]  # value = <LogLevel.Off: 6>
    Trace: typing.ClassVar[LogLevel]  # value = <LogLevel.Trace: 0>
    Warn: typing.ClassVar[LogLevel]  # value = <LogLevel.Warn: 3>
    __members__: typing.ClassVar[dict[str, LogLevel]]  # value = {'Trace': <LogLevel.Trace: 0>, 'Debug': <LogLevel.Debug: 1>, 'Info': <LogLevel.Info: 2>, 'Warn': <LogLevel.Warn: 3>, 'Error': <LogLevel.Error: 4>, 'Critical': <LogLevel.Critical: 5>, 'Off': <LogLevel.Off: 6>, 'Default': <LogLevel.Default: 7>}
    def __eq__(self, other: typing.Any) -> bool:
        ...
    def __getstate__(self) -> int:
        ...
    def __hash__(self) -> int:
        ...
    def __index__(self) -> int:
        ...
    def __init__(self, value: int) -> None:
        ...
    def __int__(self) -> int:
        ...
    def __ne__(self, other: typing.Any) -> bool:
        ...
    def __repr__(self) -> str:
        ...
    def __setstate__(self, state: int) -> None:
        ...
    def __str__(self) -> str:
        ...
    @property
    def name(self) -> str:
        ...
    @property
    def value(self) -> int:
        ...
class MockSignal:
    """
    A mock signal that can be used for testing purposes.
    """
    @staticmethod
    def current_epoch() -> str:
        """
        Returns the current epoch in the format 'YYYY-MM-DDTHH:MM:SS+ZZZZ'.
        """
    @staticmethod
    def wait_for_ms(arg0: int, arg1: bool) -> None:
        """
        Waits for the given amount of milliseconds with or without releasing the GIL.
        """
    def __init__(self, id: str = 'mock', epoch: str = '', initialize_value_descriptor: bool = True) -> None:
        """
        Constructs a mock signal.
        """
    def add_data(self, data: numpy.ndarray[numpy.float64]) -> None:
        """
        Adds the given data to the signal.
        """
    def add_objects(self, objects: typing.Any, update_descriptor: bool = True) -> None:
        """
        Adds the given data objects to the signal. Should be either a list or a dictionary. Only int and float are supported.
        """
    @property
    def domain_signal(self) -> ISignalConfig:
        """
        The domain signal.
        """
    @property
    def signal(self) -> ISignalConfig:
        """
        The value signal.
        """
class OperationModeType:
    """
    Members:
    
      Unknown
    
      Idle
    
      Operation
    
      SafeOperation
    """
    Idle: typing.ClassVar[OperationModeType]  # value = <OperationModeType.Idle: 1>
    Operation: typing.ClassVar[OperationModeType]  # value = <OperationModeType.Operation: 2>
    SafeOperation: typing.ClassVar[OperationModeType]  # value = <OperationModeType.SafeOperation: 3>
    Unknown: typing.ClassVar[OperationModeType]  # value = <OperationModeType.Unknown: 0>
    __members__: typing.ClassVar[dict[str, OperationModeType]]  # value = {'Unknown': <OperationModeType.Unknown: 0>, 'Idle': <OperationModeType.Idle: 1>, 'Operation': <OperationModeType.Operation: 2>, 'SafeOperation': <OperationModeType.SafeOperation: 3>}
    def __eq__(self, other: typing.Any) -> bool:
        ...
    def __getstate__(self) -> int:
        ...
    def __hash__(self) -> int:
        ...
    def __index__(self) -> int:
        ...
    def __init__(self, value: int) -> None:
        ...
    def __int__(self) -> int:
        ...
    def __ne__(self, other: typing.Any) -> bool:
        ...
    def __repr__(self) -> str:
        ...
    def __setstate__(self, state: int) -> None:
        ...
    def __str__(self) -> str:
        ...
    @property
    def name(self) -> str:
        ...
    @property
    def value(self) -> int:
        ...
class PacketReadyNotification:
    """
    Members:
    
      None
    
      SameThread
    
      Scheduler
    
      SchedulerQueueWasEmpty
    """
    None: typing.ClassVar[PacketReadyNotification]  # value = <PacketReadyNotification.None: 0>
    SameThread: typing.ClassVar[PacketReadyNotification]  # value = <PacketReadyNotification.SameThread: 1>
    Scheduler: typing.ClassVar[PacketReadyNotification]  # value = <PacketReadyNotification.Scheduler: 2>
    SchedulerQueueWasEmpty: typing.ClassVar[PacketReadyNotification]  # value = <PacketReadyNotification.SchedulerQueueWasEmpty: 3>
    __members__: typing.ClassVar[dict[str, PacketReadyNotification]]  # value = {'None': <PacketReadyNotification.None: 0>, 'SameThread': <PacketReadyNotification.SameThread: 1>, 'Scheduler': <PacketReadyNotification.Scheduler: 2>, 'SchedulerQueueWasEmpty': <PacketReadyNotification.SchedulerQueueWasEmpty: 3>}
    def __eq__(self, other: typing.Any) -> bool:
        ...
    def __getstate__(self) -> int:
        ...
    def __hash__(self) -> int:
        ...
    def __index__(self) -> int:
        ...
    def __init__(self, value: int) -> None:
        ...
    def __int__(self) -> int:
        ...
    def __ne__(self, other: typing.Any) -> bool:
        ...
    def __repr__(self) -> str:
        ...
    def __setstate__(self, state: int) -> None:
        ...
    def __str__(self) -> str:
        ...
    @property
    def name(self) -> str:
        ...
    @property
    def value(self) -> int:
        ...
class PacketType:
    """
    Members:
    
      None
    
      Data
    
      Event
    """
    Data: typing.ClassVar[PacketType]  # value = <PacketType.Data: 1>
    Event: typing.ClassVar[PacketType]  # value = <PacketType.Event: 2>
    None: typing.ClassVar[PacketType]  # value = <PacketType.None: 0>
    __members__: typing.ClassVar[dict[str, PacketType]]  # value = {'None': <PacketType.None: 0>, 'Data': <PacketType.Data: 1>, 'Event': <PacketType.Event: 2>}
    def __eq__(self, other: typing.Any) -> bool:
        ...
    def __getstate__(self) -> int:
        ...
    def __hash__(self) -> int:
        ...
    def __index__(self) -> int:
        ...
    def __init__(self, value: int) -> None:
        ...
    def __int__(self) -> int:
        ...
    def __ne__(self, other: typing.Any) -> bool:
        ...
    def __repr__(self) -> str:
        ...
    def __setstate__(self, state: int) -> None:
        ...
    def __str__(self) -> str:
        ...
    @property
    def name(self) -> str:
        ...
    @property
    def value(self) -> int:
        ...
class Permission:
    """
    Members:
    
      None
    
      Read
    
      Write
    
      Execute
    """
    Execute: typing.ClassVar[Permission]  # value = <Permission.Execute: 4>
    None: typing.ClassVar[Permission]  # value = <Permission.None: 0>
    Read: typing.ClassVar[Permission]  # value = <Permission.Read: 1>
    Write: typing.ClassVar[Permission]  # value = <Permission.Write: 2>
    __members__: typing.ClassVar[dict[str, Permission]]  # value = {'None': <Permission.None: 0>, 'Read': <Permission.Read: 1>, 'Write': <Permission.Write: 2>, 'Execute': <Permission.Execute: 4>}
    def __eq__(self, other: typing.Any) -> bool:
        ...
    def __getstate__(self) -> int:
        ...
    def __hash__(self) -> int:
        ...
    def __index__(self) -> int:
        ...
    def __init__(self, value: int) -> None:
        ...
    def __int__(self) -> int:
        ...
    def __ne__(self, other: typing.Any) -> bool:
        ...
    def __repr__(self) -> str:
        ...
    def __setstate__(self, state: int) -> None:
        ...
    def __str__(self) -> str:
        ...
    @property
    def name(self) -> str:
        ...
    @property
    def value(self) -> int:
        ...
class PropertyEventType:
    """
    Members:
    
      Update
    
      Clear
    
      Read
    """
    Clear: typing.ClassVar[PropertyEventType]  # value = <PropertyEventType.Clear: 1>
    Read: typing.ClassVar[PropertyEventType]  # value = <PropertyEventType.Read: 2>
    Update: typing.ClassVar[PropertyEventType]  # value = <PropertyEventType.Update: 0>
    __members__: typing.ClassVar[dict[str, PropertyEventType]]  # value = {'Update': <PropertyEventType.Update: 0>, 'Clear': <PropertyEventType.Clear: 1>, 'Read': <PropertyEventType.Read: 2>}
    def __eq__(self, other: typing.Any) -> bool:
        ...
    def __getstate__(self) -> int:
        ...
    def __hash__(self) -> int:
        ...
    def __index__(self) -> int:
        ...
    def __init__(self, value: int) -> None:
        ...
    def __int__(self) -> int:
        ...
    def __ne__(self, other: typing.Any) -> bool:
        ...
    def __repr__(self) -> str:
        ...
    def __setstate__(self, state: int) -> None:
        ...
    def __str__(self) -> str:
        ...
    @property
    def name(self) -> str:
        ...
    @property
    def value(self) -> int:
        ...
class ProtocolType:
    """
    Members:
    
      Unknown
    
      Configuration
    
      Streaming
    
      ConfigurationAndStreaming
    """
    Configuration: typing.ClassVar[ProtocolType]  # value = <ProtocolType.Configuration: 1>
    ConfigurationAndStreaming: typing.ClassVar[ProtocolType]  # value = <ProtocolType.ConfigurationAndStreaming: 3>
    Streaming: typing.ClassVar[ProtocolType]  # value = <ProtocolType.Streaming: 2>
    Unknown: typing.ClassVar[ProtocolType]  # value = <ProtocolType.Unknown: 0>
    __members__: typing.ClassVar[dict[str, ProtocolType]]  # value = {'Unknown': <ProtocolType.Unknown: 0>, 'Configuration': <ProtocolType.Configuration: 1>, 'Streaming': <ProtocolType.Streaming: 2>, 'ConfigurationAndStreaming': <ProtocolType.ConfigurationAndStreaming: 3>}
    def __eq__(self, other: typing.Any) -> bool:
        ...
    def __getstate__(self) -> int:
        ...
    def __hash__(self) -> int:
        ...
    def __index__(self) -> int:
        ...
    def __init__(self, value: int) -> None:
        ...
    def __int__(self) -> int:
        ...
    def __ne__(self, other: typing.Any) -> bool:
        ...
    def __repr__(self) -> str:
        ...
    def __setstate__(self, state: int) -> None:
        ...
    def __str__(self) -> str:
        ...
    @property
    def name(self) -> str:
        ...
    @property
    def value(self) -> int:
        ...
class ReadMode:
    """
    Members:
    
      Unscaled
    
      Scaled
    
      RawValue
    """
    RawValue: typing.ClassVar[ReadMode]  # value = <ReadMode.RawValue: 2>
    Scaled: typing.ClassVar[ReadMode]  # value = <ReadMode.Scaled: 1>
    Unscaled: typing.ClassVar[ReadMode]  # value = <ReadMode.Unscaled: 0>
    __members__: typing.ClassVar[dict[str, ReadMode]]  # value = {'Unscaled': <ReadMode.Unscaled: 0>, 'Scaled': <ReadMode.Scaled: 1>, 'RawValue': <ReadMode.RawValue: 2>}
    def __eq__(self, other: typing.Any) -> bool:
        ...
    def __getstate__(self) -> int:
        ...
    def __hash__(self) -> int:
        ...
    def __index__(self) -> int:
        ...
    def __init__(self, value: int) -> None:
        ...
    def __int__(self) -> int:
        ...
    def __ne__(self, other: typing.Any) -> bool:
        ...
    def __repr__(self) -> str:
        ...
    def __setstate__(self, state: int) -> None:
        ...
    def __str__(self) -> str:
        ...
    @property
    def name(self) -> str:
        ...
    @property
    def value(self) -> int:
        ...
class ReadStatus:
    """
    Members:
    
      Ok
    
      Event
    
      Fail
    
      Unknown
    """
    Event: typing.ClassVar[ReadStatus]  # value = <ReadStatus.Event: 1>
    Fail: typing.ClassVar[ReadStatus]  # value = <ReadStatus.Fail: 2>
    Ok: typing.ClassVar[ReadStatus]  # value = <ReadStatus.Ok: 0>
    Unknown: typing.ClassVar[ReadStatus]  # value = <ReadStatus.Unknown: 65535>
    __members__: typing.ClassVar[dict[str, ReadStatus]]  # value = {'Ok': <ReadStatus.Ok: 0>, 'Event': <ReadStatus.Event: 1>, 'Fail': <ReadStatus.Fail: 2>, 'Unknown': <ReadStatus.Unknown: 65535>}
    def __eq__(self, other: typing.Any) -> bool:
        ...
    def __getstate__(self) -> int:
        ...
    def __hash__(self) -> int:
        ...
    def __index__(self) -> int:
        ...
    def __init__(self, value: int) -> None:
        ...
    def __int__(self) -> int:
        ...
    def __ne__(self, other: typing.Any) -> bool:
        ...
    def __repr__(self) -> str:
        ...
    def __setstate__(self, state: int) -> None:
        ...
    def __str__(self) -> str:
        ...
    @property
    def name(self) -> str:
        ...
    @property
    def value(self) -> int:
        ...
class ReadTimeoutType:
    """
    Members:
    
      Any
    
      All
    """
    All: typing.ClassVar[ReadTimeoutType]  # value = <ReadTimeoutType.All: 1>
    Any: typing.ClassVar[ReadTimeoutType]  # value = <ReadTimeoutType.Any: 0>
    __members__: typing.ClassVar[dict[str, ReadTimeoutType]]  # value = {'Any': <ReadTimeoutType.Any: 0>, 'All': <ReadTimeoutType.All: 1>}
    def __eq__(self, other: typing.Any) -> bool:
        ...
    def __getstate__(self) -> int:
        ...
    def __hash__(self) -> int:
        ...
    def __index__(self) -> int:
        ...
    def __init__(self, value: int) -> None:
        ...
    def __int__(self) -> int:
        ...
    def __ne__(self, other: typing.Any) -> bool:
        ...
    def __repr__(self) -> str:
        ...
    def __setstate__(self, state: int) -> None:
        ...
    def __str__(self) -> str:
        ...
    @property
    def name(self) -> str:
        ...
    @property
    def value(self) -> int:
        ...
class SampleType:
    """
    Members:
    
      Invalid
    
      Undefined
    
      Float32
    
      Float64
    
      UInt8
    
      Int8
    
      UInt16
    
      Int16
    
      UInt32
    
      Int32
    
      UInt64
    
      Int64
    
      RangeInt64
    
      ComplexFloat32
    
      ComplexFloat64
    
      Binary
    
      String
    
      Struct
    """
    Binary: typing.ClassVar[SampleType]  # value = <SampleType.Binary: 14>
    ComplexFloat32: typing.ClassVar[SampleType]  # value = <SampleType.ComplexFloat32: 12>
    ComplexFloat64: typing.ClassVar[SampleType]  # value = <SampleType.ComplexFloat64: 13>
    Float32: typing.ClassVar[SampleType]  # value = <SampleType.Float32: 1>
    Float64: typing.ClassVar[SampleType]  # value = <SampleType.Float64: 2>
    Int16: typing.ClassVar[SampleType]  # value = <SampleType.Int16: 6>
    Int32: typing.ClassVar[SampleType]  # value = <SampleType.Int32: 8>
    Int64: typing.ClassVar[SampleType]  # value = <SampleType.Int64: 10>
    Int8: typing.ClassVar[SampleType]  # value = <SampleType.Int8: 4>
    Invalid: typing.ClassVar[SampleType]  # value = <SampleType.Invalid: 0>
    RangeInt64: typing.ClassVar[SampleType]  # value = <SampleType.RangeInt64: 11>
    String: typing.ClassVar[SampleType]  # value = <SampleType.String: 15>
    Struct: typing.ClassVar[SampleType]  # value = <SampleType.Struct: 16>
    UInt16: typing.ClassVar[SampleType]  # value = <SampleType.UInt16: 5>
    UInt32: typing.ClassVar[SampleType]  # value = <SampleType.UInt32: 7>
    UInt64: typing.ClassVar[SampleType]  # value = <SampleType.UInt64: 9>
    UInt8: typing.ClassVar[SampleType]  # value = <SampleType.UInt8: 3>
    Undefined: typing.ClassVar[SampleType]  # value = <SampleType.Invalid: 0>
    __members__: typing.ClassVar[dict[str, SampleType]]  # value = {'Invalid': <SampleType.Invalid: 0>, 'Undefined': <SampleType.Invalid: 0>, 'Float32': <SampleType.Float32: 1>, 'Float64': <SampleType.Float64: 2>, 'UInt8': <SampleType.UInt8: 3>, 'Int8': <SampleType.Int8: 4>, 'UInt16': <SampleType.UInt16: 5>, 'Int16': <SampleType.Int16: 6>, 'UInt32': <SampleType.UInt32: 7>, 'Int32': <SampleType.Int32: 8>, 'UInt64': <SampleType.UInt64: 9>, 'Int64': <SampleType.Int64: 10>, 'RangeInt64': <SampleType.RangeInt64: 11>, 'ComplexFloat32': <SampleType.ComplexFloat32: 12>, 'ComplexFloat64': <SampleType.ComplexFloat64: 13>, 'Binary': <SampleType.Binary: 14>, 'String': <SampleType.String: 15>, 'Struct': <SampleType.Struct: 16>}
    def __eq__(self, other: typing.Any) -> bool:
        ...
    def __getstate__(self) -> int:
        ...
    def __hash__(self) -> int:
        ...
    def __index__(self) -> int:
        ...
    def __init__(self, value: int) -> None:
        ...
    def __int__(self) -> int:
        ...
    def __ne__(self, other: typing.Any) -> bool:
        ...
    def __repr__(self) -> str:
        ...
    def __setstate__(self, state: int) -> None:
        ...
    def __str__(self) -> str:
        ...
    @property
    def name(self) -> str:
        ...
    @property
    def value(self) -> int:
        ...
class ScaledSampleType:
    """
    Members:
    
      Invalid
    
      Float32
    
      Float64
    """
    Float32: typing.ClassVar[ScaledSampleType]  # value = <ScaledSampleType.Float32: 1>
    Float64: typing.ClassVar[ScaledSampleType]  # value = <ScaledSampleType.Float64: 2>
    Invalid: typing.ClassVar[ScaledSampleType]  # value = <ScaledSampleType.Invalid: 0>
    __members__: typing.ClassVar[dict[str, ScaledSampleType]]  # value = {'Invalid': <ScaledSampleType.Invalid: 0>, 'Float32': <ScaledSampleType.Float32: 1>, 'Float64': <ScaledSampleType.Float64: 2>}
    def __eq__(self, other: typing.Any) -> bool:
        ...
    def __getstate__(self) -> int:
        ...
    def __hash__(self) -> int:
        ...
    def __index__(self) -> int:
        ...
    def __init__(self, value: int) -> None:
        ...
    def __int__(self) -> int:
        ...
    def __ne__(self, other: typing.Any) -> bool:
        ...
    def __repr__(self) -> str:
        ...
    def __setstate__(self, state: int) -> None:
        ...
    def __str__(self) -> str:
        ...
    @property
    def name(self) -> str:
        ...
    @property
    def value(self) -> int:
        ...
class ScalingType:
    """
    Members:
    
      Other
    
      Linear
    """
    Linear: typing.ClassVar[ScalingType]  # value = <ScalingType.Linear: 1>
    Other: typing.ClassVar[ScalingType]  # value = <ScalingType.Other: 0>
    __members__: typing.ClassVar[dict[str, ScalingType]]  # value = {'Other': <ScalingType.Other: 0>, 'Linear': <ScalingType.Linear: 1>}
    def __eq__(self, other: typing.Any) -> bool:
        ...
    def __getstate__(self) -> int:
        ...
    def __hash__(self) -> int:
        ...
    def __index__(self) -> int:
        ...
    def __init__(self, value: int) -> None:
        ...
    def __int__(self) -> int:
        ...
    def __ne__(self, other: typing.Any) -> bool:
        ...
    def __repr__(self) -> str:
        ...
    def __setstate__(self, state: int) -> None:
        ...
    def __str__(self) -> str:
        ...
    @property
    def name(self) -> str:
        ...
    @property
    def value(self) -> int:
        ...
class SubscriptionEventType:
    """
    Members:
    
      Subscribed
    
      Unsubscribed
    """
    Subscribed: typing.ClassVar[SubscriptionEventType]  # value = <SubscriptionEventType.Subscribed: 0>
    Unsubscribed: typing.ClassVar[SubscriptionEventType]  # value = <SubscriptionEventType.Unsubscribed: 1>
    __members__: typing.ClassVar[dict[str, SubscriptionEventType]]  # value = {'Subscribed': <SubscriptionEventType.Subscribed: 0>, 'Unsubscribed': <SubscriptionEventType.Unsubscribed: 1>}
    def __eq__(self, other: typing.Any) -> bool:
        ...
    def __getstate__(self) -> int:
        ...
    def __hash__(self) -> int:
        ...
    def __index__(self) -> int:
        ...
    def __init__(self, value: int) -> None:
        ...
    def __int__(self) -> int:
        ...
    def __ne__(self, other: typing.Any) -> bool:
        ...
    def __repr__(self) -> str:
        ...
    def __setstate__(self, state: int) -> None:
        ...
    def __str__(self) -> str:
        ...
    @property
    def name(self) -> str:
        ...
    @property
    def value(self) -> int:
        ...
class TimeBlockReader:
    """
    A wrapper for block signal data reader that provides the ability to read samples with timestamps.
    """
    def __init__(self, arg0: IBlockReader) -> None:
        ...
    def read_with_timestamps(self, count: int, timeout_ms: int = 0, return_status: bool = False) -> tuple[numpy.ndarray, numpy.ndarray] | tuple[numpy.ndarray, numpy.ndarray, IBlockReaderStatus]:
        """
        Returns the next `count` unread blocks of samples and clock-stamps.
        """
class TimeMultiReader:
    """
    A wrapper for multi signal data reader that provides the ability to read samples with timestamps.
    """
    def __init__(self, arg0: IMultiReader) -> None:
        ...
    def read_with_timestamps(self, count: int, timeout_ms: int = 0, return_status: bool = False) -> tuple[numpy.ndarray, numpy.ndarray] | tuple[numpy.ndarray, numpy.ndarray, IMultiReaderStatus]:
        """
        Returns the next `count` unread samples and clock-stamps.
        """
class TimeSource:
    """
    Members:
    
      Unknown
    
      Tai
    
      Gps
    
      Utc
    """
    Gps: typing.ClassVar[TimeSource]  # value = <TimeSource.Gps: 2>
    Tai: typing.ClassVar[TimeSource]  # value = <TimeSource.Tai: 1>
    Unknown: typing.ClassVar[TimeSource]  # value = <TimeSource.Unknown: 0>
    Utc: typing.ClassVar[TimeSource]  # value = <TimeSource.Utc: 3>
    __members__: typing.ClassVar[dict[str, TimeSource]]  # value = {'Unknown': <TimeSource.Unknown: 0>, 'Tai': <TimeSource.Tai: 1>, 'Gps': <TimeSource.Gps: 2>, 'Utc': <TimeSource.Utc: 3>}
    def __eq__(self, other: typing.Any) -> bool:
        ...
    def __getstate__(self) -> int:
        ...
    def __hash__(self) -> int:
        ...
    def __index__(self) -> int:
        ...
    def __init__(self, value: int) -> None:
        ...
    def __int__(self) -> int:
        ...
    def __ne__(self, other: typing.Any) -> bool:
        ...
    def __repr__(self) -> str:
        ...
    def __setstate__(self, state: int) -> None:
        ...
    def __str__(self) -> str:
        ...
    @property
    def name(self) -> str:
        ...
    @property
    def value(self) -> int:
        ...
class TimeStreamReader:
    """
    A wrapper for stream signal data reader that provides the ability to read samples with timestamps.
    """
    def __init__(self, arg0: IStreamReader) -> None:
        ...
    def read_with_timestamps(self, count: int, timeout_ms: int = 0, return_status: bool = False) -> tuple[numpy.ndarray, numpy.ndarray] | tuple[numpy.ndarray, numpy.ndarray, IReaderStatus]:
        """
        Returns the next `count` unread samples and clock-stamps.
        """
class TimeTailReader:
    """
    A wrapper for tail signal data reader that provides the ability to read samples with timestamps.
    """
    def __init__(self, arg0: ITailReader) -> None:
        ...
    def read_with_timestamps(self, count: int, timeout_ms: int = 0, return_status: bool = False) -> tuple[numpy.ndarray, numpy.ndarray] | tuple[numpy.ndarray, numpy.ndarray, ITailReaderStatus]:
        """
        Returns the next `count` last unread samples and clock-stamps.
        """
class UsesOffset:
    """
    Members:
    
      Unknown
    
      True
    
      False
    """
    False: typing.ClassVar[UsesOffset]  # value = <UsesOffset.False: 2>
    True: typing.ClassVar[UsesOffset]  # value = <UsesOffset.True: 1>
    Unknown: typing.ClassVar[UsesOffset]  # value = <UsesOffset.Unknown: 0>
    __members__: typing.ClassVar[dict[str, UsesOffset]]  # value = {'Unknown': <UsesOffset.Unknown: 0>, 'True': <UsesOffset.True: 1>, 'False': <UsesOffset.False: 2>}
    def __eq__(self, other: typing.Any) -> bool:
        ...
    def __getstate__(self) -> int:
        ...
    def __hash__(self) -> int:
        ...
    def __index__(self) -> int:
        ...
    def __init__(self, value: int) -> None:
        ...
    def __int__(self) -> int:
        ...
    def __ne__(self, other: typing.Any) -> bool:
        ...
    def __repr__(self) -> str:
        ...
    def __setstate__(self, state: int) -> None:
        ...
    def __str__(self) -> str:
        ...
    @property
    def name(self) -> str:
        ...
    @property
    def value(self) -> int:
        ...
def AddressInfo() -> IAddressInfo:
    ...
def AddressInfoBuilder() -> IAddressInfoBuilder:
    ...
def AddressInfoFromBuilder(arg0: IAddressInfoBuilder) -> IAddressInfo:
    ...
def AndSearchFilter(arg0: ISearchFilter, arg1: ISearchFilter) -> ISearchFilter:
    ...
def AnySearchFilter() -> ISearchFilter:
    ...
def ArgumentInfo(name: IString | str | IEvalValue, type: CoreType) -> IArgumentInfo:
    ...
def AuthenticationProvider(arg0: int) -> IAuthenticationProvider:
    ...
def BaseObject() -> IBaseObject:
    ...
def BasicFileLoggerSink(file_name: IString | str | IEvalValue) -> ILoggerSink:
    ...
def BlockReader(signal: ISignal, block_size: int, value_type: SampleType = ..., domain_type: SampleType = ..., read_mode: ReadMode = ..., skip_events: int = 1) -> IBlockReader:
    """
    A signal data reader that abstracts away reading of signal packets by keeping an internal read-position and automatically advances it on subsequent reads. The difference to a StreamReader is that instead of reading on per sample basis it always returns only a full block of samples. This means that even if more samples are available they will not be read until there is enough of them to fill at least one block.
    """
def BlockReaderBuilder() -> IBlockReaderBuilder:
    ...
def BlockReaderFromExisting(arg0: IBlockReader, arg1: SampleType, arg2: SampleType, arg3: int) -> IBlockReader:
    ...
def BlockReaderStatus(event_packet: IEventPacket, valid: bool, offset: INumber | float | int | IEvalValue, read_samples: int) -> IBlockReaderStatus:
    ...
def BoolProperty(name: IString | str | IEvalValue, default_value: IBoolean | bool | IEvalValue, visible: IBoolean | bool | IEvalValue) -> IProperty:
    ...
def BoolPropertyBuilder(name: IString | str | IEvalValue, default_value: IBoolean | bool | IEvalValue) -> IPropertyBuilder:
    ...
def Boolean(value: bool) -> IBoolean:
    """
    Creates a new Boolean.
    """
def CallableInfo(argument_info: IList | list | IEvalValue, return_type: CoreType, const_flag: bool) -> ICallableInfo:
    ...
def Client(ctx: IContext, local_id: IString | str | IEvalValue, default_device_info: IDeviceInfo, parent: IComponent) -> IDevice:
    ...
def CmdLineArgsConfigProvider(cmd_line_args: IList | list | IEvalValue) -> IConfigProvider:
    ...
def Coercer(eval: IString | str | IEvalValue) -> ICoercer:
    ...
@typing.overload
def ComplexNumber(real: float, imaginary: float) -> IComplexNumber:
    """
    Creates a new ComplexNumber object.
    """
@typing.overload
def ComplexNumber(value: complex) -> IComplexNumber:
    """
    Creates a new ComplexNumber object.
    """
def Component(context: IContext, parent: IComponent, local_id: IString | str | IEvalValue, class_name: IString | str | IEvalValue) -> IComponent:
    ...
def ComponentStatusContainer() -> IComponentStatusContainer:
    ...
def ConnectedClientInfo() -> IConnectedClientInfo:
    ...
def ConnectedClientInfoWithParams(address: IString | str | IEvalValue, protocol_type: ProtocolType, protocol_name: IString | str | IEvalValue, client_type: IString | str | IEvalValue, host_name: IString | str | IEvalValue) -> IConnectedClientInfo:
    ...
def Connection(arg0: IInputPort, arg1: ISignal, arg2: IContext) -> IConnection:
    ...
def ConstantDataRule() -> IDataRule:
    ...
def Context(scheduler: IScheduler, logger: ILogger, type_manager: ITypeManager, module_manager: IModuleManager, authentication_provider: IAuthenticationProvider, options: IDict | dict, discovery_servers: IDict | dict) -> IContext:
    ...
def CoreEventArgs(event_id: ..., event_name: IString | str | IEvalValue, parameters: IDict | dict) -> ICoreEventArgs:
    ...
def CoreEventArgsPropertyAdded(prop_owner: IPropertyObject, prop: IProperty, path: IString | str | IEvalValue) -> ICoreEventArgs:
    ...
def CoreEventArgsPropertyObjectUpdateEnd(prop_owner: IPropertyObject, updated_properties: IDict | dict, path: IString | str | IEvalValue) -> ICoreEventArgs:
    ...
def CoreEventArgsPropertyRemoved(prop_owner: IPropertyObject, prop_name: IString | str | IEvalValue, path: IString | str | IEvalValue) -> ICoreEventArgs:
    ...
def CoreEventArgsPropertyValueChanged(prop_owner: IPropertyObject, prop_name: IString | str | IEvalValue, value: typing.Any, path: IString | str | IEvalValue) -> ICoreEventArgs:
    ...
def CoreEventArgsTypeAdded(arg0: IType) -> ICoreEventArgs:
    ...
def CoreEventArgsTypeRemoved(type_name: IString | str | IEvalValue) -> ICoreEventArgs:
    ...
def CustomSearchFilter(arg0: IFunction, arg1: IFunction) -> ISearchFilter:
    ...
def DataDescriptorBuilder() -> IDataDescriptorBuilder:
    ...
def DataDescriptorBuilderFromExisting(arg0: IDataDescriptor) -> IDataDescriptorBuilder:
    ...
def DataDescriptorChangedEventPacket(arg0: IDataDescriptor, arg1: IDataDescriptor) -> IEventPacket:
    ...
def DataDescriptorFromBuilder(arg0: IDataDescriptorBuilder) -> IDataDescriptor:
    ...
def DataPacket(descriptor: IDataDescriptor, sample_count: int, offset: INumber | float | int | IEvalValue) -> IDataPacket:
    ...
def DataPacketWithDomain(domain_packet: IDataPacket, descriptor: IDataDescriptor, sample_count: int, offset: INumber | float | int | IEvalValue) -> IDataPacket:
    ...
def DataRule(rule_type: DataRuleType, parameters: IDict | dict) -> IDataRule:
    ...
def DataRuleBuilder() -> IDataRuleBuilder:
    ...
def DataRuleBuilderFromExisting(arg0: IDataRule) -> IDataRuleBuilder:
    ...
def DataRuleFromBuilder(arg0: IDataRuleBuilder) -> IDataRule:
    ...
@typing.overload
def DeviceDomain(tick_resolution: IRatio | tuple[int, int], origin: IString | str | IEvalValue, unit: IUnit) -> IDeviceDomain:
    ...
@typing.overload
def DeviceDomain(tick_resolution: IRatio | tuple[int, int], origin: IString | str | IEvalValue, unit: IUnit, reference_domain_info: IReferenceDomainInfo) -> IDeviceDomain:
    ...
def DeviceInfoConfig(name: IString | str | IEvalValue, connection_string: IString | str | IEvalValue) -> IDeviceInfoConfig:
    ...
def DeviceInfoConfigWithCustomSdkVersion(name: IString | str | IEvalValue, connection_string: IString | str | IEvalValue, sdk_version: IString | str | IEvalValue) -> IDeviceInfoConfig:
    ...
def DeviceType(id: IString | str | IEvalValue, name: IString | str | IEvalValue, description: IString | str | IEvalValue, default_config: IPropertyObject, prefix: IString | str | IEvalValue) -> IDeviceType:
    ...
def Dict() -> IDict:
    ...
def DictProperty(name: IString | str | IEvalValue, default_value: IDict | dict, visible: IBoolean | bool | IEvalValue) -> IProperty:
    ...
def DictPropertyBuilder(name: IString | str | IEvalValue, default_value: IDict | dict) -> IPropertyBuilder:
    ...
def Dimension(rule: IDimensionRule, unit: IUnit, name: IString | str | IEvalValue) -> IDimension:
    ...
def DimensionBuilder() -> IDimensionBuilder:
    ...
def DimensionBuilderFromExisting(arg0: IDimension) -> IDimensionBuilder:
    ...
def DimensionFromBuilder(arg0: IDimensionBuilder) -> IDimension:
    ...
def DimensionRule(type: DimensionRuleType, parameters: IDict | dict) -> IDimensionRule:
    ...
def DimensionRuleBuilder() -> IDimensionRuleBuilder:
    ...
def DimensionRuleBuilderFromExisting(arg0: IDimensionRule) -> IDimensionRuleBuilder:
    ...
def DimensionRuleFromBuilder(arg0: IDimensionRuleBuilder) -> IDimensionRule:
    ...
def Enumeration(arg0: IString, arg1: IString, arg2: ITypeManager) -> IEnumeration:
    ...
def EnumerationProperty(name: IString | str | IEvalValue, default_value: IEnumeration, visible: IBoolean | bool | IEvalValue) -> IProperty:
    ...
def EnumerationPropertyBuilder(name: IString | str | IEvalValue, default_value: IEnumeration) -> IPropertyBuilder:
    ...
def EnumerationType(arg0: IString, arg1: IList, arg2: int) -> IEnumerationType:
    ...
def EnumerationTypeWithValues(arg0: IString, arg1: IDict) -> IEnumerationType:
    ...
def EnumerationWithType(arg0: IEnumerationType, arg1: IString) -> IEnumeration:
    ...
def EnvConfigProvider() -> IConfigProvider:
    ...
def EvalValue(eval: IString | str | IEvalValue) -> IEvalValue:
    ...
def EvalValueArgs(eval: IString | str | IEvalValue, args: IList | list | IEvalValue) -> IEvalValue:
    ...
def EvalValueFunc(eval: IString | str | IEvalValue, func: IFunction) -> IEvalValue:
    ...
def Event() -> IEvent:
    ...
def EventArgs(arg0: int, arg1: IString) -> IEventArgs:
    ...
def EventHandler(event_handler: typing.Callable[[IBaseObject, IEventArgs], None]) -> IEventHandler:
    ...
def EventPacket(id: IString | str | IEvalValue, params: IDict | dict) -> IEventPacket:
    ...
def ExcludedTagsSearchFilter(excluded_tags: IList | list | IEvalValue) -> ISearchFilter:
    ...
def ExplicitDataRule() -> IDataRule:
    ...
def ExplicitDomainDataRule(min_expected_delta: INumber | float | int | IEvalValue, max_expected_delta: INumber | float | int | IEvalValue) -> IDataRule:
    ...
def Float(arg0: float) -> IFloat:
    ...
def FloatProperty(name: IString | str | IEvalValue, default_value: IFloat | float | IEvalValue, visible: IBoolean | bool | IEvalValue) -> IProperty:
    ...
def FloatPropertyBuilder(name: IString | str | IEvalValue, default_value: IFloat | float | IEvalValue) -> IPropertyBuilder:
    ...
def Folder(context: IContext, parent: IComponent, local_id: IString | str | IEvalValue) -> IFolderConfig:
    ...
def FolderWithItemType(item_type: ..., context: IContext, parent: IComponent, local_id: IString | str | IEvalValue) -> IFolderConfig:
    ...
def Function(arg0: typing.Any) -> IFunction:
    ...
def FunctionBlockType(id: IString | str | IEvalValue, name: IString | str | IEvalValue, description: IString | str | IEvalValue, default_config: IPropertyObject) -> IFunctionBlockType:
    ...
def FunctionProperty(name: IString | str | IEvalValue, callable_info: ICallableInfo, visible: IBoolean | bool | IEvalValue) -> IProperty:
    ...
def FunctionPropertyBuilder(name: IString | str | IEvalValue, callable_info: ICallableInfo) -> IPropertyBuilder:
    ...
def ImplicitDomainGapDetectedEventPacket(diff: INumber | float | int | IEvalValue) -> IEventPacket:
    ...
def InputPort(context: IContext, parent: IComponent, local_id: IString | str | IEvalValue, gap_checking: bool) -> IInputPortConfig:
    ...
@typing.overload
def Instance(context: IContext, local_id: IString | str | IEvalValue) -> IInstance:
    ...
@typing.overload
def Instance() -> IInstance:
    ...
def InstanceBuilder() -> IInstanceBuilder:
    ...
def InstanceFromBuilder(arg0: IInstanceBuilder) -> IInstance:
    ...
def IntProperty(name: IString | str | IEvalValue, default_value: IInteger | int | IEvalValue, visible: IBoolean | bool | IEvalValue) -> IProperty:
    ...
def IntPropertyBuilder(name: IString | str | IEvalValue, default_value: IInteger | int | IEvalValue) -> IPropertyBuilder:
    ...
def Integer(arg0: int) -> IInteger:
    ...
def InterfaceIdSearchFilter(arg0: ...) -> ISearchFilter:
    ...
def IoFolder(context: IContext, parent: IComponent, local_id: IString | str | IEvalValue) -> IFolderConfig:
    ...
def JsonConfigProvider(filename: IString | str | IEvalValue) -> IConfigProvider:
    ...
def JsonFileAuthenticationProvider(filename: IString | str | IEvalValue) -> IAuthenticationProvider:
    ...
def JsonStringAuthenticationProvider(json_string: IString | str | IEvalValue) -> IAuthenticationProvider:
    ...
def LinearDataRule(delta: INumber | float | int | IEvalValue, start: INumber | float | int | IEvalValue) -> IDataRule:
    ...
def LinearDimensionRule(delta: INumber | float | int | IEvalValue, start: INumber | float | int | IEvalValue, size: int) -> IDimensionRule:
    ...
def LinearScaling(scale: INumber | float | int | IEvalValue, offset: INumber | float | int | IEvalValue, input_data_type: SampleType, output_data_type: ScaledSampleType) -> IScaling:
    ...
def List() -> IList:
    ...
def ListDimensionRule(list: IList | list | IEvalValue) -> IDimensionRule:
    ...
def ListProperty(name: IString | str | IEvalValue, default_value: IList | list | IEvalValue, visible: IBoolean | bool | IEvalValue) -> IProperty:
    ...
def ListPropertyBuilder(name: IString | str | IEvalValue, default_value: IList | list | IEvalValue) -> IPropertyBuilder:
    ...
def LocalIdSearchFilter(local_id: IString | str | IEvalValue) -> ISearchFilter:
    ...
def LogFileInfoBuilder() -> ILogFileInfoBuilder:
    ...
def LogFileInfoFromBuilder(arg0: ILogFileInfoBuilder) -> ILogFileInfo:
    ...
def LogarithmicDimensionRule(delta: INumber | float | int | IEvalValue, start: INumber | float | int | IEvalValue, base: INumber | float | int | IEvalValue, size: int) -> IDimensionRule:
    ...
def Logger(sinks: IList | list | IEvalValue, level: LogLevel) -> ILogger:
    ...
def LoggerComponent(name: IString | str | IEvalValue, sinks: IList | list | IEvalValue, thread_pool: ILoggerThreadPool, level: LogLevel) -> ILoggerComponent:
    ...
def LoggerThreadPool() -> ILoggerThreadPool:
    ...
def MdnsDiscoveryServer(arg0: ILogger) -> IDiscoveryServer:
    ...
def ModuleInfo(version_info: IVersionInfo, name: IString | str | IEvalValue, id: IString | str | IEvalValue) -> IModuleInfo:
    ...
def ModuleManager(path: IString | str | IEvalValue) -> IModuleManager:
    ...
def ModuleManagerMultiplePaths(paths: IList | list | IEvalValue) -> IModuleManager:
    ...
def MultiReader(signals: IList | list, value_type: SampleType = ..., domain_type: SampleType = ..., read_mode: ReadMode = ..., timeout_type: ReadTimeoutType = ...) -> IMultiReader:
    """
    Creates a MultiReader object that reads multiple signals at once.
    """
def MultiReaderBuilder() -> IMultiReaderBuilder:
    ...
def MultiReaderFromExisting(arg0: IMultiReader, arg1: SampleType, arg2: SampleType) -> IMultiReader:
    ...
def MultiReaderStatus(main_descriptor: IEventPacket, event_packets: IDict | dict, valid: bool, offset: INumber | float | int | IEvalValue) -> IMultiReaderStatus:
    ...
def NetworkInterface(arg0: IString, arg1: IString, arg2: IString, arg3: IBaseObject) -> INetworkInterface:
    ...
def NotSearchFilter(arg0: ISearchFilter) -> ISearchFilter:
    ...
def NullContext() -> IContext:
    ...
def ObjectProperty(name: IString | str | IEvalValue, default_value: IPropertyObject) -> IProperty:
    ...
def ObjectPropertyBuilder(name: IString | str | IEvalValue, default_value: IPropertyObject) -> IPropertyBuilder:
    ...
def OrSearchFilter(arg0: ISearchFilter, arg1: ISearchFilter) -> ISearchFilter:
    ...
def PacketReader(arg0: ISignal) -> IPacketReader:
    ...
def PacketReaderFromPort(arg0: IInputPortConfig) -> IPacketReader:
    ...
def PermissionManager(arg0: IPermissionManager) -> IPermissionManager:
    ...
def PermissionMaskBuilder() -> IPermissionMaskBuilder:
    ...
def PermissionMaskBuilderFromMask(arg0: int) -> IPermissionMaskBuilder:
    ...
def PermissionsBuilder() -> IPermissionsBuilder:
    ...
def Procedure(arg0: typing.Any) -> IProcedure:
    ...
def PropertyBuilder(name: IString | str | IEvalValue) -> IPropertyBuilder:
    ...
def PropertyObject() -> IPropertyObject:
    ...
def PropertyObjectClassBuilder(name: IString | str | IEvalValue) -> IPropertyObjectClassBuilder:
    ...
def PropertyObjectClassBuilderWithManager(manager: ITypeManager, name: IString | str | IEvalValue) -> IPropertyObjectClassBuilder:
    ...
def PropertyObjectClassFromBuilder(arg0: IPropertyObjectClassBuilder) -> IPropertyObjectClass:
    ...
def PropertyObjectWithClassAndManager(manager: ITypeManager, class_name: IString | str | IEvalValue) -> IPropertyObject:
    ...
def PropertyValueEventArgs(arg0: IProperty, arg1: IBaseObject, arg2: IBaseObject, arg3: PropertyEventType, arg4: int) -> IPropertyValueEventArgs:
    ...
def Range(low_value: INumber | float | int | IEvalValue, high_value: INumber | float | int | IEvalValue) -> IRange:
    ...
def Ratio(numerator: int, denominator: int) -> IRatio:
    """
    Creates a new Ratio object.
    """
def RatioProperty(name: IString | str | IEvalValue, default_value: IRatio | tuple[int, int], visible: IBoolean | bool | IEvalValue) -> IProperty:
    ...
def RatioPropertyBuilder(name: IString | str | IEvalValue, default_value: IRatio | tuple[int, int]) -> IPropertyBuilder:
    ...
def ReaderStatus(event_packet: IEventPacket, valid: bool, offset: INumber | float | int | IEvalValue) -> IReaderStatus:
    ...
def RecursiveSearchFilter(arg0: ISearchFilter) -> ISearchFilter:
    ...
def ReferenceDomainInfoBuilder() -> IReferenceDomainInfoBuilder:
    ...
def ReferenceDomainInfoBuilderFromExisting(arg0: IReferenceDomainInfo) -> IReferenceDomainInfoBuilder:
    ...
def ReferenceDomainInfoFromBuilder(arg0: IReferenceDomainInfoBuilder) -> IReferenceDomainInfo:
    ...
def ReferenceProperty(name: IString | str | IEvalValue, referenced_property_eval: IEvalValue) -> IProperty:
    ...
def ReferencePropertyBuilder(name: IString | str | IEvalValue, referenced_property_eval: IEvalValue) -> IPropertyBuilder:
    ...
def RequiredTagsSearchFilter(required_tags: IList | list | IEvalValue) -> ISearchFilter:
    ...
def RotatingFileLoggerSink(file_name: IString | str | IEvalValue, max_file_byte_size: int, max_files: int) -> ILoggerSink:
    ...
def Scaling(input_data_type: SampleType, output_data_type: ScaledSampleType, scaling_type: ScalingType, parameters: IDict | dict) -> IScaling:
    ...
def ScalingBuilder() -> IScalingBuilder:
    ...
def ScalingBuilderFromExisting(arg0: IScaling) -> IScalingBuilder:
    ...
def ScalingFromBuilder(arg0: IScalingBuilder) -> IScaling:
    ...
def Scheduler(arg0: ILogger, arg1: int) -> IScheduler:
    ...
def SelectionProperty(name: IString | str | IEvalValue, selection_values: IList | list | IEvalValue, default_value: IInteger | int | IEvalValue, visible: IBoolean | bool | IEvalValue) -> IProperty:
    ...
def SelectionPropertyBuilder(name: IString | str | IEvalValue, selection_values: IList | list | IEvalValue, default_value: IInteger | int | IEvalValue) -> IPropertyBuilder:
    ...
def ServerType(id: IString | str | IEvalValue, name: IString | str | IEvalValue, description: IString | str | IEvalValue, default_config: IPropertyObject) -> IServerType:
    ...
def Signal(context: IContext, parent: IComponent | None, local_id: IString | str | IEvalValue, class_name: IString | str | IEvalValue | None) -> ISignalConfig:
    ...
def SignalWithDescriptor(context: IContext, descriptor: IDataDescriptor, parent: IComponent | None, local_id: IString | str | IEvalValue, class_name: IString | str | IEvalValue | None) -> ISignalConfig:
    ...
def SimpleType(arg0: CoreType) -> ISimpleType:
    ...
def SparseSelectionProperty(name: IString | str | IEvalValue, selection_values: IDict | dict, default_value: IInteger | int | IEvalValue, visible: IBoolean | bool | IEvalValue) -> IProperty:
    ...
def SparseSelectionPropertyBuilder(name: IString | str | IEvalValue, selection_values: IDict | dict, default_value: IInteger | int | IEvalValue) -> IPropertyBuilder:
    ...
def StaticAuthenticationProvider(allow_anonymous: bool, user_list: IList | list | IEvalValue) -> IAuthenticationProvider:
    ...
def StdErrLoggerSink() -> ILoggerSink:
    ...
def StdOutLoggerSink() -> ILoggerSink:
    ...
def StreamReader(signal: ISignal, value_type: SampleType = ..., domain_type: SampleType = ..., read_mode: ReadMode = ..., timeout_type: ReadTimeoutType = ..., skip_events: int = 1) -> IStreamReader:
    """
    A signal data reader that abstracts away reading of signal packets by keeping an internal read-position and automatically advances it on subsequent reads.
    """
def StreamReaderBuilder() -> IStreamReaderBuilder:
    ...
def StreamReaderFromExisting(arg0: IStreamReader, arg1: SampleType, arg2: SampleType) -> IStreamReader:
    ...
def StreamingType(id: IString | str | IEvalValue, name: IString | str | IEvalValue, description: IString | str | IEvalValue, prefix: IString | str | IEvalValue, default_config: IPropertyObject) -> IStreamingType:
    ...
def String(arg0: str) -> IString:
    ...
def StringProperty(name: IString | str | IEvalValue, default_value: IString | str | IEvalValue, visible: IBoolean | bool | IEvalValue) -> IProperty:
    ...
def StringPropertyBuilder(name: IString | str | IEvalValue, default_value: IString | str | IEvalValue) -> IPropertyBuilder:
    ...
def Struct(arg0: IString, arg1: IDict, arg2: ITypeManager) -> IStruct:
    ...
def StructBuilder(arg0: IString, arg1: ITypeManager) -> IStructBuilder:
    ...
def StructBuilderFromStruct(arg0: IStruct) -> IStructBuilder:
    ...
def StructFromBuilder(arg0: IStructBuilder) -> IStruct:
    ...
def StructProperty(name: IString | str | IEvalValue, default_value: IStruct, visible: IBoolean | bool | IEvalValue) -> IProperty:
    ...
def StructPropertyBuilder(name: IString | str | IEvalValue, default_value: IStruct) -> IPropertyBuilder:
    ...
def StructType(arg0: IString, arg1: IList, arg2: IList, arg3: IList) -> IStructType:
    ...
def StructTypeNoDefaults(arg0: IString, arg1: IList, arg2: IList) -> IStructType:
    ...
def SubscriptionEventArgs(streaming_connection_string: IString | str | IEvalValue, type: SubscriptionEventType) -> ISubscriptionEventArgs:
    ...
def SyncComponent(context: IContext, parse_failed_exception: IComponent, local_id: IString | str | IEvalValue) -> ISyncComponent:
    ...
def Tags() -> ITags:
    ...
def TailReader(signal: ISignal, history_size: int, value_type: SampleType = ..., domain_type: SampleType = ..., read_mode: ReadMode = ..., skip_events: int = 1) -> ITailReader:
    """
    A reader that only ever reads the last N samples, subsequent calls may result in overlapping data.
    """
def TailReaderBuilder() -> ITailReaderBuilder:
    ...
def TailReaderFromExisting(arg0: ITailReader, arg1: int, arg2: SampleType, arg3: SampleType) -> ITailReader:
    ...
def TailReaderStatus(event_packet: IEventPacket, valid: bool, offset: INumber | float | int | IEvalValue, sufficient_history: bool) -> ITailReaderStatus:
    ...
def Task(work: IProcedure, name: IString | str | IEvalValue) -> ITask:
    ...
def TaskGraph(work: IProcedure, name: IString | str | IEvalValue) -> ITaskGraph:
    ...
def TypeManager() -> ITypeManager:
    ...
def Unit(id: int, symbol: IString | str | IEvalValue, name: IString | str | IEvalValue, quantity: IString | str | IEvalValue) -> IUnit:
    ...
def UnitBuilder() -> IUnitBuilder:
    ...
def UnitBuilderFromExisting(arg0: IUnit) -> IUnitBuilder:
    ...
def UpdateParameters() -> IUpdateParameters:
    ...
def User(username: IString | str | IEvalValue, password_hash: IString | str | IEvalValue, groups: IList | list | IEvalValue) -> IUser:
    ...
def Validator(eval: IString | str | IEvalValue) -> IValidator:
    ...
def VersionInfo(arg0: int, arg1: int, arg2: int) -> IVersionInfo:
    ...
def VisibleSearchFilter() -> ISearchFilter:
    ...
def clear_error_info() -> None:
    ...
def get_tracked_object_count() -> int:
    ...
def print_tracked_objects() -> None:
    ...
